/* mi.c     91/04/12   intermediate code interpreter                          */

#include "mini.h"

#define UnifyStruct(mp, ip)         if(*mp++ != LopRead(ip)){FailInstr(t_struct_fail) \
										goto fail;}ip+=LopSize
#define Min(a, b)                   (((a)<(b))?(a):(b))
#define LoadGoalVar(varptr)         varptr=(MWPTR)(goalframeptr + SopFetch(goalptr))
#define LoadOffsetGoalVar(o,varptr) varptr=(MWPTR)(goalframeptr + SopRead(goalptr+o))
#define LoadHeadVar(varptr)         varptr=(MWPTR)(headframeptr + SopFetch(headptr))
#define LoadTempVar(varptr)         varptr=(MWPTR)(((CHARPTR)temp) + SopFetch(headptr))
#define LoadGoalTempVar(varptr)     varptr=(MWPTR)(((CHARPTR)temp) + SopFetch(goalptr))
#define GoalVar(offset)             (*(((MWPTR)goalframeptr)-(3+offset)))
#define HeadVar(offset)             (*(((MWPTR)headframeptr)-(3+offset)))
#define TempVar(offset)             (*(((MWPTR)temp)+(offset)))
#define AssignInter(mptr, m)        {Trail(mptr); *mptr = (m); goto interpret;}
#define AssignVam1pUnify(mptr, m)   {Trail(mptr); *mptr = (m); goto vam1p_unify;}
#define AssignVam1pCopy(mptr, m)    {Trail(mptr); *mptr = (m); goto vam1p_copy;}
#define AssignBreak(mptr, m)        {Trail(mptr); *mptr = (m); break;}
#define Push(m)                     *(--stackptr) = (MW) (m)
#define Pop(type, m)                (m = type (*stackptr++))
#define IndexAddress(ip, o)         ip=((CODEPTR)(o))+LopSize
#define ClauseAddress(ip, o)        ip= *((CODEPTR*)(o))
#define AlternativeAddress(ip)      ip= *((CODEPTR*)(ip)-1)
#define PushChoicePoint(goalptr, headptr)  \
		stackptr -= 6;                     \
		*(stackptr+5) = (MW) (goalptr);    \
		*(stackptr+4) = (MW) goalframeptr; \
		*(stackptr+3) = (MW) (headptr);    \
		*(stackptr+2) = (MW) trail;        \
		*(stackptr+1) = (MW) copyptr;      \
		*stackptr     = (MW) choicepntptr; \
		choicepntptr = stackptr
#define PopChoicePoint                              \
		stackptr = choicepntptr + 6;                \
		goalptr      = (CODEPTR) *(choicepntptr+5); \
		goalframeptr = (CHARPTR) *(choicepntptr+4); \
		headptr      = (CODEPTR) *(choicepntptr+3); \
		trail        = (MWPTR*)  *(choicepntptr+2); \
		copyptr      = (MWPTR)   *(choicepntptr+1); \
		choicepntptr = (MWPTR)   *choicepntptr;
#define LocalStackCheck             if(stackptr<=heapptr) \
                                        return(ErrorNumber=StackOverflowError)

int mi_interpreter(register CODEPTR headptr)

{
register CODEPTR    goalptr;
register MWPTR      m1ptr;
register MW         m1;
register MW         i;
register CHARPTR    headframeptr;
register CHARPTR    goalframeptr;
register MWPTR      m2ptr;
register MW         m2;
register MWPTR      stackptr;
register MW         temp0;
         MWPTR      m3ptr;
         int        bipnr;
         int        nogoal_bip;
         MW         a[4];
         MW         ErrorAtomIndex;
         MWPTR      ErrorFunctor;
         MWPTR      berror;
         MW         berr;
         MW         m3;
         MW         temp[64];
         CODE       code[28];
         CODEPTR    goalptr2;
         CODEPTR    headptr2;
         MWPTR      blockptr;
         MW         ball;
         CODEPTR    blockoutptr;

nogoal_bip = FALSE;
blockptr = 0;
m1ptr = &berr;
(void) find_atom("error", &ErrorAtomIndex);
ErrorAtomIndex = XtrAtomIndex(ErrorAtomIndex);
ErrorFunctor = find_func(ErrorAtomIndex, (MW) 2);
CreateStruct(m1ptr, ErrorFunctor, 2);
berror = copyptr;

goalptr2 = code;

SopStore(goalptr2, 0);
SopStore(goalptr2, SIZEMW * 2);
LIncr(goalptr2);
Alternative(goalptr2) = 0;
goalptr = goalptr2;
InstrStore(goalptr2, c_builtin);
SopStore(goalptr2, bip_exit_fail);

SopStore(goalptr2, 0);
SopStore(goalptr2, SIZEMW * 2);
LIncr(goalptr2);
Alternative(goalptr2) = (MWPTR) goalptr;
goalptr = goalptr2;
InstrStore(goalptr2, c_call);
InstrStore(goalptr2, c_builtin);
SopStore(goalptr2, bip_exit_true);
SopStore(goalptr2, 0);

SopStore(goalptr2, 0);
SopStore(goalptr2, 0);
LIncr(goalptr2);
Alternative(goalptr2) = 0;
blockoutptr = goalptr2;
InstrStore(goalptr2, c_block_out);
SopStore(goalptr2, 0);

SopStore(goalptr2, 0);
SopStore(goalptr2, 0);
LIncr(goalptr2);
Alternative(goalptr2) = (MWPTR) blockoutptr;
blockoutptr = goalptr2;
InstrStore(goalptr2, c_call);
SopStore(goalptr2, 0);

stackptr = StackPtr;
goalframeptr = (CHARPTR) stackptr;
choicepntptr = stackptr - 6;
PushChoicePoint(goalptr, goalptr);

headframeptr = (CHARPTR) stackptr;
stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));
LocalStackCheck;
if ((Alternative(headptr)) != 0)
	{PushChoicePoint(goalptr, headptr);}


interpret:

switch (Combine(InstrFetch(headptr),InstrFetch(goalptr)))
	{
	case Combine(h_const, g_const):
		ArgIncr TraceInstr(h_const_g_const)
		LopFetch(m1, headptr);
		LopFetch(m2, goalptr);
		if (m1 == m2)
			goto interpret;
		FailInstr(h_const_g_const)
		goto fail;
	case Combine(h_const, g_nil):
		ArgIncr TraceInstr(h_const_g_nil)
		FailInstr(h_const_g_nil)
		goto fail;
	case Combine(h_const, g_list):
		ArgIncr TraceInstr(h_const_g_list)
		FailInstr(h_const_g_list)
		goto fail;
	case Combine(h_const, g_struct):
		ArgIncr TraceInstr(h_const_g_struct)
		FailInstr(h_const_g_struct)
		goto fail;
	case Combine(h_const, g_void):
		ArgIncr TraceInstr(h_const_g_void)
		LIncr(headptr);
		goto interpret;
	case Combine(h_const, g_fstvar):
		ArgIncr TraceInstr(h_const_g_fstvar)
		LoadGoalVar(m1ptr);
		LopFetch(m1, headptr);
		*m1ptr = m1;
		goto interpret;
	case Combine(h_const, g_nxtvar):
		ArgIncr TraceInstr(h_const_g_nxtvar)
		LoadGoalVar(m1ptr);
		LopFetch(m2, headptr);
		if (NotVal(m1 = *m1ptr))
			{
const_nxtvar_0:
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignInter(m1ptr, m2)
			}
const_nxtvar_1:
		if (m1 == m2)
			goto interpret;
		FailInstr(h_const_g_nxtvar)
		goto fail;
	case Combine(h_const, g_0fstvar):
		ArgIncr TraceInstr(h_const_g_fstvar)
		LopFetch(m1, headptr);
		GoalVar(0) = m1;
		goto interpret;
	case Combine(h_const, g_0nxtvar):
		ArgIncr TraceInstr(h_const_g_nxtvar)
		LopFetch(m2, headptr);
		if (Val(m1 = GoalVar(0)))
			goto const_nxtvar_1;
		goto const_nxtvar_0;
	case Combine(h_const, g_1fstvar):
		ArgIncr TraceInstr(h_const_g_fstvar)
		LopFetch(m1, headptr);
		GoalVar(1) = m1;
		goto interpret;
	case Combine(h_const, g_1nxtvar):
		ArgIncr TraceInstr(h_const_g_nxtvar)
		LopFetch(m2, headptr);
		if (Val(m1 = GoalVar(1)))
			goto const_nxtvar_1;
		goto const_nxtvar_0;
	case Combine(h_const, g_2fstvar):
		ArgIncr TraceInstr(h_const_g_fstvar)
		LopFetch(m1, headptr);
		GoalVar(2) = m1;
		goto interpret;
	case Combine(h_const, g_2nxtvar):
		ArgIncr TraceInstr(h_const_g_nxtvar)
		LopFetch(m2, headptr);
		if (Val(m1 = GoalVar(2)))
			goto const_nxtvar_1;
		goto const_nxtvar_0;
	case Combine(h_const, g_3fstvar):
		ArgIncr TraceInstr(h_const_g_fstvar)
		LopFetch(m1, headptr);
		GoalVar(3) = m1;
		goto interpret;
	case Combine(h_const, g_3nxtvar):
		ArgIncr TraceInstr(h_const_g_nxtvar)
		LopFetch(m2, headptr);
		if (Val(m1 = GoalVar(3)))
			goto const_nxtvar_1;
		goto const_nxtvar_0;
	case Combine(h_nil, g_const):
		ArgIncr TraceInstr(h_nil_g_const)
		FailInstr(h_nil_g_const)
		goto fail;
	case Combine(h_nil, g_nil):
		ArgIncr TraceInstr(h_nil_g_nil)
		goto interpret;
	case Combine(h_nil, g_list):
		ArgIncr TraceInstr(h_nil_g_list)
		FailInstr(h_nil_g_list)
		goto fail;
	case Combine(h_nil, g_struct):
		ArgIncr TraceInstr(h_nil_g_struct)
		FailInstr(h_nil_g_struct)
		goto fail;
	case Combine(h_nil, g_void):
		ArgIncr TraceInstr(h_nil_g_void)
		goto interpret;
	case Combine(h_nil, g_fstvar):
		ArgIncr TraceInstr(h_nil_g_fstvar)
		LoadGoalVar(m1ptr);
		*m1ptr = MakeNil;
		goto interpret;
	case Combine(h_nil, g_nxtvar):
		ArgIncr TraceInstr(h_nil_g_nxtvar)
		LoadGoalVar(m1ptr);
		if (NotVal(m1 = *m1ptr))
			{
nil_nxtvar_0:
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignInter(m1ptr, MakeNil)
			}
nil_nxtvar_1:
		if (Nil(m1))
			goto interpret;
		FailInstr(h_nil_g_nxtvar)
		goto fail;
	case Combine(h_nil, g_0fstvar):
		ArgIncr TraceInstr(h_nil_g_fstvar)
		GoalVar(0) = MakeNil;
		goto interpret;
	case Combine(h_nil, g_0nxtvar):
		ArgIncr TraceInstr(h_nil_g_nxtvar)
		if (Val(m1 = GoalVar(0)))
			goto nil_nxtvar_1;
		goto nil_nxtvar_0;
	case Combine(h_nil, g_1fstvar):
		ArgIncr TraceInstr(h_nil_g_fstvar)
		GoalVar(1) = MakeNil;
		goto interpret;
	case Combine(h_nil, g_1nxtvar):
		ArgIncr TraceInstr(h_nil_g_nxtvar)
		if (Val(m1 = GoalVar(1)))
			goto nil_nxtvar_1;
		goto nil_nxtvar_0;
	case Combine(h_nil, g_2fstvar):
		ArgIncr TraceInstr(h_nil_g_fstvar)
		GoalVar(2) = MakeNil;
		goto interpret;
	case Combine(h_nil, g_2nxtvar):
		ArgIncr TraceInstr(h_nil_g_nxtvar)
		if (Val(m1 = GoalVar(2)))
			goto nil_nxtvar_1;
		goto nil_nxtvar_0;
	case Combine(h_nil, g_3fstvar):
		ArgIncr TraceInstr(h_nil_g_fstvar)
		GoalVar(3) = MakeNil;
		goto interpret;
	case Combine(h_nil, g_3nxtvar):
		ArgIncr TraceInstr(h_nil_g_nxtvar)
		if (Val(m1 = GoalVar(3)))
			goto nil_nxtvar_1;
		goto nil_nxtvar_0;
	case Combine(h_list, g_const):
		ArgIncr TraceInstr(h_list_g_const)
		FailInstr(h_list_g_const)
		goto fail;
	case Combine(h_list, g_nil):
		ArgIncr TraceInstr(h_list_g_nil)
		FailInstr(h_list_g_nil)
		goto fail;
	case Combine(h_list, g_list):
		ArgIncr TraceInstr(h_list_g_list)
		ArgFreeze(2)
		TraceAdd(t_g_skip_unify, 2)
		goto interpret;
	case Combine(h_list, g_struct):
		ArgIncr TraceInstr(h_list_g_struct)
		FailInstr(h_list_g_struct)
		goto fail;
	case Combine(h_list, g_void):
		ArgIncr TraceInstr(h_list_g_void)
		i = 2;
head_list_skip:
		while (--i >= 0)
			switch(HeadMux(InstrFetch(headptr)))
				{
				case HeadMux(h_const):
					LIncr(headptr);
				case HeadMux(h_nil):
					break;
				case HeadMux(h_list):
					i += 2;
					break;
				case HeadMux(h_struct):
					i += ArityFetch(headptr);
					FirstArgIncr(headptr);
				case HeadMux(h_void):
					break;
				case HeadMux(h_fstvar):
					LoadHeadVar(m1ptr);
					MakeCopyUndef;
					*m1ptr = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case HeadMux(h_nxtvar):
				case HeadMux(h_nxttemp):
					SIncr(headptr);
				case HeadMux(h_nxttmp0):
					break;
				case HeadMux(h_fsttemp):
					LoadTempVar(m1ptr);
					MakeCopyUndef;
					*m1ptr = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case HeadMux(h_fsttmp0):
					MakeCopyUndef;
					temp0 = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				default:
					fprintf(stderr, "HeadListSkipError\n");
					return(ErrorNumber = SystemError);
				}
		goto interpret;
	case Combine(h_list, g_fstvar):
		ArgIncr TraceInstr(h_list_g_fstvar)
		LoadGoalVar(m1ptr);
list_fstvar:
		CreateList(m1ptr);
		i = 2;
		Push(0);
		goto head_copy;
	case Combine(h_list, g_nxtvar):
		ArgIncr TraceInstr(h_list_g_nxtvar)
		LoadGoalVar(m1ptr);
		if (NotVal(m1 = *m1ptr))
			{
list_nxtvar_0:
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				goto list_fstvar;
				}
			}
list_nxtvar_1:
		if (List(m1))
			{
list_nxtvar_2:
			m1ptr = XtrList(m1);
			TraceInstr(t_xtrlist)
			i = -2;
			Push(0);
			goto head_unify;
			}
		FailInstr(h_list_g_nxtvar)
		goto fail;
	case Combine(h_list, g_0fstvar):
		ArgIncr TraceInstr(h_list_g_fstvar)
		m1ptr = &GoalVar(0);
		goto list_fstvar;
	case Combine(h_list, g_0nxtvar):
		ArgIncr TraceInstr(h_list_g_nxtvar)
		if (Val(m1 = GoalVar(0)))
			goto list_nxtvar_1;
		goto list_nxtvar_0;
	case Combine(h_list, g_1fstvar):
		ArgIncr TraceInstr(h_list_g_fstvar)
		m1ptr = &GoalVar(1);
		goto list_fstvar;
	case Combine(h_list, g_1nxtvar):
		ArgIncr TraceInstr(h_list_g_nxtvar)
		if (Val(m1 = GoalVar(1)))
			goto list_nxtvar_1;
		goto list_nxtvar_0;
	case Combine(h_list, g_2fstvar):
		ArgIncr TraceInstr(h_list_g_fstvar)
		m1ptr = &GoalVar(2);
		goto list_fstvar;
	case Combine(h_list, g_2nxtvar):
		ArgIncr TraceInstr(h_list_g_nxtvar)
		if (Val(m1 = GoalVar(2)))
			goto list_nxtvar_1;
		goto list_nxtvar_0;
	case Combine(h_list, g_3fstvar):
		ArgIncr TraceInstr(h_list_g_fstvar)
		m1ptr = &GoalVar(3);
		goto list_fstvar;
	case Combine(h_list, g_3nxtvar):
		ArgIncr TraceInstr(h_list_g_nxtvar)
		if (Val(m1 = GoalVar(3)))
			goto list_nxtvar_1;
		goto list_nxtvar_0;
	case Combine(h_struct, g_const):
		ArgIncr TraceInstr(h_struct_g_const)
		FailInstr(h_struct_g_const)
		goto fail;
	case Combine(h_struct, g_nil):
		ArgIncr TraceInstr(h_struct_g_nil)
		FailInstr(h_struct_g_nil)
		goto fail;
	case Combine(h_struct, g_list):
		ArgIncr TraceInstr(h_struct_g_list)
		FailInstr(h_struct_g_list)
		goto fail;
	case Combine(h_struct, g_struct):
		ArgIncr TraceInstr(h_struct_g_struct)
		ArgFreeze(ArityFetch(headptr))
		TraceAdd(t_g_skip_unify, ArityFetch(headptr) + 1)
		CodeStructUnify(headptr, goalptr);
		goto interpret;
	case Combine(h_struct, g_void):
		ArgIncr TraceInstr(h_struct_g_void)
		i = ArityFetch(headptr);
		FirstArgIncr(headptr);
		goto head_list_skip;
	case Combine(h_struct, g_fstvar):
		ArgIncr TraceInstr(h_struct_g_fstvar)
		LoadGoalVar(m1ptr);
struct_fstvar:
		FetchStruct(m1ptr, headptr, i = ArityFetch(headptr));
		Push(0);
		goto head_copy;
	case Combine(h_struct, g_nxtvar):
		ArgIncr TraceInstr(h_struct_g_nxtvar)
		LoadGoalVar(m1ptr);
		if (NotVal(m1 = *m1ptr))
			{
struct_nxtvar_0:
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				goto struct_fstvar;
				}
			}
struct_nxtvar_1:
		if (Struct(m1))
			{
struct_nxtvar_2:
			m1ptr = XtrStruct(m1);
			i = -ArityFetch(headptr);
			UnifyStruct(m1ptr, headptr);
			Push(0);
			goto head_unify;
			}
		FailInstr(h_struct_g_nxtvar)
		goto fail;
	case Combine(h_struct, g_0fstvar):
		ArgIncr TraceInstr(h_struct_g_fstvar)
		m1ptr = &GoalVar(0);
		goto struct_fstvar;
	case Combine(h_struct, g_0nxtvar):
		ArgIncr TraceInstr(h_struct_g_nxtvar)
		if (Val(m1 = GoalVar(0)))
			goto struct_nxtvar_1;
		goto struct_nxtvar_0;
	case Combine(h_struct, g_1fstvar):
		ArgIncr TraceInstr(h_struct_g_fstvar)
		m1ptr = &GoalVar(1);
		goto struct_fstvar;
	case Combine(h_struct, g_1nxtvar):
		ArgIncr TraceInstr(h_struct_g_nxtvar)
		if (Val(m1 = GoalVar(1)))
			goto struct_nxtvar_1;
		goto struct_nxtvar_0;
	case Combine(h_struct, g_2fstvar):
		ArgIncr TraceInstr(h_struct_g_fstvar)
		m1ptr = &GoalVar(2);
		goto struct_fstvar;
	case Combine(h_struct, g_2nxtvar):
		ArgIncr TraceInstr(h_struct_g_nxtvar)
		if (Val(m1 = GoalVar(2)))
			goto struct_nxtvar_1;
		goto struct_nxtvar_0;
	case Combine(h_struct, g_3fstvar):
		ArgIncr TraceInstr(h_struct_g_fstvar)
		m1ptr = &GoalVar(3);
		goto struct_fstvar;
	case Combine(h_struct, g_3nxtvar):
		ArgIncr TraceInstr(h_struct_g_nxtvar)
		if (Val(m1 = GoalVar(3)))
			goto struct_nxtvar_1;
		goto struct_nxtvar_0;
	case Combine(h_void, g_const):
		ArgIncr TraceInstr(h_void_g_const)
		LIncr(goalptr);
		goto interpret;
	case Combine(h_void, g_nil):
		ArgIncr TraceInstr(h_void_g_nil)
		goto interpret;
	case Combine(h_void, g_list):
		ArgIncr TraceInstr(h_void_g_list)
		i = 2;
		TraceAdd(t_g_skip_unify, 2)
goal_list_skip:
		while (--i >= 0)
			switch(GoalMux(InstrFetch(goalptr)))
				{
				case GoalMux(g_const):
					LIncr(goalptr);
				case GoalMux(g_nil):
					break;
				case GoalMux(g_list):
					i += 2;
					TraceAdd(t_g_skip_unify, 2)
					break;
				case GoalMux(g_struct):
					TraceAdd(t_g_skip_unify, ArityFetch(goalptr) + 1)
					i += ArityFetch(goalptr);
					FirstArgIncr(goalptr);
				case GoalMux(g_void):
					break;
				case GoalMux(g_fstvar):
					LoadGoalVar(m1ptr);
					MakeCopyUndef;
					*m1ptr = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case GoalMux(g_nxtvar):
					SIncr(goalptr);
					break;
				case GoalMux(g_0fstvar):
					MakeCopyUndef;
					GoalVar(0) = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case GoalMux(g_1fstvar):
					MakeCopyUndef;
					GoalVar(1) = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case GoalMux(g_2fstvar):
					MakeCopyUndef;
					GoalVar(2) = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case GoalMux(g_3fstvar):
					MakeCopyUndef;
					GoalVar(3) = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case GoalMux(g_0nxtvar):
				case GoalMux(g_1nxtvar):
				case GoalMux(g_2nxtvar):
				case GoalMux(g_3nxtvar):
					break;
				default:
					fprintf(stderr, "GoalListSkipError\n");
					return(ErrorNumber = SystemError);
				}
		goto interpret;
	case Combine(h_void, g_struct):
		ArgIncr TraceInstr(h_void_g_struct)
		i = ArityFetch(goalptr);
		TraceAdd(t_g_skip_unify, i + 1)
		FirstArgIncr(goalptr);
		goto goal_list_skip;
	case Combine(h_void, g_void):
		ArgIncr TraceInstr(h_void_g_void)
		goto interpret;
	case Combine(h_void, g_fstvar):
		ArgIncr TraceInstr(h_void_g_fstvar)
		LoadGoalVar(m1ptr);
		MakeCopyUndef;
		*m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_void, g_nxtvar):
		ArgIncr TraceInstr(h_void_g_nxtvar)
		SIncr(goalptr);
		goto interpret;
	case Combine(h_void, g_0fstvar):
		ArgIncr TraceInstr(h_void_g_fstvar)
		MakeCopyUndef;
		GoalVar(0) = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_void, g_1fstvar):
		ArgIncr TraceInstr(h_void_g_fstvar)
		MakeCopyUndef;
		GoalVar(1) = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_void, g_2fstvar):
		ArgIncr TraceInstr(h_void_g_fstvar)
		MakeCopyUndef;
		GoalVar(2) = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_void, g_3fstvar):
		ArgIncr TraceInstr(h_void_g_fstvar)
		MakeCopyUndef;
		GoalVar(3) = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_void, g_0nxtvar):
	case Combine(h_void, g_1nxtvar):
	case Combine(h_void, g_2nxtvar):
	case Combine(h_void, g_3nxtvar):
		ArgIncr TraceInstr(h_void_g_nxtvar)
		goto interpret;
	case Combine(h_fstvar, g_const):
		ArgIncr TraceInstr(h_fstvar_g_const)
		LoadHeadVar(m1ptr);
fstvar_const:
		LopFetch(m1, goalptr);
		*m1ptr = m1;
		goto interpret;
	case Combine(h_fstvar, g_nil):
		ArgIncr TraceInstr(h_fstvar_g_nil)
		LoadHeadVar(m1ptr);
fstvar_nil:
		*m1ptr = MakeNil;
		goto interpret;
	case Combine(h_fstvar, g_list):
		ArgIncr TraceInstr(h_fstvar_g_list)
		LoadHeadVar(m1ptr);
fstvar_list:
		CreateList(m1ptr);
		i = 2;
		Push(0);
		goto goal_copy;
	case Combine(h_fstvar, g_struct):
		ArgIncr TraceInstr(h_fstvar_g_struct)
		LoadHeadVar(m1ptr);
fstvar_struct:
		FetchStruct(m1ptr, goalptr, i = ArityFetch(goalptr));
		Push(0);
		goto goal_copy;
	case Combine(h_fstvar, g_void):
		ArgIncr TraceInstr(h_fstvar_g_void)
		LoadHeadVar(m1ptr);
fstvar_void:
		MakeCopyUndef;
		*m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fstvar, g_fstvar):
		ArgIncr TraceInstr(h_fstvar_g_fstvar)
		LoadHeadVar(m1ptr);
fstvar_fstvar:
		LoadGoalVar(m2ptr);
		MakeCopyUndef;
		*m2ptr = *m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fstvar, g_nxtvar):
		ArgIncr TraceInstr(h_fstvar_g_nxtvar)
		LoadHeadVar(m1ptr);
fstvar_nxtvar:
		LoadGoalVar(m2ptr);
		*m1ptr = *m2ptr;
		ReduceDeref(*m2ptr, m1)
		goto interpret;
	case Combine(h_fstvar, g_0fstvar):
		ArgIncr TraceInstr(h_fstvar_g_fstvar)
		LoadHeadVar(m1ptr);
		MakeCopyUndef;
		GoalVar(0) = *m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fstvar, g_0nxtvar):
		ArgIncr TraceInstr(h_fstvar_g_nxtvar)
		LoadHeadVar(m1ptr);
		*m1ptr = GoalVar(0);
		ReduceDeref(GoalVar(0), m1)
		goto interpret;
	case Combine(h_fstvar, g_1fstvar):
		ArgIncr TraceInstr(h_fstvar_g_fstvar)
		LoadHeadVar(m1ptr);
		MakeCopyUndef;
		GoalVar(1) = *m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fstvar, g_1nxtvar):
		ArgIncr TraceInstr(h_fstvar_g_nxtvar)
		LoadHeadVar(m1ptr);
		*m1ptr = GoalVar(1);
		ReduceDeref(GoalVar(1), m1)
		goto interpret;
	case Combine(h_fstvar, g_2fstvar):
		ArgIncr TraceInstr(h_fstvar_g_fstvar)
		LoadHeadVar(m1ptr);
		MakeCopyUndef;
		GoalVar(2) = *m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fstvar, g_2nxtvar):
		ArgIncr TraceInstr(h_fstvar_g_nxtvar)
		LoadHeadVar(m1ptr);
		*m1ptr = GoalVar(2);
		ReduceDeref(GoalVar(2), m1)
		goto interpret;
	case Combine(h_fstvar, g_3fstvar):
		ArgIncr TraceInstr(h_fstvar_g_fstvar)
		LoadHeadVar(m1ptr);
		MakeCopyUndef;
		GoalVar(3) = *m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fstvar, g_3nxtvar):
		ArgIncr TraceInstr(h_fstvar_g_nxtvar)
		LoadHeadVar(m1ptr);
		*m1ptr = GoalVar(3);
		ReduceDeref(GoalVar(3), m1)
		goto interpret;
	case Combine(h_nxtvar, g_const):
		ArgIncr TraceInstr(h_nxtvar_g_const)
		LoadHeadVar(m1ptr);
nxtvar_const:
		LopFetch(m2, goalptr);
		m1 = *m1ptr;
nxtvar_const_tmp0:
		if (NotVal(m1))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignInter(m1ptr, m2)
			}
		if (m1 == m2)
			goto interpret;
		FailInstr(h_nxtvar_g_const)
		goto fail;
	case Combine(h_nxtvar, g_nil):
		ArgIncr TraceInstr(h_nxtvar_g_nil)
		LoadHeadVar(m1ptr);
nxtvar_nil:
		m1 = *m1ptr;
nxtvar_nil_tmp0:
		if (NotVal(m1))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignInter(m1ptr, MakeNil)
			}
		if (Nil(m1))
			goto interpret;
		FailInstr(h_nxtvar_g_nil)
		goto fail;
	case Combine(h_nxtvar, g_list):
		ArgIncr TraceInstr(h_nxtvar_g_list)
		LoadHeadVar(m1ptr);
nxtvar_list:
		m1 = *m1ptr;
nxtvar_list_tmp0:
		if (NotVal(m1))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				goto fstvar_list;
				}
			}
		if (List(m1))
			{
			m1ptr = XtrList(m1);
			TraceInstr(t_xtrlist)
			i = -2;
			TraceAdd(t_g_skip_unify, 2)
			Push(0);
			goto goal_unify;
			}
		FailInstr(h_nxtvar_g_list)
		goto fail;
	case Combine(h_nxtvar, g_struct):
		ArgIncr TraceInstr(h_nxtvar_g_struct)
		LoadHeadVar(m1ptr);
nxtvar_struct:
		m1 = *m1ptr;
nxtvar_struct_tmp0:
		if (NotVal(m1))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				goto fstvar_struct;
				}
			}
		if (Struct(m1))
			{
			m1ptr = XtrStruct(m1);
			i = -ArityFetch(goalptr);
			TraceAdd(t_g_skip_unify, 1 - i)
			UnifyStruct(m1ptr, goalptr);
			Push(0);
			goto goal_unify;
			}
		FailInstr(h_nxtvar_g_struct)
		goto fail;
	case Combine(h_nxtvar, g_void):
		ArgIncr TraceInstr(h_nxtvar_g_void)
		SIncr(headptr);
		goto interpret;
	case Combine(h_nxtvar, g_fstvar):
		ArgIncr TraceInstr(h_nxtvar_g_fstvar)
		LoadHeadVar(m1ptr);
nxtvar_fstvar:
		LoadGoalVar(m2ptr);
		*m2ptr = *m1ptr;
		goto interpret;
	case Combine(h_nxtvar, g_nxtvar):
		ArgIncr TraceInstr(h_nxtvar_g_nxtvar)
		LoadHeadVar(m1ptr);
nxtvar_nxtvar:
		LoadGoalVar(m2ptr);
nxtvar_nxtvar_0:
		m1 = *m1ptr;
nxtvar_nxtvar_tmp0:
		if (NotVal(m1))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
nxtvar_nxtvar_1:
				if (NotVal(m2 = *m2ptr))
					{
					Deref(m2, m2ptr);
					if (RefUndef(m2))
						if (Pointsto(m1ptr, m2ptr))
							{ 
							TraceInstr(t_makeref)
							AssignInter(m1ptr, MakeRef(m2ptr))
							}
						else if (Pointsto(m2ptr, m1ptr))
							{
							TraceInstr(t_makeref)
							AssignInter(m2ptr, MakeRef(m1ptr))
							}
						else
							goto interpret;
					}
				AssignInter(m1ptr, m2)
				}
			}
		if (NotVal(m2 = *m2ptr))
			{
			Deref(m2, m2ptr);
			if (RefUndef(m2))
				AssignInter(m2ptr, m1)
			}
		if (m1 == m2)
			goto interpret;
		if (ListOrStruct(m1) &&	struct_unify(m1, m2))
			goto interpret;
		FailInstr(h_nxtvar_g_nxtvar)
		goto fail;
	case Combine(h_nxtvar, g_0fstvar):
		ArgIncr TraceInstr(h_nxtvar_g_fstvar)
		LoadHeadVar(m1ptr);
		GoalVar(0) = *m1ptr;
		goto interpret;
	case Combine(h_nxtvar, g_0nxtvar):
		ArgIncr TraceInstr(h_nxtvar_g_nxtvar)
		LoadHeadVar(m1ptr);
		m2ptr = &GoalVar(0);
		goto nxtvar_nxtvar_0;
	case Combine(h_nxtvar, g_1fstvar):
		ArgIncr TraceInstr(h_nxtvar_g_fstvar)
		LoadHeadVar(m1ptr);
		GoalVar(1) = *m1ptr;
		goto interpret;
	case Combine(h_nxtvar, g_1nxtvar):
		ArgIncr TraceInstr(h_nxtvar_g_nxtvar)
		LoadHeadVar(m1ptr);
		m2ptr = &GoalVar(1);
		goto nxtvar_nxtvar_0;
	case Combine(h_nxtvar, g_2fstvar):
		ArgIncr TraceInstr(h_nxtvar_g_fstvar)
		LoadHeadVar(m1ptr);
		GoalVar(2) = *m1ptr;
		goto interpret;
	case Combine(h_nxtvar, g_2nxtvar):
		ArgIncr TraceInstr(h_nxtvar_g_nxtvar)
		LoadHeadVar(m1ptr);
		m2ptr = &GoalVar(2);
		goto nxtvar_nxtvar_0;
	case Combine(h_nxtvar, g_3fstvar):
		ArgIncr TraceInstr(h_nxtvar_g_fstvar)
		LoadHeadVar(m1ptr);
		GoalVar(3) = *m1ptr;
		goto interpret;
	case Combine(h_nxtvar, g_3nxtvar):
		ArgIncr TraceInstr(h_nxtvar_g_nxtvar)
		LoadHeadVar(m1ptr);
		m2ptr = &GoalVar(3);
		goto nxtvar_nxtvar_0;
	case Combine(h_fsttemp, g_const):
		ArgIncr TraceInstr(h_fsttmp_g_const)
		LoadTempVar(m1ptr);
		goto fstvar_const;
	case Combine(h_fsttemp, g_nil):
		ArgIncr TraceInstr(h_fsttmp_g_nil)
		LoadTempVar(m1ptr);
		*m1ptr = MakeNil;
		goto interpret;
	case Combine(h_fsttemp, g_list):
		ArgIncr TraceInstr(h_fsttmp_g_list)
		LoadTempVar(m1ptr);
		goto fstvar_list;
	case Combine(h_fsttemp, g_struct):
		ArgIncr TraceInstr(h_fsttmp_g_struct)
		LoadTempVar(m1ptr);
		goto fstvar_struct;
	case Combine(h_fsttemp, g_void):
		ArgIncr TraceInstr(h_fsttmp_g_void)
		LoadTempVar(m1ptr);
		MakeCopyUndef;
		*m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fsttemp, g_fstvar):
		ArgIncr TraceInstr(h_fsttmp_g_fstvar)
		LoadTempVar(m1ptr);
		goto fstvar_fstvar;
	case Combine(h_fsttemp, g_nxtvar):
		ArgIncr TraceInstr(h_fsttmp_g_nxtvar)
		LoadTempVar(m1ptr);
		goto fstvar_nxtvar;
	case Combine(h_fsttemp, g_0fstvar):
		ArgIncr TraceInstr(h_fsttmp_g_fstvar)
		LoadTempVar(m1ptr);
		MakeCopyUndef;
		GoalVar(0) = *m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fsttemp, g_0nxtvar):
		ArgIncr TraceInstr(h_fsttmp_g_nxtvar)
		LoadTempVar(m1ptr);
		*m1ptr = GoalVar(0);
		ReduceDeref(GoalVar(0), m1)
		goto interpret;
	case Combine(h_fsttemp, g_1fstvar):
		ArgIncr TraceInstr(h_fsttmp_g_fstvar)
		LoadTempVar(m1ptr);
		MakeCopyUndef;
		GoalVar(1) = *m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fsttemp, g_1nxtvar):
		ArgIncr TraceInstr(h_fsttmp_g_nxtvar)
		LoadTempVar(m1ptr);
		*m1ptr = GoalVar(1);
		ReduceDeref(GoalVar(1), m1)
		goto interpret;
	case Combine(h_fsttemp, g_2fstvar):
		ArgIncr TraceInstr(h_fsttmp_g_fstvar)
		LoadTempVar(m1ptr);
		MakeCopyUndef;
		GoalVar(2) = *m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fsttemp, g_2nxtvar):
		ArgIncr TraceInstr(h_fsttmp_g_nxtvar)
		LoadTempVar(m1ptr);
		*m1ptr = GoalVar(2);
		ReduceDeref(GoalVar(2), m1)
		goto interpret;
	case Combine(h_fsttemp, g_3fstvar):
		ArgIncr TraceInstr(h_fsttmp_g_fstvar)
		LoadTempVar(m1ptr);
		MakeCopyUndef;
		GoalVar(3) = *m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fsttemp, g_3nxtvar):
		ArgIncr TraceInstr(h_fsttmp_g_nxtvar)
		LoadTempVar(m1ptr);
		*m1ptr = GoalVar(3);
		ReduceDeref(GoalVar(3), m1)
		goto interpret;
	case Combine(h_nxttemp, g_const):
		ArgIncr TraceInstr(h_nxttmp_g_const)
		LoadTempVar(m1ptr);
		goto nxtvar_const;
	case Combine(h_nxttemp, g_nil):
		ArgIncr TraceInstr(h_nxttmp_g_nil)
		LoadTempVar(m1ptr);
		goto nxtvar_nil;
	case Combine(h_nxttemp, g_list):
		ArgIncr TraceInstr(h_nxttmp_g_list)
		LoadTempVar(m1ptr);
		goto nxtvar_list;
	case Combine(h_nxttemp, g_struct):
		ArgIncr TraceInstr(h_nxttmp_g_struct)
		LoadTempVar(m1ptr);
		goto nxtvar_struct;
	case Combine(h_nxttemp, g_void):
		ArgIncr TraceInstr(h_nxttmp_g_void)
		SIncr(headptr);
		goto interpret;
	case Combine(h_nxttemp, g_fstvar):
		ArgIncr TraceInstr(h_nxttmp_g_fstvar)
		LoadTempVar(m1ptr);
		LoadGoalVar(m2ptr);
		*m2ptr = *m1ptr;
		goto interpret;
	case Combine(h_nxttemp, g_nxtvar):
		ArgIncr TraceInstr(h_nxttmp_g_nxtvar)
		LoadTempVar(m1ptr);
		goto nxtvar_nxtvar;
	case Combine(h_nxttemp, g_0fstvar):
		ArgIncr TraceInstr(h_nxttmp_g_fstvar)
		LoadTempVar(m1ptr);
		GoalVar(0) = *m1ptr;
		goto interpret;
	case Combine(h_nxttemp, g_0nxtvar):
		ArgIncr TraceInstr(h_nxttmp_g_nxtvar)
		LoadTempVar(m1ptr);
		m2ptr = &GoalVar(0);
		goto nxtvar_nxtvar_0;
	case Combine(h_nxttemp, g_1fstvar):
		ArgIncr TraceInstr(h_nxttmp_g_fstvar)
		LoadTempVar(m1ptr);
		GoalVar(1) = *m1ptr;
		goto interpret;
	case Combine(h_nxttemp, g_1nxtvar):
		ArgIncr TraceInstr(h_nxttmp_g_nxtvar)
		LoadTempVar(m1ptr);
		m2ptr = &GoalVar(1);
		goto nxtvar_nxtvar_0;
	case Combine(h_nxttemp, g_2fstvar):
		ArgIncr TraceInstr(h_nxttmp_g_fstvar)
		LoadTempVar(m1ptr);
		GoalVar(2) = *m1ptr;
		goto interpret;
	case Combine(h_nxttemp, g_2nxtvar):
		ArgIncr TraceInstr(h_nxttmp_g_nxtvar)
		LoadTempVar(m1ptr);
		m2ptr = &GoalVar(2);
		goto nxtvar_nxtvar_0;
	case Combine(h_nxttemp, g_3fstvar):
		ArgIncr TraceInstr(h_nxttmp_g_fstvar)
		LoadTempVar(m1ptr);
		GoalVar(3) = *m1ptr;
		goto interpret;
	case Combine(h_nxttemp, g_3nxtvar):
		ArgIncr TraceInstr(h_nxttmp_g_nxtvar)
		LoadTempVar(m1ptr);
		m2ptr = &GoalVar(3);
		goto nxtvar_nxtvar_0;
	case Combine(h_fsttmp0, g_const):
		ArgIncr TraceInstr(h_fsttmp_g_const)
		LopFetch(m1, goalptr);
		temp0 = m1;
		goto interpret;
	case Combine(h_fsttmp0, g_nil):
		ArgIncr TraceInstr(h_fsttmp_g_nil)
		temp0 = MakeNil;
		goto interpret;
	case Combine(h_fsttmp0, g_list):
		ArgIncr TraceInstr(h_fsttmp_g_list)
		CreateList2(temp0, m1ptr);
		i = 2;
		Push(0);
		goto goal_copy;
	case Combine(h_fsttmp0, g_struct):
		ArgIncr TraceInstr(h_fsttmp_g_struct)
		FetchStruct4(temp0, m1ptr, goalptr, i = ArityFetch(goalptr));
		Push(0);
		goto goal_copy;
	case Combine(h_fsttmp0, g_void):
		ArgIncr TraceInstr(h_fsttmp_g_void)
		MakeCopyUndef;
		temp0 = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fsttmp0, g_fstvar):
		ArgIncr TraceInstr(h_fsttmp_g_fstvar)
		LoadGoalVar(m1ptr);
		MakeCopyUndef;
		*m1ptr = temp0 = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fsttmp0, g_nxtvar):
		ArgIncr TraceInstr(h_fsttmp_g_nxtvar)
		LoadGoalVar(m1ptr);
		temp0 = *m1ptr;
		ReduceDeref(*m1ptr, m1)
		goto interpret;
	case Combine(h_fsttmp0, g_0fstvar):
		ArgIncr TraceInstr(h_fsttmp_g_fstvar)
		MakeCopyUndef;
		GoalVar(0) = temp0 = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fsttmp0, g_0nxtvar):
		ArgIncr TraceInstr(h_fsttmp_g_nxtvar)
		temp0 = GoalVar(0);
		ReduceDeref(GoalVar(0), m1)
		goto interpret;
	case Combine(h_fsttmp0, g_1fstvar):
		ArgIncr TraceInstr(h_fsttmp_g_fstvar)
		MakeCopyUndef;
		GoalVar(1) = temp0 = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fsttmp0, g_1nxtvar):
		ArgIncr TraceInstr(h_fsttmp_g_nxtvar)
		temp0 = GoalVar(1);
		ReduceDeref(GoalVar(1), m1)
		goto interpret;
	case Combine(h_fsttmp0, g_2fstvar):
		ArgIncr TraceInstr(h_fsttmp_g_fstvar)
		MakeCopyUndef;
		GoalVar(2) = temp0 = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fsttmp0, g_2nxtvar):
		ArgIncr TraceInstr(h_fsttmp_g_nxtvar)
		temp0 = GoalVar(2);
		ReduceDeref(GoalVar(2), m1)
		goto interpret;
	case Combine(h_fsttmp0, g_3fstvar):
		ArgIncr TraceInstr(h_fsttmp_g_fstvar)
		MakeCopyUndef;
		GoalVar(3) = temp0 = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto interpret;
	case Combine(h_fsttmp0, g_3nxtvar):
		ArgIncr TraceInstr(h_fsttmp_g_nxtvar)
		temp0 = GoalVar(3);
		ReduceDeref(GoalVar(3), m1)
		goto interpret;
	case Combine(h_nxttmp0, g_const):
		ArgIncr TraceInstr(h_nxttmp_g_const)
		LopFetch(m2, goalptr);
		m1 = temp0;
		goto nxtvar_const_tmp0;
	case Combine(h_nxttmp0, g_nil):
		ArgIncr TraceInstr(h_nxttmp_g_nil)
		m1 = temp0;
		goto nxtvar_nil_tmp0;
	case Combine(h_nxttmp0, g_list):
		ArgIncr TraceInstr(h_nxttmp_g_list)
		m1 = temp0;
		goto nxtvar_list_tmp0;
	case Combine(h_nxttmp0, g_struct):
		ArgIncr TraceInstr(h_nxttmp_g_struct)
		m1 = temp0;
		goto nxtvar_struct_tmp0;
	case Combine(h_nxttmp0, g_void):
		ArgIncr TraceInstr(h_nxttmp_g_void)
		goto interpret;
	case Combine(h_nxttmp0, g_fstvar):
		ArgIncr TraceInstr(h_nxttmp_g_fstvar)
		LoadGoalVar(m1ptr);
		*m1ptr = temp0;
		goto interpret;
	case Combine(h_nxttmp0, g_nxtvar):
		ArgIncr TraceInstr(h_nxttmp_g_nxtvar)
		m1 = temp0;
		LoadGoalVar(m2ptr);
		goto nxtvar_nxtvar_tmp0;
	case Combine(h_nxttmp0, g_0fstvar):
		ArgIncr TraceInstr(h_nxttmp_g_fstvar)
		GoalVar(0) = temp0;
		goto interpret;
	case Combine(h_nxttmp0, g_0nxtvar):
		ArgIncr TraceInstr(h_nxttmp_g_nxtvar)
		m1 = temp0;
		m2ptr = &GoalVar(0);
		goto nxtvar_nxtvar_tmp0;
	case Combine(h_nxttmp0, g_1fstvar):
		ArgIncr TraceInstr(h_nxttmp_g_fstvar)
		GoalVar(1) = temp0;
		goto interpret;
	case Combine(h_nxttmp0, g_1nxtvar):
		ArgIncr TraceInstr(h_nxttmp_g_nxtvar)
		m1 = temp0;
		m2ptr = &GoalVar(1);
		goto nxtvar_nxtvar_tmp0;
	case Combine(h_nxttmp0, g_2fstvar):
		ArgIncr TraceInstr(h_nxttmp_g_fstvar)
		GoalVar(2) = temp0;
		goto interpret;
	case Combine(h_nxttmp0, g_2nxtvar):
		ArgIncr TraceInstr(h_nxttmp_g_nxtvar)
		m1 = temp0;
		m2ptr = &GoalVar(2);
		goto nxtvar_nxtvar_tmp0;
	case Combine(h_nxttmp0, g_3fstvar):
		ArgIncr TraceInstr(h_nxttmp_g_fstvar)
		GoalVar(3) = temp0;
		goto interpret;
	case Combine(h_nxttmp0, g_3nxtvar):
		ArgIncr TraceInstr(h_nxttmp_g_nxtvar)
		m1 = temp0;
		m2ptr = &GoalVar(3);
		goto nxtvar_nxtvar_tmp0;
	case Combine(h_undefproc, g_const):
	case Combine(h_undefproc, g_nil):
	case Combine(h_undefproc, g_list):
	case Combine(h_undefproc, g_struct):
	case Combine(h_undefproc, g_void):
	case Combine(h_undefproc, g_fstvar):
	case Combine(h_undefproc, g_nxtvar):
	case Combine(h_undefproc, g_0fstvar):
	case Combine(h_undefproc, g_0nxtvar):
	case Combine(h_undefproc, g_1fstvar):
	case Combine(h_undefproc, g_1nxtvar):
	case Combine(h_undefproc, g_2fstvar):
	case Combine(h_undefproc, g_2nxtvar):
	case Combine(h_undefproc, g_3fstvar):
	case Combine(h_undefproc, g_3nxtvar):
	case Combine(c_undefproc, c_call):
	case Combine(c_undefproc, c_lastcall):
undef_proc:
		SDecr(goalptr);
		LDecr(goalptr);
		LopFetch(m1, goalptr);
		m1ptr = ProcFunctor((MWPTR) m1);
		fprintf(stderr, "%s/%d\n", IndexPtr(FunctIndex(m1ptr)),
		                           (int) FunctArity(m1ptr));
		return(ErrorNumber = UndefProcError);
	case Combine(c_goal, c_call):
		ArgReset
		TraceInstr(c_goal_c_call)
		*(((MWPTR) headframeptr) - 2) = (MW) goalframeptr;
		*(((MWPTR) headframeptr) - 1) = (MW) goalptr;
		SIncr(headptr);
		goto call_goal_1;
	case Combine(c_1_goal, c_call):
	case Combine(c_2_goal, c_call):
	case Combine(c_3_goal, c_call):
	case Combine(c_4_goal, c_call):
		ArgReset
		TraceInstr(c_goal_c_call)
		*(((MWPTR) headframeptr) - 2) = (MW) goalframeptr;
		*(((MWPTR) headframeptr) - 1) = (MW) goalptr;
call_goal_1:
		goalframeptr = headframeptr;
		goalptr = headptr;
call_goal_2:
		LopFetch(m1,goalptr);
		ClauseAddress(headptr, m1);
call_goal_3:
		headframeptr = (CHARPTR) stackptr;
		stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));
		LocalStackCheck;
		TraceFrame(FrameSize(headptr))
		if (Alternative(headptr))
			{
			TraceChoice(ComputeArgs(goalptr))
call_goal_4:
			PushChoicePoint(goalptr, headptr);
			}
		TraceStacks
		ReSetRepush
		goto interpret;
	case Combine(c_goal, c_lastcall):
		ArgReset
		TraceInstr(c_goal_c_lastcall)
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			SIncr(headptr);
			goto call_goal_1;
			}
		i = SopFetch(headptr);
		m1ptr = stackptr + i;
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));
		m2ptr = stackptr + i;
		while (--i >= 0)
			*(--m2ptr) = *(--m1ptr);
		goalptr = headptr;
		goto call_goal_2;
	case Combine(c_1_goal, c_lastcall):
		ArgReset
		TraceInstr(c_goal_c_lastcall)
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_goal_1;
			}
		m1ptr = stackptr;
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));
		*stackptr = *m1ptr;
		goalptr = headptr;
		goto call_goal_2;
	case Combine(c_2_goal, c_lastcall):
		ArgReset
		TraceInstr(c_goal_c_lastcall)
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_goal_1;
			}
		m1ptr = stackptr;
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));
		*(stackptr + 1) = *(m1ptr + 1);
		*stackptr = *m1ptr;
		goalptr = headptr;
		goto call_goal_2;
	case Combine(c_3_goal, c_lastcall):
		ArgReset
		TraceInstr(c_goal_c_lastcall)
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_goal_1;
			}
		m1ptr = stackptr;
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));
		*(stackptr + 2) = *(m1ptr + 2);
		*(stackptr + 1) = *(m1ptr + 1);
		*stackptr = *m1ptr;
		goalptr = headptr;
		goto call_goal_2;
	case Combine(c_4_goal, c_lastcall):
		ArgReset
		TraceInstr(c_goal_c_lastcall)
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_goal_1;
			}
		m1ptr = stackptr;
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));
		*(stackptr + 3) = *(m1ptr + 3);
		*(stackptr + 2) = *(m1ptr + 2);
		*(stackptr + 1) = *(m1ptr + 1);
		*stackptr = *m1ptr;
		goalptr = headptr;
		goto call_goal_2;
	case Combine(c_nogoal, c_lastcall):
		ArgReset
		TraceInstr(c_nogoal_c_lastcall)
nogoal_lastcall:
		headframeptr = goalframeptr;
		goalptr = (CODEPTR) (*(((MWPTR) goalframeptr) - 1));
		goalframeptr = (CHARPTR) (*(((MWPTR) goalframeptr) - 2));
#ifdef Trace
		goto nogoal_call;
#endif
	case Combine(c_nogoal, c_call):
		ArgReset
		TraceInstr(c_nogoal_c_call)
nogoal_call:
		stackptr = Min(choicepntptr, (MWPTR) headframeptr);
nogoal_loop:
		TraceStacks
		ArgReset
		switch(ControlMux(InstrFetch(goalptr)))
			{
			case ControlMux(c_goal):
				TraceInstr(c_nogoal_c_goal)
				goto call_goal_2;
			case ControlMux(c_xgoal):
				TraceInstr(c_nogoal_c_xgoal)
				goto xgoal_2;
			case ControlMux(c_nogoal):
				TraceInstr(c_nogoal_c_nogoal)
				goto nogoal_lastcall;
			case ControlMux(c_cut):
				TraceInstr(c_nogoal_c_cut)
				while ((CHARPTR) choicepntptr < goalframeptr)
					DerefChoicePntPtr;
				stackptr = (MWPTR) (goalframeptr - SopFetch(goalptr));
				goto nogoal_loop;
			case ControlMux(c_builtin):
				TraceInstr(c_nogoal_c_bip)
				headframeptr = goalframeptr;
				headptr = goalptr;
				nogoal_bip = TRUE;
				goto call_builtin_0;
			case ControlMux(c_metacall):
				TraceInstr(c_nogoal_c_meta)
				goto call_meta_2;
			case ControlMux(c_block_in):
				TraceInstr(c_nogoal_c_block_in)
				goto call_block_in_2;
			case ControlMux(c_block_out):
				LoadGoalVar(m1ptr);
				blockptr = (MWPTR) BlockBlock(m1ptr);
				if (InstrFetch(goalptr) == c_lastcall)
					goto nogoal_lastcall;
				goto nogoal_loop;
			case ControlMux(c_exit_block):
				TraceInstr(c_nogoal_c_exit_block)
				headframeptr = goalframeptr;
				headptr = goalptr;
				goto call_exit_block_0;
			default:
				fprintf(stderr, "NogoalError\n");
				return(ErrorNumber = SystemError);
			}
	case Combine(c_cut, c_call):
		ArgReset
		TraceInstr(c_cut_c_call)
#ifdef Trace
		goto cut_lastcall;
#endif
	case Combine(c_cut, c_lastcall):
		ArgReset
		TraceInstr(c_cut_c_lastcall)
cut_lastcall:
		if ((CHARPTR) choicepntptr < headframeptr)
			{
			DerefChoicePntPtr;
			stackptr += 6;
			}
		SDecr(goalptr);
		goto interpret;
	case Combine(c_builtin, c_call):
		ArgReset
		TraceInstr(c_bip_c_call)
#ifdef Trace
		goto call_builtin_0;
#endif
	case Combine(c_builtin, c_lastcall):
		ArgReset
		TraceInstr(c_bip_c_lastcall)
call_builtin_0:
		bipnr = SopFetch(headptr);
call_builtin_1:
		i = builtin[bipnr].bt_arity;
		TraceInstr(bipnr + MaxTrace)
		m1ptr = a;
		while (--i >= 0)
			{
			switch(HeadMux(InstrFetch(headptr)))
				{
				case HeadMux(h_const):
					TraceInstr(t_b_const)
					LopFetch(m1, headptr);
					*m1ptr++ = m1;
					break;
				case HeadMux(h_nil):
					TraceInstr(t_b_nil)
					*m1ptr++ = MakeNil;
					break;
				case HeadMux(h_list):
					TraceInstr(t_b_list)
					m2ptr = m1ptr++;
					Push(i);
					CreateList(m2ptr);
					i = -2;
					TraceAdd(t_bipallocsize, 2)
					goto builtin_head_copy;
				case HeadMux(h_struct):
					TraceInstr(t_b_struct)
					m2ptr = m1ptr++;
					Push(i);
					FetchStruct(m2ptr, headptr,
					            i = ArityFetch(headptr));
					TraceAdd(t_bipallocsize, i + 1)
					i = -i;
					goto builtin_head_copy;
				case HeadMux(h_void):
					TraceInstr(t_b_void)
					MakeCopyUndef;
					*m1ptr++ = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case HeadMux(h_fstvar):
					TraceInstr(t_b_fstvar)
					LoadHeadVar(m2ptr);
					TraceInstr(t_bipcopyundef)
					MakeCopyUndef;
					*m2ptr = *m1ptr++ = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case HeadMux(h_nxtvar):
					TraceInstr(t_b_nxtvar)
					LoadHeadVar(m2ptr);
					*m1ptr++ = *m2ptr;
					break;
				case HeadMux(h_fsttemp):
					TraceInstr(t_b_fsttmp)
					LoadTempVar(m2ptr);
					MakeCopyUndef;
					TraceInstr(t_bipcopyundef)
					*m2ptr = *m1ptr++ = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case HeadMux(h_nxttemp):
					TraceInstr(t_b_nxttmp)
					LoadTempVar(m2ptr);
					*m1ptr++ = *m2ptr;
					break;
				case HeadMux(h_fsttmp0):
					TraceInstr(t_b_fsttmp)
					MakeCopyUndef;
					TraceInstr(t_bipcopyundef)
					temp0 = *m1ptr++ = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case HeadMux(h_nxttmp0):
					TraceInstr(t_b_nxttmp)
					*m1ptr++ = temp0;
					break;
				default:
					fprintf(stderr, "BuiltinArgCopyError\n");
					return(ErrorNumber = SystemError);
				}
call_builtin_head: ;
			}
		if ((i = (*builtin[bipnr].bt_bipptr)(a)) != Success)
			{
			nogoal_bip = FALSE;
			if (i == Fail)
				{
				TraceInstr(t_bipfail)
				goto fail;
				}
			else
				goto bip_error_0;
			}
		if (nogoal_bip)
			{
			nogoal_bip = FALSE;
			goalptr = headptr;
			goto nogoal_loop;
			}
		SDecr(goalptr);
		goto interpret;
	case Combine(c_metacall, c_call):
		ArgReset
		TraceInstr(c_meta_c_call)
		*(((MWPTR) headframeptr) - 2) = (MW) goalframeptr;
		*(((MWPTR) headframeptr) - 1) = (MW) goalptr;
call_meta_1:
		SIncr(headptr);
		goalframeptr = headframeptr;
		goalptr = headptr;
call_meta_2:
		goalptr2 = goalptr;
		SIncr(goalptr);
		SIncr(goalptr);
		LoadGoalVar(m1ptr);
call_meta_3:
		m1 = *m1ptr;
		StructDeref(m1, m1ptr);
		if (Atom(m1))
			{
			goalptr2 = goalptr;
call_meta_4:
			m1 = XtrAtomIndex(m1);
			i = 0;
			if ((m2ptr = find_func(m1, i)) == 0)
				return(ErrorNumber);
			}
		else if (Struct(m1))
			{
			m1ptr = XtrStruct(m1);
			m1 = FunctIndex(m2ptr = XtrFunctor(m1ptr));
			i = FunctArity(m2ptr);
			m1ptr = FirstArgPtr(m1ptr);
			}
		else
			return(ErrorNumber = InvalidGoalError);
		if (m2ptr == CutFunctor)
			{
			if (InstrFetch(goalptr) == c_call)
				goto nogoal_call;
			else
				goto nogoal_lastcall;
			}
		if ((bipnr = find_bip(m1, i)) >= 0)
			{
			TraceInstr(bipnr + MaxTrace)
			if ((i = (*builtin[bipnr].bt_bipptr)(m1ptr)) != Success)
				if (i == Fail)
					{
					TraceInstr(t_bipfail)
					goto fail;
					}
				else
					goto bip_error_1;
			if (InstrFetch(goalptr) == c_call)
				goto nogoal_call;
			else
				goto nogoal_lastcall;
			}
		if ((m2ptr = FunctProc(m2ptr)) != 0)
			headptr = (CODEPTR) ProcOffset(m2ptr);
		if ((m2ptr == 0) || (IsUndefProc(headptr)))
			{
			ErrorNumber = UndefProcError;
			goto bip_error_2;
			}
		headframeptr = (CHARPTR) stackptr;
		stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));
		LocalStackCheck;
		TraceFrame(FrameSize(headptr))
		if (Alternative(headptr))
			{
			TraceChoice(i)
			PushChoicePoint(goalptr2, headptr);
			}
		TraceStacks
		ReSetRepush
		if (i == 0)
			goto interpret;
		i = -i;
		Push(0);
		goto head_unify;
	case Combine(c_metacall, c_lastcall):
		ArgReset
		TraceInstr(c_meta_c_lastcall)
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_meta_1;
			}
		i = SopFetch(headptr);
		m1ptr = stackptr + i;
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));
		m2ptr = stackptr + i;
		while (--i >= 0)
			*(--m2ptr) = *(--m1ptr);
		goalptr = headptr;
		goto call_meta_2;
	case Combine(h_const, g_meta):
	case Combine(h_nil, g_meta):
	case Combine(h_list, g_meta):
	case Combine(h_struct, g_meta):
	case Combine(h_void, g_meta):
	case Combine(h_fstvar, g_meta):
	case Combine(h_nxtvar, g_meta):
	case Combine(h_fsttemp, g_meta):
	case Combine(h_nxttemp, g_meta):
	case Combine(h_fsttmp0, g_meta):
	case Combine(h_nxttmp0, g_meta):
	case Combine(c_goal, g_meta):
	case Combine(c_1_goal, g_meta):
	case Combine(c_2_goal, g_meta):
	case Combine(c_3_goal, g_meta):
	case Combine(c_4_goal, g_meta):
	case Combine(c_nogoal, g_meta):
	case Combine(c_cut, g_meta):
	case Combine(c_builtin, g_meta):
	case Combine(c_metacall, g_meta):
	case Combine(c_undefproc, g_meta):
	case Combine(c_xgoal, g_meta):
	case Combine(c_1_xgoal, g_meta):
	case Combine(c_2_xgoal, g_meta):
	case Combine(c_3_xgoal, g_meta):
	case Combine(c_4_xgoal, g_meta):
	case Combine(c_block_in, g_meta):
	case Combine(c_exit_block, g_meta):
		SDecr(headptr);
		if (InstrFetch(goalptr) == c_metacall)
			{
			LoadGoalVar(m1ptr);
			m1 = *m1ptr;
			StructDeref(m1, m1ptr);
			}
		else
			{
			LoadGoalVar(m1ptr);
			blockptr = m1ptr;
			m1 = *(m1ptr = &BlockCall(blockptr));
			StructDeref(m1, m1ptr);
			if (Atom(m1))
				goto interpret;
			}
		m1ptr = XtrStruct(m1);
		i = -(XtrArity(m1ptr));
		m1ptr = FirstArgPtr(m1ptr);
		Push(0);
		goto head_unify;
	case Combine(c_block_in, c_call):
		ArgReset
		TraceInstr(c_block_in_c_call)
		*(((MWPTR) headframeptr) - 2) = (MW) goalframeptr;
		*(((MWPTR) headframeptr) - 1) = (MW) goalptr;
call_block_in_1:
		SIncr(headptr);
		goalframeptr = headframeptr;
		goalptr = headptr;
call_block_in_2:
		goalptr2 = goalptr;
		SIncr(goalptr);
		SIncr(goalptr);
		LoadGoalVar(m1ptr);
		BlockCall(m1ptr) = a[0];
		BlockBall(m1ptr) = a[1];
		BlockExit(m1ptr) = a[2];
		BlockCode(m1ptr) = (MW) (goalptr + 3);  /* c_call, c_block_out, offset */
		BlockFrame(m1ptr) = (MW) goalframeptr;
		BlockStack(m1ptr) = (MW) stackptr;
		BlockTrail(m1ptr) = (MW) trail;
		BlockCopy(m1ptr) = (MW) copyptr;
		BlockBlock(m1ptr) = (MW) blockptr;
		*(--stackptr) = (MW) blockptr;
		blockptr = m1ptr;
		PushChoicePoint(blockoutptr, blockoutptr);
		m1 = *(m1ptr = a);
		StructDeref(m1, m1ptr);
		if (Atom(m1))
			goto call_meta_4;
		goto call_meta_3;
	case Combine(c_block_in, c_lastcall):
		ArgReset
		TraceInstr(c_block_in_c_lastcall)
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_block_in_1;
			}
		i = SopFetch(headptr);
		m1ptr = stackptr + i;
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));
		m2ptr = stackptr + i;
		while (--i >= 0)
			*(--m2ptr) = *(--m1ptr);
		goalptr = headptr;
		goto call_block_in_2;
bip_error_0:
		m1ptr = a;
		m1 = builtin[bipnr].bt_name;
bip_error_1:
		i = builtin[bipnr].bt_arity;
bip_error_2:
		if (blockptr == 0)
			return(ErrorNumber);
		copyptr = copyptr + ((MWPTR) trail - copyptr) / 2;
		m2ptr = berror + 2;
		if (i == 0)
			*m2ptr = MakeAtom(m1);
		else
			{
			CreateStruct(m2ptr, find_func(m1, i), i);
			ctbottom = trail;
			while (--i >= 0)
				if (var_copy_term(m1ptr++, m2ptr++) != Success)
					{
					trail = ctbottom;
					return(ErrorNumber);
					}
			trail = ctbottom;
			}
		switch (ErrorNumber)
			{
			case EndOfInputError:
				(void) find_atom("end_of_file_error", berror + 1);
				break;
			case FileOpenError:
				(void) find_atom("file_open_error", berror + 1);
				break;
			case InvalidGoalError:
				(void) find_atom("database_error", berror + 1);
				break;
			case UndefProcError:
				(void) find_atom("undefined_procedure_error", berror + 1);
				break;
			case BuiltinInstError:
				(void) find_atom("instantiation_error", berror + 1);
				break;
			case BuiltinTypeError:
				(void) find_atom("type_error", berror + 1);
				break;
			case BuiltinRangeError:
				(void) find_atom("range_error", berror + 1);
				break;
			case BuiltinOpError:
				(void) find_atom("operator_error", berror + 1);
				break;
			default:
				return(ErrorNumber);
			}
		ball = berr;
		goto call_exit_block_1;
	case Combine(c_exit_block, c_call):
		ArgReset
		TraceInstr(c_exit_block_c_call)
call_exit_block_0:
		if (blockptr == 0)
			return(ErrorNumber = NoBlockError);
		copyptr = copyptr + ((MWPTR) trail - copyptr) / 2;
		if (copy_term(&TempVar(0), &ball) != Success)
			return(ErrorNumber);
call_exit_block_1:
		while (blockptr != 0)
			{
			m1ptr = (MWPTR) trail;
			goalptr = (CODEPTR) BlockCode(blockptr);		
			goalframeptr = (CHARPTR) BlockFrame(blockptr);		
			stackptr = (MWPTR) BlockStack(blockptr);		
			trail = (MWPTR*) BlockTrail(blockptr);		
			copyptr = (MWPTR) BlockCopy(blockptr);		
			/* untrailing */
#ifdef Comp
			while (m1ptr > (MWPTR) trail)
				{
				m2ptr = XtrRef(*(--m1ptr));
				*m2ptr = MakeUndef(m2ptr);
				}
#else
			while (m1ptr > (MWPTR) trail)
				{
				m2ptr = (MWPTR)(*(--m1ptr));
				*m2ptr = MakeUndef(m2ptr);
				}
#endif	
			while (choicepntptr < stackptr)
				DerefChoicePntPtr;
			if ((MWPTR) trail >= --copyptr)
				return(ErrorNumber = CopyOverflowError);
			m2ptr = copyptr;
			if (copy_term(&ball, copyptr) != Success)
				return(ErrorNumber);
			m3ptr = &BlockBall(blockptr);
			m1ptr = &BlockExit(blockptr);
			blockptr = (MWPTR) BlockBlock(blockptr);
			if ((i = unify(m2ptr, m3ptr)) == Success)
				goto call_meta_3;
			if (i != Fail)
				return(ErrorNumber);
			}
		return(ErrorNumber = NoBlockError);
	case Combine(c_exit_block, c_lastcall):
		ArgReset
		TraceInstr(c_exit_block_c_lastcall)
		goto call_exit_block_0;
	case Combine(c_block_out, c_call):
		blockptr = (MWPTR) *stackptr;
		goto fail;
	case Combine(c_xgoal, c_lastcall):
		ArgReset
		TraceInstr(c_xgoal_c_lastcall)
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			SIncr(headptr);
			goto xgoal_1;
			}
		i = SopFetch(headptr);
		m1ptr = stackptr + i;
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));
		m2ptr = stackptr + i;
		while (--i >= 0)
			*(--m2ptr) = *(--m1ptr);
		goalptr = headptr;
		goto xgoal_2;
	case Combine(c_1_xgoal, c_lastcall):
		ArgReset
		TraceInstr(c_xgoal_c_lastcall)
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto xgoal_1;
			}
		m1ptr = stackptr;
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));
		*stackptr = *m1ptr;
		goalptr = headptr;
		goto xgoal_2;
	case Combine(c_2_xgoal, c_lastcall):
		ArgReset
		TraceInstr(c_xgoal_c_lastcall)
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto xgoal_1;
			}
		m1ptr = stackptr;
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));
		*(stackptr + 1) = *(m1ptr + 1);
		*stackptr = *m1ptr;
		goalptr = headptr;
		goto xgoal_2;
	case Combine(c_3_xgoal, c_lastcall):
		ArgReset
		TraceInstr(c_xgoal_c_lastcall)
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto xgoal_1;
			}
		m1ptr = stackptr;
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));
		*(stackptr + 2) = *(m1ptr + 2);
		*(stackptr + 1) = *(m1ptr + 1);
		*stackptr = *m1ptr;
		goalptr = headptr;
		goto xgoal_2;
	case Combine(c_4_xgoal, c_lastcall):
		ArgReset
		TraceInstr(c_xgoal_c_lastcall)
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto xgoal_1;
			}
		m1ptr = stackptr;
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));
		*(stackptr + 3) = *(m1ptr + 3);
		*(stackptr + 2) = *(m1ptr + 2);
		*(stackptr + 1) = *(m1ptr + 1);
		*stackptr = *m1ptr;
		goalptr = headptr;
		goto xgoal_2;
	case Combine(c_xgoal, c_call):
		ArgReset
		TraceInstr(c_xgoal_c_call)
		*(((MWPTR) headframeptr) - 2) = (MW) goalframeptr;
		*(((MWPTR) headframeptr) - 1) = (MW) goalptr;
		SIncr(headptr);
		goto xgoal_1;
	case Combine(c_1_xgoal, c_call):
	case Combine(c_2_xgoal, c_call):
	case Combine(c_3_xgoal, c_call):
	case Combine(c_4_xgoal, c_call):
		ArgReset
		TraceInstr(c_xgoal_c_call)
		*(((MWPTR) headframeptr) - 2) = (MW) goalframeptr;
		*(((MWPTR) headframeptr) - 1) = (MW) goalptr;
xgoal_1:
		goalframeptr = headframeptr;
		goalptr = headptr;
xgoal_2:
		LopFetch(m2,goalptr);
		IndexAddress(headptr, m2);
		LoadGoalVar(m1ptr);
		if (NotVal(m1 = *m1ptr))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				AlternativeAddress(headptr);
xgoal_3:
				headframeptr = (CHARPTR) stackptr;
				stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));
				LocalStackCheck;
				TraceFrame(FrameSize(headptr))
				if (Alternative(headptr))
					{
					TraceChoice(ComputeArgs(goalptr-2))
					PushChoicePoint((-((MW) goalptr)), headptr);
					}
				TraceStacks
				ReSetRepush
				ArgIncr
				switch (HeadMux(InstrFetch(headptr)))
					{
					case HeadMux(h_const):
						TraceInstr(h_const_g_nxtvar)
						LopFetch(m2, headptr);
						AssignInter(m1ptr, m2);
					case HeadMux(h_nil):
						TraceInstr(h_nil_g_nxtvar)
						AssignInter(m1ptr, MakeNil);
					case HeadMux(h_list):
						TraceInstr(h_list_g_nxtvar)
						Trail(m1ptr);
						goto list_fstvar;
					case HeadMux(h_struct):
						TraceInstr(h_struct_g_nxtvar)
						Trail(m1ptr);
						goto struct_fstvar;
					case HeadMux(h_fstvar):
						TraceInstr(h_fstvar_g_nxtvar)
						LoadHeadVar(m2ptr);
						*m2ptr = MakeRef(m1ptr);
						TraceInstr(t_makeref)
						goto interpret;
					case HeadMux(h_void):
						TraceInstr(h_void_g_nxtvar)
						goto interpret;
					case HeadMux(h_fsttemp):
						TraceInstr(h_fsttmp_g_nxtvar)
						LoadTempVar(m2ptr);
						*m2ptr = MakeRef(m1ptr);
						TraceInstr(t_makeref)
						goto interpret;
					case HeadMux(h_fsttmp0):
						TraceInstr(h_fsttmp_g_nxtvar)
						temp0 = MakeRef(m1ptr);
						TraceInstr(t_makeref)
						goto interpret;
					case HeadMux(h_undefproc):
						goto undef_proc;
					default:
						fprintf(stderr, "XgoalUndefError\n");
						return(ErrorNumber = SystemError);
					}
				}
			}
		if (Indexing(headptr) != x_general)     /* switch */
			{
			if (List(m1))
				{
				headptr = (CODEPTR) Equal(headptr);
				headframeptr = (CHARPTR) stackptr;
				stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));
				LocalStackCheck;
				TraceFrame(FrameSize(headptr))
				ArgIncr
				TraceInstr(h_list_g_nxtvar)
				SIncr(headptr);
				m1ptr = XtrList(m1);
				TraceInstr(t_xtrlist)
				i = -2;
				TraceStacks
				ReSetRepush
				Push(0);
				goto head_unify;
				}
			if (Nil(m1))
				{
				headptr = (CODEPTR) Greater(headptr);
				headframeptr = (CHARPTR) stackptr;
				stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));
				LocalStackCheck;
				TraceFrame(FrameSize(headptr))
				ArgIncr
				TraceInstr(h_nil_g_nxtvar)
				SIncr(headptr);
				TraceStacks
				ReSetRepush
				goto interpret;
				}
			goto fail;
			}
xgoal_4:
		if (ListOrStruct(m1))
			if (List(m1))
				goto xfail_1;
			else
				{
				m1ptr = XtrStruct(m1);
				m3 = (MW) XtrFunctor(m1ptr);
				i = XtrArity(m1ptr);
				}
		else if (Nil(m1))
			if ((headptr = (CODEPTR) Greater(headptr)) == 0)
				{
				TraceInstr(t_index_fail)
				goto fail;
				}
			else
				goto xfail_2;
		else
			m3 = m1;
		headptr = (CODEPTR) Less(headptr);
		while (headptr != 0)
			{
			headptr2 = headptr;
			switch(HeadMux(InstrFetch(headptr)))
				{
				case HeadMux(h_const):
					LopFetch(m2, headptr);
					if (m3 != m2)
						if (m3 < m2)
							{
							headptr = (CODEPTR) Less(headptr2);
							continue;
							}
						else
							{
							headptr = (CODEPTR) Greater(headptr2);
							continue;
							}
					headframeptr = (CHARPTR) stackptr;
					stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));
					LocalStackCheck;
					TraceFrame(FrameSize(headptr2))
					if (Equal(headptr2))
						{
						TraceChoice(ComputeArgs(goalptr-2))
						PushChoicePoint((-((MW) goalptr)), (-((MW) headptr2)));
						}
					TraceStacks
					ReSetRepush
					ArgIncr TraceInstr(h_const_g_nxtvar)
					goto interpret;
				case HeadMux(h_struct):
					m2 = (MW) FunctorFetch(headptr);
					if (m3 != m2)
						if (m3 < m2)
							{
							headptr = (CODEPTR) Less(headptr2);
							continue;
							}
						else
							{
							headptr = (CODEPTR) Greater(headptr2);
							continue;
							}
					if (i != ArityFetch(headptr))
						{
						headptr = (CODEPTR) Equal(headptr2);
						continue;
						}
					i = -i;
					m1ptr = FirstArgPtr(m1ptr);
					FirstArgIncr(headptr);
					headframeptr = (CHARPTR) stackptr;
					stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));
					LocalStackCheck;
					TraceFrame(FrameSize(headptr2))
					if (Equal(headptr2))
						{
						TraceChoice(ComputeArgs(goalptr-2))
						PushChoicePoint((-((MW) goalptr)), (-((MW) headptr2)));
						}
					TraceStacks
					ReSetRepush
					ArgIncr TraceInstr(h_struct_g_nxtvar)
					Push(0);
					goto head_unify;
				case HeadMux(h_fstvar):
					ArgIncr TraceInstr(h_fstvar_g_nxtvar)
					headframeptr = (CHARPTR) stackptr;
					stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));
					LocalStackCheck;
					LoadHeadVar(m1ptr);
					*m1ptr = m1;
					goto xgoal_5;
				case HeadMux(h_fsttemp):
					ArgIncr TraceInstr(h_fsttmp_g_nxtvar)
					LoadTempVar(m1ptr);
					*m1ptr = m1;
					goto xgoal_t5;
				case HeadMux(h_fsttmp0):
					ArgIncr TraceInstr(h_fsttmp_g_nxtvar)
					temp0 = m1;
#ifdef Trace
					goto xgoal_t5;
#endif
				case HeadMux(h_void):
					ArgIncr TraceInstr(h_void_g_nxtvar)
xgoal_t5:
					headframeptr = (CHARPTR) stackptr;
					stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));
					LocalStackCheck;
xgoal_5:
					TraceFrame(FrameSize(headptr2))
					if (Alternative(headptr2))
						{
						TraceChoice(ComputeArgs(goalptr-2))
						PushChoicePoint((-((MW) goalptr)), headptr2);
						}
					TraceStacks
					ReSetRepush
					goto interpret;
				case HeadMux(h_undefproc):
					goto undef_proc;
				default:
					fprintf(stderr, "XgoalValError\n");
					return(ErrorNumber = SystemError);
				}
			}
		TraceInstr(t_index_fail)
		goto fail;
	default:
		fprintf(stderr, "MainSwitchError\n");
		return(ErrorNumber = SystemError);
	}

fail:
	TraceInstr(t_fail)
	TraceStacks
	ArgReset
	SetRepush
	m1ptr = (MWPTR) trail;
	PopChoicePoint;
#ifdef Comp
	while (m1ptr > (MWPTR) trail)
		{
		m2ptr = XtrRef(*(--m1ptr));
		*m2ptr = MakeUndef(m2ptr);
		}
#else
	while (m1ptr > (MWPTR) trail)
		{
		m2ptr =(MWPTR)(*(--m1ptr));
		*m2ptr = MakeUndef(m2ptr);
		}
#endif
	if ((MW) goalptr > 0)
		{
		if ((headptr = (CODEPTR) Alternative(headptr)) == 0)
			goto fail;
		goto call_goal_3;
		}
	goalptr = (CODEPTR) (-((MW) goalptr));
	LoadOffsetGoalVar(-1, m1ptr);
	if (NotVal(m1 = *m1ptr))
		{
		Deref(m1, m1ptr);
		if (RefUndef(m1))
			{
			headptr = (CODEPTR) Alternative(headptr);
			goto xgoal_3;
			}
		}
	if ((MW) headptr > 0)
		goto xgoal_4;
	headptr = (CODEPTR) (-((MW) headptr));
xfail_1:
	if ((headptr = (CODEPTR) Equal(headptr)) == 0)
		{
		TraceInstr(t_index_fail)
		goto fail;
		}
xfail_2:
	headptr2 = headptr;
	headframeptr = (CHARPTR) stackptr;
	stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));
	LocalStackCheck;
	TraceFrame(FrameSize(headptr))
	ArgIncr
	switch(HeadMux(InstrFetch(headptr)))
		{
		case HeadMux(h_const):
			TraceInstr(h_const_g_nxtvar)
			LIncr(headptr);
#ifdef Trace
		goto xfail_t2;
#endif
		case HeadMux(h_nil):
			TraceInstr(h_nil_g_nxtvar)
xfail_t2:
			if (Equal(headptr2))
				{
				TraceChoice(ComputeArgs(goalptr-2))
				PushChoicePoint((-((MW) goalptr)), (-((MW) headptr2)));
				}
			TraceStacks
			ReSetRepush
			goto interpret;
		case HeadMux(h_list):
			TraceInstr(h_list_g_nxtvar)
			m1ptr = XtrList(m1);
			TraceInstr(t_xtrlist)
			i = -2;
xfail_3:
			if (Equal(headptr2))
				{
				TraceChoice(ComputeArgs(goalptr-2))
				PushChoicePoint((-((MW) goalptr)), (-((MW) headptr2)));
				}
			TraceStacks
			ReSetRepush
			Push(0);
			goto head_unify;
		case HeadMux(h_struct):
			TraceInstr(h_struct_g_nxtvar)
			m1ptr = XtrStruct(m1);
			i = XtrArity(m1ptr);
			if (i != ArityFetch(headptr))
				goto xfail_1;
			i = -i;
			m1ptr = FirstArgPtr(m1ptr);
			FirstArgIncr(headptr);
			goto xfail_3;
		case HeadMux(h_fstvar):
			TraceInstr(h_fstvar_g_nxtvar)
			LoadHeadVar(m1ptr);
xfail_4:
			*m1ptr = m1;
#ifdef Trace
			goto xfail_t4;
#endif
		case HeadMux(h_void):
			TraceInstr(h_void_g_nxtvar)
xfail_t4:
			if (Alternative(headptr2))
				{
				TraceChoice(ComputeArgs(goalptr-2))
				PushChoicePoint((-((MW) goalptr)), headptr2);
				}
			TraceStacks
			ReSetRepush
			goto interpret;
		case HeadMux(h_fsttemp):
			TraceInstr(h_fsttmp_g_nxtvar)
			LoadTempVar(m1ptr);
			goto xfail_4;
		case HeadMux(h_fsttmp0):
			TraceInstr(h_fsttmp_g_nxtvar)
			temp0 = m1;
			goto xfail_t4;
		case HeadMux(h_undefproc):
			goto undef_proc;
		default:
			fprintf(stderr, "XfailError\n");
			return(ErrorNumber = SystemError);
		}


builtin_head_copy:
while (++i <= 0)
	switch(HeadMux(InstrFetch(headptr)))
		{
		case HeadMux(h_const):
			TraceInstr(b_copy_h_const)
			LopFetch(m1, headptr);
			*m2ptr++ = m1;
			break;
		case HeadMux(h_nil):
			TraceInstr(b_copy_h_nil)
			*m2ptr++ = MakeNil;
			break;
		case HeadMux(h_list):
			TraceInstr(b_copy_h_list)
			if (i != 0)
				{
				Push(m2ptr+1);
				Push(i);
				}
			CreateList(m2ptr);
			TraceAdd(t_bipallocsize, 2)
			i = -2;
			break;
		case HeadMux(h_struct):
			TraceInstr(b_copy_h_struct)
			if (i != 0)
				{
				Push(m2ptr+1);
				Push(i);
				}
			FetchStruct(m2ptr, headptr, i = (ArityFetch(headptr)));
			TraceAdd(t_bipallocsize, i + 1)
			i = -i;
			break;
		case HeadMux(h_fstvar):
			TraceInstr(b_copy_h_fstvar)
			LoadHeadVar(m3ptr);
			*m3ptr = MakeRef(m2ptr);
			TraceInstr(t_makeref)
		case HeadMux(h_void):
			TraceInstr(b_copy_h_void)
			*m2ptr++ = MakeUndef(m2ptr);
			break;
		case HeadMux(h_nxtvar):
			TraceInstr(b_copy_h_nxtvar)
			LoadHeadVar(m3ptr);
			*m2ptr++ = *m3ptr;
			break;
		case HeadMux(h_fsttemp):
			TraceInstr(b_copy_h_fsttmp)
			LoadTempVar(m3ptr);
			*m3ptr = MakeRef(m2ptr);
			TraceInstr(t_makeref)
			*m2ptr++ = MakeUndef(m2ptr);
			break;
		case HeadMux(h_nxttemp):
			TraceInstr(b_copy_h_nxttmp)
			LoadTempVar(m3ptr);
			*m2ptr++ = *m3ptr;
			break;
		case HeadMux(h_fsttmp0):
			TraceInstr(b_copy_h_fsttmp)
			temp0 = MakeRef(m2ptr);
			TraceInstr(t_makeref)
			*m2ptr++ = MakeUndef(m2ptr);
			break;
		case HeadMux(h_nxttmp0):
			TraceInstr(b_copy_h_nxttmp)
			*m2ptr++ = temp0;
			break;
		default:
			fprintf(stderr, "BuiltinCopyError\n");
			return(ErrorNumber = SystemError);
		}
if (Pop((int), i) >= 0)
	goto call_builtin_head;
Pop((MWPTR), m2ptr);
goto builtin_head_copy;


builtin_goal_copy:
while (++i <= 0)
	switch(HeadMux(InstrFetch(goalptr)))
		{
		case HeadMux(h_const):
			TraceInstr(b_copy_h_const)
			LopFetch(m1, goalptr);
			*m2ptr++ = m1;
			break;
		case HeadMux(h_nil):
			TraceInstr(b_copy_h_nil)
			*m2ptr++ = MakeNil;
			break;
		case HeadMux(h_list):
			TraceInstr(b_copy_h_list)
			if (i != 0)
				{
				Push(m2ptr+1);
				Push(i);
				}
			CreateList(m2ptr);
			TraceAdd(t_bipallocsize, 2)
			i = -2;
			break;
		case HeadMux(h_struct):
			TraceInstr(b_copy_h_struct)
			if (i != 0)
				{
				Push(m2ptr+1);
				Push(i);
				}
			FetchStruct(m2ptr, goalptr, i = (ArityFetch(goalptr)));
			TraceAdd(t_bipallocsize, i + 1)
			i = -i;
			break;
		case HeadMux(h_fstvar):
			TraceInstr(b_copy_h_fstvar)
			LoadGoalVar(m3ptr);
			*m3ptr = MakeRef(m2ptr);
			TraceInstr(t_makeref)
		case HeadMux(h_void):
			TraceInstr(b_copy_h_void)
			*m2ptr++ = MakeUndef(m2ptr);
			break;
		case HeadMux(h_nxtvar):
			TraceInstr(b_copy_h_nxtvar)
			LoadGoalVar(m3ptr);
			*m2ptr++ = *m3ptr;
			break;
		case HeadMux(h_fsttemp):
			TraceInstr(b_copy_h_fsttmp)
			LoadGoalTempVar(m3ptr);
			*m3ptr = MakeRef(m2ptr);
			TraceInstr(t_makeref)
			*m2ptr++ = MakeUndef(m2ptr);
			break;
		case HeadMux(h_nxttemp):
			TraceInstr(b_copy_h_nxttmp)
			LoadGoalTempVar(m3ptr);
			*m2ptr++ = *m3ptr;
			break;
		case HeadMux(h_fsttmp0):
			TraceInstr(b_copy_h_fsttmp)
			temp0 = MakeRef(m2ptr);
			TraceInstr(t_makeref)
			*m2ptr++ = MakeUndef(m2ptr);
			break;
		case HeadMux(h_nxttmp0):
			TraceInstr(b_copy_h_nxttmp)
			*m2ptr++ = temp0;
			break;
		default:
			fprintf(stderr, "BuiltinCopyError\n");
			return(ErrorNumber = SystemError);
		}
if (Pop((int), i) >= 0)
	goto call_builtin_goal;
Pop((MWPTR), m2ptr);
goto builtin_goal_copy;


head_copy:
while (--i >= 0)
	switch(HeadMux(InstrFetch(headptr)))
		{
		case HeadMux(h_const):
			TraceInstr(h_copy_h_const)
			LopFetch(m1, headptr);
			*m1ptr++ = m1;
			break;
		case HeadMux(h_nil):
			TraceInstr(h_copy_h_nil)
			*m1ptr++ = MakeNil;
			break;
		case HeadMux(h_list):
			TraceInstr(h_copy_h_list)
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			CreateList(m1ptr);
			i = 2;
			break;
		case HeadMux(h_struct):
			TraceInstr(h_copy_h_struct)
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			FetchStruct(m1ptr, headptr, i = ArityFetch(headptr));
			break;
		case HeadMux(h_fstvar):
			TraceInstr(h_copy_h_fstvar)
			LoadHeadVar(m2ptr);
			*m2ptr = MakeRef(m1ptr);
			TraceInstr(t_makeref)
		case HeadMux(h_void):
			TraceInstr(h_copy_h_void)
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case HeadMux(h_nxtvar):
			TraceInstr(h_copy_h_nxtvar)
			LoadHeadVar(m2ptr);
			*m1ptr++ = *m2ptr;
			break;
		case HeadMux(h_fsttemp):
			TraceInstr(h_copy_h_fsttmp)
			LoadTempVar(m2ptr);
			*m2ptr = MakeRef(m1ptr);
			TraceInstr(t_makeref)
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case HeadMux(h_nxttemp):
			TraceInstr(h_copy_h_nxttmp)
			LoadTempVar(m2ptr);
			*m1ptr++ = *m2ptr;
			break;
		case HeadMux(h_fsttmp0):
			TraceInstr(h_copy_h_fsttmp)
			temp0 = MakeRef(m1ptr);
			TraceInstr(t_makeref)
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case HeadMux(h_nxttmp0):
			TraceInstr(h_copy_h_nxttmp)
			*m1ptr++ = temp0;
			break;
		default:
			fprintf(stderr, "HeadCopyError\n");
			return(ErrorNumber = SystemError);
		}
if (Pop((int), i) == 0)
	goto interpret;
Pop((MWPTR), m1ptr);
if (i > 0)
	goto head_copy;
/* goto head_unify; */

head_unify:
while (++i <= 0)
	switch(HeadMux(InstrFetch(headptr)))
		{
		case HeadMux(h_const):
			TraceInstr(h_unify_h_const)
			LopFetch(m1, headptr);
			if (NotVal(m2 = *m1ptr++))
				{
				m2ptr = m1ptr-1;
				StructDeref(m2, m2ptr);
				if (RefUndef(m2))
					AssignBreak(m2ptr, m1)
				}
			if (m1 == m2)
				break;
			FailInstr(h_unify_h_const)
			goto fail;
		case HeadMux(h_nil):
			TraceInstr(h_unify_h_nil)
			if (NotVal(m1 = *m1ptr++))
				{
				m2ptr = m1ptr-1;
				StructDeref(m1, m2ptr);
				if (RefUndef(m1))
					AssignBreak(m2ptr, MakeNil)
				}
			if (Nil(m1))
				break;
			FailInstr(h_unify_h_nil)
			goto fail;
		case HeadMux(h_list):
			TraceInstr(h_unify_h_list)
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			if (NotVal(m1 = *m1ptr))
				{
				StructDeref(m1, m1ptr);
				if (RefUndef(m1))
					{
					Trail(m1ptr);
					CreateList(m1ptr);
					i = 2;
					goto head_copy;
					}
				}
			if (NotList(m1))
				{
				FailInstr(h_unify_h_list)
				goto fail;
				}
			m1ptr = XtrList(m1);
			TraceInstr(t_xtrlist)
			i = -2;
			break;
		case HeadMux(h_struct):
			TraceInstr(h_unify_h_struct)
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			if (NotVal(m1 = *m1ptr))
				{
				StructDeref(m1, m1ptr);
				if (RefUndef(m1))
					{
					Trail(m1ptr);
					FetchStruct(m1ptr, headptr, i = ArityFetch(headptr));
					goto head_copy;
					}
				}
			if (NotStruct(m1))
				{
				FailInstr(h_unify_h_struct)
				goto fail;
				}
			m1ptr = XtrStruct(m1);
			i = -ArityFetch(headptr);
			UnifyStruct(m1ptr, headptr);
			break;
		case HeadMux(h_void):
			TraceInstr(h_unify_h_void)
			m1ptr++;
			break;
		case HeadMux(h_fstvar):
			TraceInstr(h_unify_h_fstvar)
			LoadHeadVar(m2ptr);
unify_fstvar:
#ifdef UndefSelfRef
			*m2ptr = *m1ptr++;
#else
			if (Undef(*m2ptr = *m1ptr++))
				{
				*m2ptr = MakeRef(m1ptr-1);
				TraceInstr(t_makeref)
				}
#endif /* UndefSelfRef */
			break;
		case HeadMux(h_nxtvar):
			TraceInstr(h_unify_h_nxtvar)
			LoadHeadVar(m2ptr);
unify_nxtvar:
			m2 = *m2ptr;
unify_nxtvar_tmp0:
			m3ptr = m1ptr++;
			if (NotVal(m1 = *m3ptr))
				{
				StructDeref(m1, m3ptr);
				if (RefUndef(m1))
					{
					if (NotVal(m2))
						{
						Deref(m2, m2ptr);
						if (RefUndef(m2))
							if (Pointsto(m3ptr, m2ptr))
								{ 
								TraceInstr(t_makeref)
								AssignBreak(m3ptr, MakeRef(m2ptr))
								}
							else if (Pointsto(m2ptr, m3ptr))
								{
								TraceInstr(t_makeref)
								AssignBreak(m2ptr, MakeRef(m3ptr))
								}
							else
								break;
						}
					AssignBreak(m3ptr, m2)
					}
				}
			if (NotVal(m2))
				{
				Deref(m2, m2ptr);
				if (RefUndef(m2))
					AssignBreak(m2ptr, m1)
				}
			if (m1 == m2)
				break;
			if (ListOrStruct(m1) &&	struct_unify(m1, m2))
				break;
			FailInstr(h_unify_h_nxtvar)
			goto fail;
		case HeadMux(h_fsttemp):
			TraceInstr(h_unify_h_fsttmp)
			LoadTempVar(m2ptr);
			goto unify_fstvar;
		case HeadMux(h_nxttemp):
			TraceInstr(h_unify_h_nxttmp)
			LoadTempVar(m2ptr);
			goto unify_nxtvar;
		case HeadMux(h_fsttmp0):
			TraceInstr(h_unify_h_fsttmp)
#ifdef UndefSelfRef
			temp0 = *m1ptr++;
#else
			if (Undef(temp0 = *m1ptr))
				{
				temp0 = MakeRef(m1ptr);
				TraceInstr(t_makeref)
				}
			m1ptr++;
#endif /* UndefSelfRef */
			break;
		case HeadMux(h_nxttmp0):
			TraceInstr(h_unify_h_nxttmp)
			m2 = temp0;
			goto unify_nxtvar_tmp0;
		case HeadMux(h_undefproc):
			return(ErrorNumber = UndefProcError);
		default:
			fprintf(stderr, "HeadUnifyError\n");
			return(ErrorNumber = SystemError);
		}
if (Pop((int), i) == 0)
	goto interpret;
Pop((MWPTR), m1ptr);
goto head_unify;


goal_copy:
while (--i >= 0)
	switch(GoalMux(InstrFetch(goalptr)))
		{
		case GoalMux(g_const):
			TraceInstr(g_copy_g_const)
			LopFetch(m1, goalptr);
			*m1ptr++ = m1;
			break;
		case GoalMux(g_nil):
			TraceInstr(g_copy_g_nil)
			*m1ptr++ = MakeNil;
			break;
		case GoalMux(g_list):
			TraceInstr(g_copy_g_list)
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			CreateList(m1ptr);
			i = 2;
			TraceAdd(t_g_skip_unify, 2)
			break;
		case GoalMux(g_struct):
			TraceInstr(g_copy_g_struct)
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			FetchStruct(m1ptr, goalptr, i = ArityFetch(goalptr));
			TraceAdd(t_g_skip_unify, i + 1)
			break;
		case GoalMux(g_void):
			TraceInstr(g_copy_g_void)
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case GoalMux(g_fstvar):
			TraceInstr(g_copy_g_fstvar)
			LoadGoalVar(m2ptr);
			*m2ptr = MakeRef(m1ptr);
			TraceInstr(t_makeref)
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case GoalMux(g_nxtvar):
			TraceInstr(g_copy_g_nxtvar)
			LoadGoalVar(m2ptr);
			*m1ptr++ = *m2ptr;
			break;
		case GoalMux(g_0fstvar):
			TraceInstr(g_copy_g_fstvar)
			GoalVar(0) = MakeRef(m1ptr);
			TraceInstr(t_makeref)
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case GoalMux(g_0nxtvar):
			TraceInstr(g_copy_g_nxtvar)
			*m1ptr++ = GoalVar(0);
			break;
		case GoalMux(g_1fstvar):
			TraceInstr(g_copy_g_fstvar)
			GoalVar(1) = MakeRef(m1ptr);
			TraceInstr(t_makeref)
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case GoalMux(g_1nxtvar):
			TraceInstr(g_copy_g_nxtvar)
			*m1ptr++ = GoalVar(1);
			break;
		case GoalMux(g_2fstvar):
			TraceInstr(g_copy_g_fstvar)
			GoalVar(2) = MakeRef(m1ptr);
			TraceInstr(t_makeref)
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case GoalMux(g_2nxtvar):
			TraceInstr(g_copy_g_nxtvar)
			*m1ptr++ = GoalVar(2);
			break;
		case GoalMux(g_3fstvar):
			TraceInstr(g_copy_g_fstvar)
			GoalVar(3) = MakeRef(m1ptr);
			TraceInstr(t_makeref)
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case GoalMux(g_3nxtvar):
			TraceInstr(g_copy_g_nxtvar)
			*m1ptr++ = GoalVar(3);
			break;
		default:
			fprintf(stderr, "GoalCopyError\n");
			return(ErrorNumber = SystemError);
		}
if (Pop((int), i) == 0)
	goto interpret;
Pop((MWPTR), m1ptr);
if (i > 0)
	goto goal_copy;
/* goto goal_unify; */

goal_unify:
while (++i <= 0)
	switch(GoalMux(InstrFetch(goalptr)))
		{
		case GoalMux(g_const):
			TraceInstr(g_unify_g_const)
			LopFetch(m1, goalptr);
			if (NotVal(m2 = *m1ptr++))
				{
				m2ptr = m1ptr-1;
				StructDeref(m2, m2ptr);
				if (RefUndef(m2))
					AssignBreak(m2ptr, m1)
				}
			if (m1 == m2)
				break;
			FailInstr(g_unify_g_const)
			goto fail;
		case GoalMux(g_nil):
			TraceInstr(g_unify_g_nil)
			if (NotVal(m1 = *m1ptr++))
				{
				m2ptr = m1ptr-1;
				StructDeref(m1, m2ptr);
				if (RefUndef(m1))
					AssignBreak(m2ptr, MakeNil)
				}
			if (Nil(m1))
				break;
			FailInstr(g_unify_g_nil)
			goto fail;
		case GoalMux(g_list):
			TraceInstr(g_unify_g_list)
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			if (NotVal(m1 = *m1ptr))
				{
				StructDeref(m1, m1ptr);
				if (RefUndef(m1))
					{
					Trail(m1ptr);
					CreateList(m1ptr);
					i = 2;
					goto goal_copy;
					}
				}
			if (NotList(m1))
				{
				FailInstr(g_unify_g_list)
				goto fail;
				}
			m1ptr = XtrList(m1);
			TraceInstr(t_xtrlist)
			i = -2;
			break;
		case GoalMux(g_struct):
			TraceInstr(g_unify_g_struct)
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			if (NotVal(m1 = *m1ptr))
				{
				StructDeref(m1, m1ptr);
				if (RefUndef(m1))
					{
					Trail(m1ptr);
					FetchStruct(m1ptr, goalptr, i = ArityFetch(goalptr));
					goto goal_copy;
					}
				}
			if (NotStruct(m1))
				{
				FailInstr(g_unify_g_struct)
				goto fail;
				}
			m1ptr = XtrStruct(m1);
			i = -ArityFetch(goalptr);
			UnifyStruct(m1ptr, goalptr);
			break;
		case GoalMux(g_void):
			TraceInstr(g_unify_g_void)
			m1ptr++;
			break;
		case GoalMux(g_fstvar):
			TraceInstr(g_unify_g_fstvar)
			LoadGoalVar(m2ptr);
#ifdef UndefSelfRef
			*m2ptr = *m1ptr++;
#else
			if (Undef(*m2ptr = *m1ptr++))
				{
				*m2ptr = MakeRef(m1ptr-1);
				TraceInstr(t_makeref)
				}
#endif /* UndefSelfRef */
			break;
		case GoalMux(g_nxtvar):
			TraceInstr(g_unify_g_nxtvar)
			m3ptr = m1ptr++;
			LoadGoalVar(m2ptr);
unify_g_nxtvar_0:
			if (NotVal(m1 = *m3ptr))
				{
				StructDeref(m1, m3ptr);
				if (RefUndef(m1))
					{
					if (NotVal(m2 = *m2ptr))
						{
						Deref(m2, m2ptr);
						if (RefUndef(m2))
							if (Pointsto(m3ptr, m2ptr))
								{
								TraceInstr(t_makeref)
								AssignBreak(m3ptr, MakeRef(m2ptr))
								}
							else if (Pointsto(m2ptr, m3ptr))
								{
								TraceInstr(t_makeref)
								AssignBreak(m2ptr, MakeRef(m3ptr))
								}
							else
								break;
						}
					AssignBreak(m3ptr, m2)
					}
				}
			if (NotVal(m2 = *m2ptr))
				{
				Deref(m2, m2ptr);
				if (RefUndef(m2))
					AssignBreak(m2ptr, m1)
				}
			if (m1 == m2)
				break;
			if (ListOrStruct(m1) &&	struct_unify(m1, m2))
				break;
			FailInstr(g_unify_g_nxtvar)
			goto fail;
		case GoalMux(g_0fstvar):
			TraceInstr(g_unify_g_fstvar)
#ifdef UndefSelfRef
			GoalVar(0) = *m1ptr++;
#else
			if (Undef(GoalVar(0) = *m1ptr++))
				{
				GoalVar(0) = MakeRef(m1ptr-1);
				TraceInstr(t_makeref)
				}
#endif /* UndefSelfRef */
			break;
		case GoalMux(g_0nxtvar):
			TraceInstr(g_unify_g_nxtvar)
			m3ptr = m1ptr++;
			m2ptr = &GoalVar(0);
			goto unify_g_nxtvar_0;
		case GoalMux(g_1fstvar):
			TraceInstr(g_unify_g_fstvar)
#ifdef UndefSelfRef
			GoalVar(1) = *m1ptr++;
#else
			if (Undef(GoalVar(1) = *m1ptr++))
				{
				GoalVar(1) = MakeRef(m1ptr-1);
				TraceInstr(t_makeref)
				}
#endif /* UndefSelfRef */
			break;
		case GoalMux(g_1nxtvar):
			TraceInstr(g_unify_g_nxtvar)
			m3ptr = m1ptr++;
			m2ptr = &GoalVar(1);
			goto unify_g_nxtvar_0;
		case GoalMux(g_2fstvar):
			TraceInstr(g_unify_g_fstvar)
#ifdef UndefSelfRef
			GoalVar(2) = *m1ptr++;
#else
			if (Undef(GoalVar(2) = *m1ptr++))
				{
				GoalVar(2) = MakeRef(m1ptr-1);
				TraceInstr(t_makeref)
				}
#endif /* UndefSelfRef */
			break;
		case GoalMux(g_2nxtvar):
			TraceInstr(g_unify_g_nxtvar)
			m3ptr = m1ptr++;
			m2ptr = &GoalVar(2);
			goto unify_g_nxtvar_0;
		case GoalMux(g_3fstvar):
			TraceInstr(g_unify_g_fstvar)
#ifdef UndefSelfRef
			GoalVar(3) = *m1ptr++;
#else
			if (Undef(GoalVar(3) = *m1ptr++))
				{
				GoalVar(3) = MakeRef(m1ptr-1);
				TraceInstr(t_makeref)
				}
#endif /* UndefSelfRef */
			break;
		case GoalMux(g_3nxtvar):
			TraceInstr(g_unify_g_nxtvar)
			m3ptr = m1ptr++;
			m2ptr = &GoalVar(3);
			goto unify_g_nxtvar_0;
		default:
			fprintf(stderr, "GoalUnifyError\n");
			return(ErrorNumber = SystemError);
		}
if (Pop((int), i) == 0)
	goto interpret;
Pop((MWPTR), m1ptr);
goto goal_unify;


vam1p_unify:

switch(UnifyMux(InstrFetch(goalptr)))
	{
	case UnifyMux(v1_unify_const):
		TraceInstr(v1_t_unify_const)
		LopFetch(m1, goalptr);
		if (NotVal(m2 = *m1ptr++))
			{
			m2ptr = m1ptr-1;
			StructDeref(m2, m2ptr);
			if (RefUndef(m2))
				AssignVam1pUnify(m2ptr, m1)
			}
		if (m1 == m2)
			goto vam1p_unify;
		FailInstr(v1_t_unify_const)
		goto fail;

	case UnifyMux(v1_unify_nil):
		TraceInstr(v1_t_unify_nil)
		if (NotVal(m1 = *m1ptr++))
			{
			m2ptr = m1ptr-1;
			StructDeref(m1, m2ptr);
			if (RefUndef(m1))
				AssignVam1pUnify(m2ptr, MakeNil)
			}
		if (Nil(m1))
			goto vam1p_unify;
		FailInstr(v1_t_unify_nil)
		goto fail;

	case UnifyMux(v1_unify_list):
		Push(m1ptr+1);

	case UnifyMux(v1_unify_last_list):
		TraceInstr(v1_t_unify_list)
		if (NotVal(m1 = *m1ptr))
			{
			StructDeref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				CreateList(m1ptr);
				goto vam1p_copy;
				}
			}
		if (NotList(m1))
			{
			FailInstr(v1_t_unify_list)
			goto fail;
			}
		m1ptr = XtrList(m1);
		TraceInstr(t_xtrlist)
		goto vam1p_unify;

	case UnifyMux(v1_unify_struct):
		Push(m1ptr+1);

	case UnifyMux(v1_unify_last_struct):
		TraceInstr(v1_t_unify_struct)
		if (NotVal(m1 = *m1ptr))
			{
			StructDeref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				FetchStruct(m1ptr, goalptr, ArityFetch(goalptr));
				goto vam1p_copy;
				}
			}
		if (NotStruct(m1))
			{
			FailInstr(v1_t_unify_struct)
			goto fail;
			}
		m1ptr = XtrStruct(m1);
		UnifyStruct(m1ptr, goalptr);
		goto vam1p_unify;

	case UnifyMux(v1_unify_void):
		TraceInstr(v1_t_unify_void)
		m1ptr++;
		goto vam1p_unify;

	case UnifyMux(v1_unify_fsttemp):
		TraceInstr(v1_t_unify_fsttmp)
		LoadTempVar(m2ptr);
#ifdef UndefSelfRef
		*m2ptr = *m1ptr++;
#else
		if (Undef(*m2ptr = *m1ptr++))
			{
			*m2ptr = MakeRef(m1ptr-1);
			TraceInstr(t_makeref)
			}
#endif /* UndefSelfRef */
		goto vam1p_unify;

	case UnifyMux(v1_unify_nxttemp):
		TraceInstr(v1_t_unify_nxttmp)
		LoadTempVar(m2ptr);
		m2 = *m2ptr;
		goto v_unify_nxtvar;

	case UnifyMux(v1_unify_fsttmp0):
		TraceInstr(v1_t_unify_fsttmp)
#ifdef UndefSelfRef
		temp0 = *m1ptr++;
#else
		if (Undef(temp0 = *m1ptr))
			{
			temp0 = MakeRef(m1ptr);
			TraceInstr(t_makeref)
			}
		m1ptr++;
#endif /* UndefSelfRef */
		goto vam1p_unify;

	case UnifyMux(v1_unify_nxttmp0):
		TraceInstr(v1_t_unify_nxttmp)
		m2 = temp0;
		goto v_unify_nxtvar;

	case UnifyMux(v1_unify_fstvar):
		TraceInstr(v1_t_unify_fstvar)
		LoadGoalVar(m2ptr);
#ifdef UndefSelfRef
		*m2ptr = *m1ptr++;
#else
		if (Undef(*m2ptr = *m1ptr++))
			{
			*m2ptr = MakeRef(m1ptr-1);
			TraceInstr(t_makeref)
			}
#endif /* UndefSelfRef */
		goto vam1p_unify;

	case UnifyMux(v1_unify_nxtvar):
		TraceInstr(v1_t_unify_nxtvar)
		LoadGoalVar(m2ptr);
		m2 = *m2ptr;
v_unify_nxtvar:
		m3ptr = m1ptr++;
		if (NotVal(m1 = *m3ptr))
			{
			StructDeref(m1, m3ptr);
			if (RefUndef(m1))
				{
				if (NotVal(m2))
					{
					Deref(m2, m2ptr);
					if (RefUndef(m2))
						if (Pointsto(m3ptr, m2ptr))
							{
							TraceInstr(t_makeref)
							AssignVam1pUnify(m3ptr, MakeRef(m2ptr))
							}
						else if (Pointsto(m2ptr, m3ptr))
							{
							TraceInstr(t_makeref)
							AssignVam1pUnify(m2ptr, MakeRef(m3ptr))
							}
						else
							goto vam1p_unify;
					}
				AssignVam1pUnify(m3ptr, m2)
				}
			}
		if (NotVal(m2))
			{
			Deref(m2, m2ptr);
			if (RefUndef(m2))
				AssignVam1pUnify(m2ptr, m1)
			}
		if (m1 == m2)
			goto vam1p_unify;
		if (ListOrStruct(m1) &&	struct_unify(m1, m2))
			goto vam1p_unify;
		FailInstr(v1_t_unify_nxtvar)
		goto fail;

	case UnifyMux(v1_unify_0fstvar):
		TraceInstr(v1_t_unify_fstvar)
#ifdef UndefSelfRef
		GoalVar(0) = *m1ptr++;
#else
		if (Undef(GoalVar(0) = *m1ptr++))
			{
			GoalVar(0) = MakeRef(m1ptr-1);
			TraceInstr(t_makeref)
			}
#endif /* UndefSelfRef */
		goto vam1p_unify;

	case UnifyMux(v1_unify_0nxtvar):
		TraceInstr(v1_t_unify_nxtvar)
		m2 = GoalVar(0);
		goto v_unify_nxtvar;

	case UnifyMux(v1_unify_1fstvar):
		TraceInstr(v1_t_unify_fstvar)
#ifdef UndefSelfRef
		GoalVar(1) = *m1ptr++;
#else
		if (Undef(GoalVar(1) = *m1ptr++))
			{
			GoalVar(1) = MakeRef(m1ptr-1);
			TraceInstr(t_makeref)
			}
#endif /* UndefSelfRef */
		goto vam1p_unify;

	case UnifyMux(v1_unify_1nxtvar):
		TraceInstr(v1_t_unify_nxtvar)
		m2 = GoalVar(1);
		goto v_unify_nxtvar;

	case UnifyMux(v1_unify_2fstvar):
		TraceInstr(v1_t_unify_fstvar)
#ifdef UndefSelfRef
		GoalVar(2) = *m1ptr++;
#else
		if (Undef(GoalVar(2) = *m1ptr++))
			{
			GoalVar(2) = MakeRef(m1ptr-1);
			TraceInstr(t_makeref)
			}
#endif /* UndefSelfRef */
		goto vam1p_unify;

	case UnifyMux(v1_unify_2nxtvar):
		TraceInstr(v1_t_unify_nxtvar)
		m2 = GoalVar(2);
		goto v_unify_nxtvar;

	case UnifyMux(v1_unify_3fstvar):
		TraceInstr(v1_t_unify_fstvar)
#ifdef UndefSelfRef
		GoalVar(3) = *m1ptr++;
#else
		if (Undef(GoalVar(3) = *m1ptr++))
			{
			GoalVar(3) = MakeRef(m1ptr-1);
			TraceInstr(t_makeref)
			}
#endif /* UndefSelfRef */
		goto vam1p_unify;

	case UnifyMux(v1_unify_3nxtvar):
		TraceInstr(v1_t_unify_nxtvar)
		m2 = GoalVar(3);
		goto v_unify_nxtvar;

	case UnifyMux(v1_pop):
		TraceInstr(v1_t_pop)
		Pop((MWPTR), m1ptr);
		goto vam1p_unify;

	case UnifyMux(v1_const_fstvar):
v_const_fstvar:
		LoadGoalVar(m1ptr);
		LopFetch(m1, goalptr);
		*m1ptr = m1;
		goto vam1p_unify;

	case UnifyMux(v1_const_nxtvar):
v_const_nxtvar:
		LoadGoalVar(m1ptr);
		LopFetch(m2, goalptr);
		if (NotVal(m1 = *m1ptr))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignVam1pUnify(m1ptr, m2)
			}
		if (m1 == m2)
			goto vam1p_unify;
		goto fail;

	case UnifyMux(v1_const_fsttmp):
v_const_fsttmp:
		LoadTempVar(m1ptr);
		LopFetch(m1, goalptr);
		*m1ptr = m1;
		goto vam1p_unify;

	case UnifyMux(v1_const_nxttmp):
v_const_nxttmp:
		LoadTempVar(m1ptr);
		LopFetch(m2, goalptr);
		if (NotVal(m1 = *m1ptr))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignVam1pUnify(m1ptr, m2)
			}
		if (m1 == m2)
			goto vam1p_unify;
		goto fail;

	case UnifyMux(v1_const_fsttmp0):
v_const_fsttmp0:
		LopFetch(m1, goalptr);
		temp0 = m1;
		goto vam1p_unify;

	case UnifyMux(v1_const_nxttmp0):
v_const_nxttmp0:
		LopFetch(m2, goalptr);
		if (NotVal(m1 = temp0))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignVam1pUnify(m1ptr, m2)
			}
		if (m1 == m2)
			goto vam1p_unify;
		goto fail;

	case UnifyMux(v1_nil_fstvar):
v_nil_fstvar:
		LoadGoalVar(m1ptr);
		*m1ptr = MakeNil;
		goto vam1p_unify;

	case UnifyMux(v1_nil_nxtvar):
v_nil_nxtvar:
		LoadGoalVar(m1ptr);
		if (NotVal(m1 = *m1ptr))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignVam1pUnify(m1ptr, MakeNil)
			}
		if (Nil(m1))
			goto vam1p_unify;
		goto fail;

	case UnifyMux(v1_nil_fsttmp):
v_nil_fsttmp:
		LoadTempVar(m1ptr);
		*m1ptr = MakeNil;
		goto vam1p_unify;

	case UnifyMux(v1_nil_nxttmp):
v_nil_nxttmp:
		LoadTempVar(m1ptr);
		if (NotVal(m1 = *m1ptr))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignVam1pUnify(m1ptr, MakeNil)
			}
		if (Nil(m1))
			goto vam1p_unify;
		goto fail;

	case UnifyMux(v1_nil_fsttmp0):
v_nil_fsttmp0:
		temp0 = MakeNil;
		goto vam1p_unify;

	case UnifyMux(v1_nil_nxttmp0):
v_nil_nxttmp0:
		if (NotVal(m1 = temp0))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignVam1pUnify(m1ptr, MakeNil)
			}
		if (Nil(m1))
			goto vam1p_unify;
		goto fail;

	case UnifyMux(v1_list_fstvar):
v_list_fstvar:
		LoadGoalVar(m1ptr);
		CreateList(m1ptr);
		goto vam1p_copy;

	case UnifyMux(v1_list_nxtvar):
v_list_nxtvar:
		LoadGoalVar(m1ptr);
		m1 = *m1ptr;
v_list_nxtvar_0:
		if (NotVal(m1))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				CreateList(m1ptr);
				goto vam1p_copy;
				}
			}
		if (List(m1))
			{
			m1ptr = XtrList(m1);
			TraceInstr(t_xtrlist)
			goto vam1p_unify;
			}
		goto fail;

	case UnifyMux(v1_list_fsttmp):
v_list_fsttmp:
		LoadTempVar(m1ptr);
		CreateList(m1ptr);
		goto vam1p_copy;

	case UnifyMux(v1_list_nxttmp):
v_list_nxttmp:
		LoadTempVar(m1ptr);
		m1 = *m1ptr;
		goto v_list_nxtvar_0;

	case UnifyMux(v1_list_fsttmp0):
v_list_fsttmp0:
		CreateList2(temp0, m1ptr);
		goto vam1p_copy;

	case UnifyMux(v1_list_nxttmp0):
v_list_nxttmp0:
		m1 = temp0;
		goto v_list_nxtvar_0;

	case UnifyMux(v1_struct_fstvar):
v_struct_fstvar:
		LoadGoalVar(m1ptr);
		FetchStruct(m1ptr, headptr, ArityFetch(goalptr));
		goto vam1p_copy;

	case UnifyMux(v1_struct_nxtvar):
v_struct_nxtvar:
		LoadGoalVar(m1ptr);
		m1 = *m1ptr;
v_struct_nxtvar_0:
		if (NotVal(m1))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				FetchStruct(m1ptr, goalptr, ArityFetch(goalptr));
				goto vam1p_copy;
				}
			}
		if (Struct(m1))
			{
			m1ptr = XtrStruct(m1);
			UnifyStruct(m1ptr, goalptr);
			goto vam1p_unify;
			}
		goto fail;

	case UnifyMux(v1_struct_fsttmp):
v_struct_fsttmp:
		LoadTempVar(m1ptr);
		FetchStruct(m1ptr, goalptr, ArityFetch(goalptr));
		goto vam1p_copy;

	case UnifyMux(v1_struct_nxttmp):
v_struct_nxttmp:
		LoadTempVar(m1ptr);
		m1 = *m1ptr;
		goto v_struct_nxtvar_0;

	case UnifyMux(v1_struct_fsttmp0):
v_struct_fsttmp0:
		FetchStruct4(temp0, m1ptr, goalptr, ArityFetch(goalptr));
		goto vam1p_copy;

	case UnifyMux(v1_struct_nxttmp0):
v_struct_nxttmp0:
		m1 = temp0;
		goto v_struct_nxtvar_0;

	case UnifyMux(v1_void_fstvar):
v_void_fstvar:
		LoadGoalVar(m1ptr);
		MakeCopyUndef;
		*m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto vam1p_unify;

	case UnifyMux(v1_void_fsttmp):
v_void_fsttmp:
		LoadTempVar(m1ptr);
		MakeCopyUndef;
		*m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto vam1p_unify;

	case UnifyMux(v1_void_fsttmp0):
v_void_fsttmp0:
		MakeCopyUndef;
		temp0 = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto vam1p_unify;

	case UnifyMux(v1_fstvar_fstvar):
v_fstvar_fstvar:
		LoadGoalVar(m1ptr);
		LoadGoalVar(m2ptr);
		MakeCopyUndef;
		*m2ptr = *m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto vam1p_unify;

	case UnifyMux(v1_fstvar_nxtvar):
v_fstvar_nxtvar:
		LoadGoalVar(m1ptr);
		LoadGoalVar(m2ptr);
		MakeCopyUndef;
		*m1ptr = *m2ptr;
		TraceInstr(t_makeref)
		goto vam1p_unify;

	case UnifyMux(v1_fstvar_fsttmp):
v_fstvar_fsttmp:
		LoadGoalVar(m1ptr);
		LoadTempVar(m2ptr);
		MakeCopyUndef;
		*m2ptr = *m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto vam1p_unify;

	case UnifyMux(v1_fstvar_nxttmp):
v_fstvar_nxttmp:
		LoadGoalVar(m1ptr);
		LoadTempVar(m2ptr);
		MakeCopyUndef;
		*m1ptr = *m2ptr;
		TraceInstr(t_makeref)
		goto vam1p_unify;

	case UnifyMux(v1_fstvar_fsttmp0):
v_fstvar_fsttmp0:
		LoadGoalVar(m1ptr);
		MakeCopyUndef;
		temp0 = *m1ptr = MakeRef(copyptr);
		TraceInstr(t_makeref)
		goto vam1p_unify;

	case UnifyMux(v1_fstvar_nxttmp0):
v_fstvar_nxttmp0:
		LoadGoalVar(m1ptr);
		MakeCopyUndef;
		*m1ptr = temp0;
		TraceInstr(t_makeref)
		goto vam1p_unify;

	case UnifyMux(v1_fsttmp_nxtvar):
v_fsttmp_nxtvar:
		LoadTempVar(m1ptr);
		LoadGoalVar(m2ptr);
		MakeCopyUndef;
		*m1ptr = *m2ptr;
		TraceInstr(t_makeref)
		goto vam1p_unify;

	case UnifyMux(v1_fsttmp0_nxtvar):
v_fsttmp0_nxtvar:
		LoadGoalVar(m1ptr);
		MakeCopyUndef;
		temp0 = *m1ptr;
		TraceInstr(t_makeref)
		goto vam1p_unify;

	case UnifyMux(v1_nxtvar_nxtvar):
v_nxtvar_nxtvar:
		LoadGoalVar(m1ptr);
		LoadGoalVar(m2ptr);
		m2 = *m2ptr;
v_nxtvar_nxtvar_0:
		if (NotVal(m1 = *m1ptr))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				if (NotVal(m2))
					{
					Deref(m2, m2ptr);
					if (RefUndef(m2))
						if (Pointsto(m1ptr, m2ptr))
							{
							TraceInstr(t_makeref)
							AssignVam1pUnify(m1ptr, MakeRef(m2ptr))
							}
						else if (Pointsto(m2ptr, m1ptr))
							{
							TraceInstr(t_makeref)
							AssignVam1pUnify(m2ptr, MakeRef(m1ptr))
							}
						else
							goto vam1p_unify;
					}
				AssignVam1pUnify(m1ptr, m2)
				}
			}
		if (NotVal(m2))
			{
			Deref(m2, m2ptr);
			if (RefUndef(m2))
				AssignVam1pUnify(m2ptr, m1)
			}
		if (m1 == m2)
			goto vam1p_unify;
		if (ListOrStruct(m1) &&	struct_unify(m1, m2))
			goto vam1p_unify;
		FailInstr(v1_t_nxtvar_nxtvar)
		goto fail;

	case UnifyMux(v1_nxtvar_nxttmp):
v_nxtvar_nxttmp:
		LoadGoalVar(m1ptr);
		LoadTempVar(m2ptr);
		m2 = *m2ptr;
		goto v_nxtvar_nxtvar_0;

	case UnifyMux(v1_nxtvar_nxttmp0):
v_nxtvar_nxttmp0:
		LoadGoalVar(m1ptr);
		m2 = temp0;
		goto v_nxtvar_nxtvar_0;
		
	case UnifyMux(v1_goal):
v_goal:
		ArgReset
		TraceInstr(c_goal_c_lastcall)
		goalptr -= SopRead(goalptr);
		goto call_goal_2;
		
	case UnifyMux(v1_builtin):
v_builtin:
		ArgReset
		TraceInstr(c_bip_c_lastcall)
		bipnr = SopFetch(goalptr);
		i = builtin[bipnr].bt_arity;
		TraceInstr(bipnr + MaxTrace)
		m1ptr = a;
		while (--i >= 0)
			{
			switch(HeadMux(InstrFetch(goalptr)))
				{
				case HeadMux(h_const):
					TraceInstr(t_b_const)
					LopFetch(m1, goalptr);
					*m1ptr++ = m1;
					break;
				case HeadMux(h_nil):
					TraceInstr(t_b_nil)
					*m1ptr++ = MakeNil;
					break;
				case HeadMux(h_list):
					TraceInstr(t_b_list)
					m2ptr = m1ptr++;
					Push(i);
					CreateList(m2ptr);
					i = -2;
					TraceAdd(t_bipallocsize, 2)
					goto builtin_goal_copy;
				case HeadMux(h_struct):
					TraceInstr(t_b_struct)
					m2ptr = m1ptr++;
					Push(i);
					FetchStruct(m2ptr, goalptr,
					            i = ArityFetch(goalptr));
					TraceAdd(t_bipallocsize, i + 1)
					i = -i;
					goto builtin_goal_copy;
				case HeadMux(h_void):
					TraceInstr(t_b_void)
					MakeCopyUndef;
					*m1ptr++ = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case HeadMux(h_fstvar):
					TraceInstr(t_b_fstvar)
					LoadGoalVar(m2ptr);
					TraceInstr(t_bipcopyundef)
					MakeCopyUndef;
					*m2ptr = *m1ptr++ = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case HeadMux(h_nxtvar):
					TraceInstr(t_b_nxtvar)
					LoadGoalVar(m2ptr);
					*m1ptr++ = *m2ptr;
					break;
				case HeadMux(h_fsttemp):
					TraceInstr(t_b_fsttmp)
					LoadGoalTempVar(m2ptr);
					MakeCopyUndef;
					TraceInstr(t_bipcopyundef)
					*m2ptr = *m1ptr++ = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case HeadMux(h_nxttemp):
					TraceInstr(t_b_nxttmp)
					LoadGoalTempVar(m2ptr);
					*m1ptr++ = *m2ptr;
					break;
				case HeadMux(h_fsttmp0):
					TraceInstr(t_b_fsttmp)
					MakeCopyUndef;
					TraceInstr(t_bipcopyundef)
					temp0 = *m1ptr++ = MakeRef(copyptr);
					TraceInstr(t_makeref)
					break;
				case HeadMux(h_nxttmp0):
					TraceInstr(t_b_nxttmp)
					*m1ptr++ = temp0;
					break;
				default:
					fprintf(stderr, "BuiltinArgCopyError\n");
					return(ErrorNumber = SystemError);
				}
call_builtin_goal: ;
			}
		if ((i = (*builtin[bipnr].bt_bipptr)(a)) != Success)
			if (i == Fail)
				{
				TraceInstr(t_bipfail)
				goto fail;
				}
			else
				goto bip_error_0;
		goto vam1p_unify;
		
	case UnifyMux(v1_metacall):
v_metacall:
		ArgReset
		TraceInstr(c_meta_c_lastcall)
		goalptr -= SopRead(goalptr);
		goto call_meta_2;
		
	case UnifyMux(v1_xgoal):
v_xgoal:
		ArgReset
		TraceInstr(c_xgoal_c_lastcall)
		goalptr -= SopRead(goalptr);
		goto xgoal_2;

	default:
		fprintf(stderr, "Vam1pUnifyError\n");
		return(ErrorNumber = SystemError);
	}


vam1p_copy:

switch(CopyMux(InstrFetch(goalptr)))
	{
	case CopyMux(v1_unify_const):
		TraceInstr(v1_t_unify_const)
		LopFetch(m1, goalptr);
		*m1ptr++ = m1;
		goto vam1p_copy;

	case CopyMux(v1_unify_nil):
		TraceInstr(v1_t_unify_nil)
		*m1ptr++ = MakeNil;
		goto vam1p_copy;

	case CopyMux(v1_unify_list):
		Push(-((MW) m1ptr+1));
	case CopyMux(v1_unify_last_list):
		TraceInstr(v1_t_unify_list)
		CreateList(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_struct):
		Push(-((MW) m1ptr+1));
	case CopyMux(v1_unify_last_struct):
		TraceInstr(v1_t_unify_struct)
		FetchStruct(m1ptr, goalptr, ArityFetch(goalptr));
		goto vam1p_copy;

	case CopyMux(v1_unify_void):
		TraceInstr(v1_t_unify_void)
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_fsttemp):
		TraceInstr(v1_t_unify_fsttmp)
		LoadTempVar(m2ptr);
		*m2ptr = MakeRef(m1ptr);
		TraceInstr(t_makeref)
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_nxttemp):
		TraceInstr(v1_t_unify_nxttmp)
		LoadTempVar(m2ptr);
		*m1ptr++ = *m2ptr;
		goto vam1p_copy;

	case CopyMux(v1_unify_fsttmp0):
		TraceInstr(v1_t_unify_fsttmp)
		temp0 = MakeRef(m1ptr);
		TraceInstr(t_makeref)
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_nxttmp0):
		TraceInstr(v1_t_unify_nxttmp)
		*m1ptr++ = temp0;
		goto vam1p_copy;

	case CopyMux(v1_unify_fstvar):
		TraceInstr(v1_t_unify_fstvar)
		LoadGoalVar(m2ptr);
		*m2ptr = MakeRef(m1ptr);
		TraceInstr(t_makeref)
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_nxtvar):
		TraceInstr(v1_t_unify_nxtvar)
		LoadGoalVar(m2ptr);
		*m1ptr++ = *m2ptr;
		goto vam1p_copy;

	case CopyMux(v1_unify_0fstvar):
		TraceInstr(v1_t_unify_fstvar)
		GoalVar(0) = MakeRef(m1ptr);
		TraceInstr(t_makeref)
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_0nxtvar):
		TraceInstr(v1_t_unify_nxtvar)
		*m1ptr++ = GoalVar(0);
		goto vam1p_copy;

	case CopyMux(v1_unify_1fstvar):
		TraceInstr(v1_t_unify_fstvar)
		GoalVar(1) = MakeRef(m1ptr);
		TraceInstr(t_makeref)
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_1nxtvar):
		TraceInstr(v1_t_unify_nxtvar)
		*m1ptr++ = GoalVar(1);
		goto vam1p_copy;

	case CopyMux(v1_unify_2fstvar):
		TraceInstr(v1_t_unify_fstvar)
		GoalVar(2) = MakeRef(m1ptr);
		TraceInstr(t_makeref)
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_2nxtvar):
		TraceInstr(v1_t_unify_nxtvar)
		*m1ptr++ = GoalVar(2);
		goto vam1p_copy;

	case CopyMux(v1_unify_3fstvar):
		TraceInstr(v1_t_unify_fstvar)
		GoalVar(3) = MakeRef(m1ptr);
		TraceInstr(t_makeref)
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_3nxtvar):
		TraceInstr(v1_t_unify_nxtvar)
		*m1ptr++ = GoalVar(3);
		goto vam1p_copy;

	case CopyMux(v1_pop):
		TraceInstr(v1_t_pop)
		Pop((MWPTR), m1ptr);
		if (((MW) m1ptr) > 0)
			goto vam1p_unify;
		m1ptr = (MWPTR)(-((MW) m1ptr));
		goto vam1p_copy;

	case CopyMux(v1_const_fstvar):
		goto v_const_fstvar;
	case CopyMux(v1_const_nxtvar):
		goto v_const_nxtvar;
	case CopyMux(v1_const_fsttmp):
		goto v_const_fsttmp;
	case CopyMux(v1_const_nxttmp):
		goto v_const_nxttmp;
	case CopyMux(v1_const_fsttmp0):
		goto v_const_fsttmp0;
	case CopyMux(v1_const_nxttmp0):
		goto v_const_nxttmp0;
	case CopyMux(v1_nil_fstvar):
		goto v_nil_fstvar;
	case CopyMux(v1_nil_nxtvar):
		goto v_nil_nxtvar;
	case CopyMux(v1_nil_fsttmp):
		goto v_nil_fsttmp;
	case CopyMux(v1_nil_nxttmp):
		goto v_nil_nxttmp;
	case CopyMux(v1_nil_fsttmp0):
		goto v_nil_fsttmp0;
	case CopyMux(v1_nil_nxttmp0):
		goto v_nil_nxttmp0;
	case CopyMux(v1_list_fstvar):
		goto v_list_fstvar;
	case CopyMux(v1_list_nxtvar):
		goto v_list_nxtvar;
	case CopyMux(v1_list_fsttmp):
		goto v_list_fsttmp;
	case CopyMux(v1_list_nxttmp):
		goto v_list_nxttmp;
	case CopyMux(v1_list_fsttmp0):
		goto v_list_fsttmp0;
	case CopyMux(v1_list_nxttmp0):
		goto v_list_nxttmp0;
	case CopyMux(v1_struct_fstvar):
		goto v_struct_fstvar;
	case CopyMux(v1_struct_nxtvar):
		goto v_struct_nxtvar;
	case CopyMux(v1_struct_fsttmp):
		goto v_struct_fsttmp;
	case CopyMux(v1_struct_nxttmp):
		goto v_struct_nxttmp;
	case CopyMux(v1_struct_fsttmp0):
		goto v_struct_fsttmp0;
	case CopyMux(v1_struct_nxttmp0):
		goto v_struct_nxttmp0;
	case CopyMux(v1_void_fstvar):
		goto v_void_fstvar;
	case CopyMux(v1_void_fsttmp):
		goto v_void_fsttmp;
	case CopyMux(v1_void_fsttmp0):
		goto v_void_fsttmp0;
	case CopyMux(v1_fstvar_fstvar):
		goto v_fstvar_fstvar;
	case CopyMux(v1_fstvar_nxtvar):
		goto v_fstvar_nxtvar;
	case CopyMux(v1_fstvar_fsttmp):
		goto v_fstvar_fsttmp;
	case CopyMux(v1_fstvar_nxttmp):
		goto v_fstvar_nxttmp;
	case CopyMux(v1_fstvar_fsttmp0):
		goto v_fstvar_fsttmp0;
	case CopyMux(v1_fstvar_nxttmp0):
		goto v_fstvar_nxttmp0;
	case CopyMux(v1_fsttmp_nxtvar):
		goto v_fsttmp_nxtvar;
	case CopyMux(v1_fsttmp0_nxtvar):
		goto v_fsttmp0_nxtvar;
	case CopyMux(v1_nxtvar_nxtvar):
		goto v_nxtvar_nxtvar;
	case CopyMux(v1_nxtvar_nxttmp):
		goto v_nxtvar_nxttmp;
	case CopyMux(v1_nxtvar_nxttmp0):
		goto v_nxtvar_nxttmp0;
	case CopyMux(v1_goal):
		goto v_goal;
	case CopyMux(v1_builtin):
		goto v_builtin;
	case CopyMux(v1_metacall):
		goto v_metacall;
	case CopyMux(v1_xgoal):
		goto v_xgoal;

	default:
		fprintf(stderr, "Vam1pCopyError\n");
		return(ErrorNumber = SystemError);
	}
}
