/* mi.c     91/04/12   intermediate code interpreter			  */

#include "mini.h"

#define UnifyStruct(mp, ip)	 if(*mp++ != LopRead(ip)){FailInstr(t_struct_fail) \
	     goto fail;}ip+=LopSize
#define Min(a, b)		   (((a)<(b))?(a):(b))												/* calculates the minimum of a,b */
#define LoadGoalVar(varptr)	 varptr=(MWPTR)(goalframeptr + SopFetch(goalptr))				/* puts the next local goal variable (goalptr) in the current stack frame --> at the adress varptr */
#define LoadOffsetGoalVar(o,varptr) varptr=(MWPTR)(goalframeptr + SopRead(goalptr+o))		/* puts the next local goal (goalptr + offset) variable in the current stack frame --> at the adress varptr */
#define LoadHeadVar(varptr)	 varptr=(MWPTR)(headframeptr + SopFetch(headptr))				/* puts the next local head variable (headptr) in the current stack frame --> at the adress varptr */
#define LoadTempVar(varptr)	 varptr=(MWPTR)(((CHARPTR)temp) + SopFetch(headptr))			/* puts the next temporal variable in the current stack frame --> unification */
#define LoadGoalTempVar(varptr)     varptr=(MWPTR)(((CHARPTR)temp) + SopFetch(goalptr))		/* puts the next temporal variable of a goal in the current stack frame --> unification */
#define GoalVar(offset)	     (*(((MWPTR)goalframeptr)-(3+offset)))							/* value of the local goal variable at offset offset */
#define HeadVar(offset)	     (*(((MWPTR)headframeptr)-(3+offset)))							/* value of the local head variable at offset offset */
#define TempVar(offset)	     (*(((MWPTR)temp)+(offset)))									/* value of the temporal variable at offset offset */
#define AssignInter(mptr, m)	{Trail(mptr); *mptr = (m); goto interpret;}					/* a bound variable is trailed, the next VAM2P-Code will be executed */
#define AssignVam1pUnify(mptr, m)   {Trail(mptr); *mptr = (m); goto vam1p_unify;}			/* a bound variable is trailed, the next VAM1P-Code (unify-mode) will be executed */
#define AssignVam1pCopy(mptr, m)    {Trail(mptr); *mptr = (m); goto vam1p_copy;}			/* a bound variable is trailed, the next VAM1P-Code (copy-mode) will be executed */		
#define AssignBreak(mptr, m)	{Trail(mptr); *mptr = (m); break;}							/* a bound variable is trailed, the next single pointer instruction (list, struct) will be executed */
#define Push(m)		     *(--stackptr) = (MW) (m)											/* m is pushed on the stack; stackchange: no modification */ 
#define Pop(type, m)		(m = type (*stackptr++))										/* m is popped from the stack; stackchange: no modification */
#define IndexAddress(ip, o)	 ip=((CODEPTR)(o))+LopSize										/* calculates the adress (ip) of the next instruction from the procedure block o with clause indexing */
#define ClauseAddress(ip, o)	ip= *((CODEPTR*)(o))										/* calculates the adress (ip) of the next instruction from the procedure block o without clause indexing */
#define AlternativeAddress(ip)      ip= *((CODEPTR*)(ip)-1)									/* calculates the adress (ip) of the next instruction for an alternative */



/*  intermediate code interpreter			  */
int mi_interpreter(register CODEPTR headptr)

{
register CODEPTR	goalptr;					/* current adress of goal instruction */
register MWPTR		m1ptr;						
register MW			m1, m1_V1;
register MW			i, V1_headvarcount;			/* number of local head variables in a clause with selvrecursion */
register CHARPTR	headframeptr;				/* pointer to the current headframe */
register CHARPTR	goalframeptr;				/* pointer to the current goalframe */
register MWPTR		m2ptr, m2ptr_V1;
register MW			m2, m2_V1;
register MW			temp0;
	 MWPTR			m3ptr; 
	 CODEPTR		V1_headptr, *V1_codeptr;	/* pointer to head , pointer to VAM1P-Code of selfrecursion */
	 MWPTR			V1_procptr;					/* pointer to procedure block of selfrecursion */
	 int			bipnr;						/* number of builtin predicate */
	 int			nogoal_bip;					/* true if builtin predicate is a factum else false */
	 MW				a[4];
	 MW				ErrorAtomIndex;
	 MWPTR			ErrorFunctor;
	 MWPTR			berror;
	 MW				berr;
	 MW				m3;
	 MW				temp[MAXTEMPVARS];			/* array for temporal variable block */
	 CODE			code[28];
	 CODEPTR		goalptr2;
	 CODEPTR		headptr2;
	 MWPTR			blockptr;
	 MW				ball;
	 CODEPTR		blockoutptr;
	 MW				local_copyspace_required_goal, local_copyspace_required_head;
	 int			f = 1;
	 CODEPTR		v1_xgoal_codeptr=0x0;		/* v1_xgoal_codeptr of last selfrecursion */


/* initialisation of the interpreter */
nogoal_bip = FALSE;
blockptr = 0;
m1ptr = &berr;
(void) find_atom("error", &ErrorAtomIndex);
ErrorAtomIndex = XtrAtomIndex(ErrorAtomIndex);
ErrorFunctor = find_func(ErrorAtomIndex, (MW) 2);
CreateStruct(m1ptr, ErrorFunctor, 2);
berror = copyptr;					  /* stackchange: no modification */

goalptr2 = code;

SopStore(goalptr2, 0);
SopStore(goalptr2, SIZEMW * 2);
LIncr(goalptr2);
Alternative(goalptr2) = 0;
goalptr = goalptr2;
InstrStore(goalptr2, c_builtin);
SopStore(goalptr2, bip_exit_fail);

SopStore(goalptr2, 0);
SopStore(goalptr2, SIZEMW * 2);
LIncr(goalptr2);
Alternative(goalptr2) = (MWPTR) goalptr;
goalptr = goalptr2;
InstrStore(goalptr2, c_call);
InstrStore(goalptr2, c_builtin);
SopStore(goalptr2, bip_exit_true);
SopStore(goalptr2, 0);

SopStore(goalptr2, 0);
SopStore(goalptr2, 0);
LIncr(goalptr2);
Alternative(goalptr2) = 0;
blockoutptr = goalptr2;
InstrStore(goalptr2, c_block_out);
SopStore(goalptr2, 0);

SopStore(goalptr2, 0);
SopStore(goalptr2, 0);
LIncr(goalptr2);
Alternative(goalptr2) = (MWPTR) blockoutptr;
blockoutptr = goalptr2;
InstrStore(goalptr2, c_call);
SopStore(goalptr2, 0);

/* stackptr = StackPtr;  stackchange: isn't necessary anymore */

goalframeptr = (CHARPTR) stackptr;  /* stackchange: no modification */
choicepntptr = stackptr - 6;	/* stackchange: no modification */
PushChoicePoint(goalptr, goalptr);

headframeptr = (CHARPTR) stackptr;  /* stackchange: no modification */
stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));  /* stackchange: no modification */
LocalStackCheck;
if ((Alternative(headptr)) != 0)
	{PushChoicePoint(goalptr, headptr);}

interpret:

#ifdef Ausgabe_der_stacks
		PrintEnvStack(env_file);
		PrintCopyStack(copy_file);
#endif


switch (Combine(InstrFetch(headptr),InstrFetch(goalptr)))
	{
	case Combine(h_const, g_const):				/* atom/int (long), atom/int (long) */
		ArgIncr TraceInstr("h_const_g_const")
		LopFetch(m1, headptr);
		LopFetch(m2, goalptr);
		if (m1 == m2)
			goto interpret;
		FailInstr(h_const_g_const)
		goto fail;
	case Combine(h_const, g_nil):				/* atom/int (long), no operand */
		ArgIncr TraceInstr("h_const_g_nil")
		FailInstr(h_const_g_nil)
		goto fail;
	case Combine(h_const, g_list):				/* atom/int (long), 2 operands */
		ArgIncr TraceInstr("h_const_g_list")
		FailInstr(h_const_g_list)
		goto fail;
	case Combine(h_const, g_struct):			/* atom/int (long), functor and n operands */
		ArgIncr TraceInstr("h_const_g_struct")
		FailInstr(h_const_g_struct)
		goto fail;
	case Combine(h_const, g_void):				/* atom/int (long), no operand */
		ArgIncr TraceInstr("h_const_g_void")
		LIncr(headptr);
		goto interpret;
	case Combine(h_const, g_fstvar):			/* atom/int (long), varoffset (short) */
		ArgIncr TraceInstr("h_const_g_fstvar")
		LoadGoalVar(m1ptr);
		LopFetch(m1, headptr);
		*m1ptr = m1;
		goto interpret;
	case Combine(h_const, g_nxtvar):			/* atom/int (long), varoffset (short) */
		ArgIncr TraceInstr("h_const_g_nxtvar")
		LoadGoalVar(m1ptr);
		LopFetch(m2, headptr);
		if (NotVal(m1 = *m1ptr))
			{
const_nxtvar_0:
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignInter(m1ptr, m2)
			}
const_nxtvar_1:
		if (m1 == m2)
			goto interpret;
		FailInstr(h_const_g_nxtvar)
		goto fail;
	case Combine(h_const, g_0fstvar):			/* atom/int (long), no operand */
		ArgIncr TraceInstr("h_const_g_fstvar")
		LopFetch(m1, headptr);
		GoalVar(0) = m1;
		goto interpret;
	case Combine(h_const, g_0nxtvar):			/* atom/int (long), no operand  */
		ArgIncr TraceInstr("h_const_g_nxtvar")
		LopFetch(m2, headptr);
		if (Val(m1 = GoalVar(0)))
			goto const_nxtvar_1;
		goto const_nxtvar_0;
	case Combine(h_const, g_1fstvar):			/* atom/int (long), no operand  */
		ArgIncr TraceInstr("h_const_g_fstvar")
		LopFetch(m1, headptr);
		GoalVar(1) = m1;
		goto interpret;
	case Combine(h_const, g_1nxtvar):			/* atom/int (long), no operand  */
		ArgIncr TraceInstr("h_const_g_nxtvar")
		LopFetch(m2, headptr);
		if (Val(m1 = GoalVar(1)))
			goto const_nxtvar_1;
		goto const_nxtvar_0;
	case Combine(h_const, g_2fstvar):			/* atom/int (long), no operand  */
		ArgIncr TraceInstr("h_const_g_fstvar")
		LopFetch(m1, headptr);
		GoalVar(2) = m1;
		goto interpret;
	case Combine(h_const, g_2nxtvar):			/* atom/int (long), no operand  */
		ArgIncr TraceInstr("h_const_g_nxtvar")
		LopFetch(m2, headptr);
		if (Val(m1 = GoalVar(2)))
			goto const_nxtvar_1;
		goto const_nxtvar_0;
	case Combine(h_const, g_3fstvar):			/* atom/int (long), no operand  */
		ArgIncr TraceInstr("h_const_g_fstvar")
		LopFetch(m1, headptr);
		GoalVar(3) = m1;
		goto interpret;
	case Combine(h_const, g_3nxtvar):			/* atom/int (long), no operand  */
		ArgIncr TraceInstr("h_const_g_nxtvar")
		LopFetch(m2, headptr);
		if (Val(m1 = GoalVar(3)))
			goto const_nxtvar_1;
		goto const_nxtvar_0;
	case Combine(h_nil, g_const):				/* atom/int (long), no operand  */
		ArgIncr TraceInstr("h_nil_g_const")
		FailInstr(h_nil_g_const)
		goto fail;
	case Combine(h_nil, g_nil):					/* no operand, no operand*/
		ArgIncr TraceInstr("h_nil_g_nil")
		goto interpret;
	case Combine(h_nil, g_list):				/* no operand, 2 operands*/
		ArgIncr TraceInstr("h_nil_g_list")
		FailInstr(h_nil_g_list)
		goto fail;
	case Combine(h_nil, g_struct):					/* no operand, functor and n operands*/
		ArgIncr TraceInstr("h_nil_g_struct")
		FailInstr(h_nil_g_struct)
		goto fail;
	case Combine(h_nil, g_void):					/* no operand, no operand*/
		ArgIncr TraceInstr("h_nil_g_void")
		goto interpret;
	case Combine(h_nil, g_fstvar):					/* no operand, varoffset (short)*/
		ArgIncr TraceInstr("h_nil_g_fstvar")
		LoadGoalVar(m1ptr);
		*m1ptr = MakeNil;
		goto interpret;
	case Combine(h_nil, g_nxtvar):					/* no operand, varoffset (short)*/
		ArgIncr TraceInstr("h_nil_g_nxtvar")
		LoadGoalVar(m1ptr);
		if (NotVal(m1 = *m1ptr))
			{
nil_nxtvar_0:
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignInter(m1ptr, MakeNil)
			}
nil_nxtvar_1:
		if (Nil(m1))
			goto interpret;
		FailInstr(h_nil_g_nxtvar)
		goto fail;
	case Combine(h_nil, g_0fstvar):					/* no operand, no operand*/
		ArgIncr TraceInstr("h_nil_g_fstvar")
		GoalVar(0) = MakeNil;
		goto interpret;
	case Combine(h_nil, g_0nxtvar):					/* no operand, no operand*/
		ArgIncr TraceInstr("h_nil_g_nxtvar")
		if (Val(m1 = GoalVar(0)))
			goto nil_nxtvar_1;
		goto nil_nxtvar_0;
	case Combine(h_nil, g_1fstvar):					/* no operand, no operand*/
		ArgIncr TraceInstr("h_nil_g_fstvar")
		GoalVar(1) = MakeNil;
		goto interpret;
	case Combine(h_nil, g_1nxtvar):					/* no operand, no operand*/
		ArgIncr TraceInstr("h_nil_g_nxtvar")
		if (Val(m1 = GoalVar(1)))
			goto nil_nxtvar_1;
		goto nil_nxtvar_0;
	case Combine(h_nil, g_2fstvar):					/* no operand, no operand*/
		ArgIncr TraceInstr("h_nil_g_fstvar")
		GoalVar(2) = MakeNil;
		goto interpret;
	case Combine(h_nil, g_2nxtvar):					/* no operand, no operand*/
		ArgIncr TraceInstr("h_nil_g_nxtvar")
		if (Val(m1 = GoalVar(2)))
			goto nil_nxtvar_1;
		goto nil_nxtvar_0;
	case Combine(h_nil, g_3fstvar):					/* no operand, no operand*/
		ArgIncr TraceInstr("h_nil_g_fstvar")
		GoalVar(3) = MakeNil;
		goto interpret;
	case Combine(h_nil, g_3nxtvar):					/* no operand, no operand*/
		ArgIncr TraceInstr("h_nil_g_nxtvar")
		if (Val(m1 = GoalVar(3)))
			goto nil_nxtvar_1;
		goto nil_nxtvar_0;
	case Combine(h_list, g_const):					/* 2 operands, */
		ArgIncr TraceInstr("h_list_g_const")
		FailInstr(h_list_g_const)
		goto fail;
	case Combine(h_list, g_nil):					/* 2 operands, no operand*/
		ArgIncr TraceInstr("h_list_g_nil")
		FailInstr(h_list_g_nil)
		goto fail;
	case Combine(h_list, g_list):					/* 2 operands, 2 operands*/
		ArgIncr TraceInstr("h_list_g_list")
		ArgFreeze(2)
		TraceAdd(t_g_skip_unify, 2)
		goto interpret;
	case Combine(h_list, g_struct):					/* 2 operands, functor and n operands*/
		ArgIncr TraceInstr("h_list_g_struct")
		FailInstr(h_list_g_struct)
		goto fail;
	case Combine(h_list, g_void):					/* 2 operands, no operand*/
		ArgIncr TraceInstr("h_list_g_void")
		i = 2;
head_list_skip:										/* overread list-elements */
		while (--i >= 0)
			switch(HeadMux(InstrFetch(headptr)))
				{
				case HeadMux(h_const):			/* atom/int (long) */
					LIncr(headptr);
				case HeadMux(h_nil):			/* no operand */
					break;
				case HeadMux(h_list):			/* 2 operands */
					i += 2;
					break;
				case HeadMux(h_struct):			/* functor (long) and n operands */
					i += ArityFetch(headptr);
					FirstArgIncr(headptr);
				case HeadMux(h_void):			/* no operand */
					break;
				case HeadMux(h_fstvar):			/* varoffset (short) */
					LoadHeadVar(m1ptr);
					MakeCopyUndef; 
					*m1ptr = MakeRef(copyptr);		/* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case HeadMux(h_nxtvar):			/* varoffset (short) */
				case HeadMux(h_nxttemp):		/* varoffset (short) */
					SIncr(headptr);
				case HeadMux(h_nxttmp0):		/* no operand */
					break;
				case HeadMux(h_fsttemp):		/* varoffset (short) */
					LoadTempVar(m1ptr);
					MakeCopyUndef;
					*m1ptr = MakeRef(copyptr);		/* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case HeadMux(h_fsttmp0):		/* no operand */
					MakeCopyUndef;
					temp0 = MakeRef(copyptr);	 /* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				default:
					fprintf(stderr, "HeadListSkipError\n");
					return(ErrorNumber = SystemError);
				}
		goto interpret;
	case Combine(h_list, g_fstvar):					/* 2 operands, varoffset (short) */
		ArgIncr TraceInstr("h_list_g_fstvar")
		LoadGoalVar(m1ptr);
list_fstvar:
		CreateList(m1ptr);
		i = 2;
		Push(0);
		goto head_copy;
	case Combine(h_list, g_nxtvar):					/* 2 operands, varoffset (short)*/
		ArgIncr TraceInstr("h_list_g_nxtvar")
		LoadGoalVar(m1ptr);
		if (NotVal(m1 = *m1ptr))
			{
list_nxtvar_0:
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				goto list_fstvar;
				}
			}
list_nxtvar_1:
		if (List(m1))
			{
list_nxtvar_2:
			m1ptr = XtrList(m1);
			TraceInstr("t_xtrlist")
			i = -2;
			Push(0);
			goto head_unify;
			}
		FailInstr(h_list_g_nxtvar)
		goto fail;
	case Combine(h_list, g_0fstvar):					/* 2 operands, no operand */
		ArgIncr TraceInstr("h_list_g_fstvar")
		m1ptr = &GoalVar(0);
		goto list_fstvar;
	case Combine(h_list, g_0nxtvar):					/* 2 operands, no operand */
		ArgIncr TraceInstr("h_list_g_nxtvar")
		if (Val(m1 = GoalVar(0)))
			goto list_nxtvar_1;
		goto list_nxtvar_0;
	case Combine(h_list, g_1fstvar):					/* 2 operands, no operand */
		ArgIncr TraceInstr("h_list_g_fstvar")
		m1ptr = &GoalVar(1);
		goto list_fstvar;
	case Combine(h_list, g_1nxtvar):					/* 2 operands, no operand */
		ArgIncr TraceInstr("h_list_g_nxtvar")
		if (Val(m1 = GoalVar(1)))
			goto list_nxtvar_1;
		goto list_nxtvar_0;
	case Combine(h_list, g_2fstvar):					/* 2 operands, no operand */
		ArgIncr TraceInstr("h_list_g_fstvar")
		m1ptr = &GoalVar(2);
		goto list_fstvar;
	case Combine(h_list, g_2nxtvar):					/* 2 operands, no operand */
		ArgIncr TraceInstr("h_list_g_nxtvar")
		if (Val(m1 = GoalVar(2)))
			goto list_nxtvar_1;
		goto list_nxtvar_0;
	case Combine(h_list, g_3fstvar):					/* 2 operands, no operand */
		ArgIncr TraceInstr("h_list_g_fstvar")
		m1ptr = &GoalVar(3);
		goto list_fstvar;
	case Combine(h_list, g_3nxtvar):					/* 2 operands, no operand */
		ArgIncr TraceInstr("h_list_g_nxtvar")
		if (Val(m1 = GoalVar(3)))
			goto list_nxtvar_1;
		goto list_nxtvar_0;
	case Combine(h_struct, g_const):					/* functor and n operands, atom/int (long)*/
		ArgIncr TraceInstr("h_struct_g_const")
		FailInstr(h_struct_g_const)
		goto fail;
	case Combine(h_struct, g_nil):					/* functor and n operands, no operand*/
		ArgIncr TraceInstr("h_struct_g_nil")
		FailInstr(h_struct_g_nil)
		goto fail;
	case Combine(h_struct, g_list):					/* functor and n operands, 2 operands*/
		ArgIncr TraceInstr("h_struct_g_list")
		FailInstr(h_struct_g_list)
		goto fail;
	case Combine(h_struct, g_struct):					/* functor and n operands, functor and n operands */
		ArgIncr TraceInstr("h_struct_g_struct")
		ArgFreeze(ArityFetch(headptr))
		TraceAdd(t_g_skip_unify, ArityFetch(headptr) + 1)
		CodeStructUnify(headptr, goalptr);
		goto interpret;
	case Combine(h_struct, g_void):					/* functor and n operands, no operand*/
		ArgIncr TraceInstr("h_struct_g_void")
		i = ArityFetch(headptr);
		FirstArgIncr(headptr);
		goto head_list_skip;
	case Combine(h_struct, g_fstvar):					/* functor and n operands, varoffset (short) */
		ArgIncr TraceInstr("h_struct_g_fstvar")
		LoadGoalVar(m1ptr);
struct_fstvar:
		FetchStruct(m1ptr, headptr, i = ArityFetch(headptr));
		Push(0);
		goto head_copy;
	case Combine(h_struct, g_nxtvar):					/* functor and n operands, varoffset (short) */
		ArgIncr TraceInstr("h_struct_g_nxtvar")
		LoadGoalVar(m1ptr);
		if (NotVal(m1 = *m1ptr))
			{
struct_nxtvar_0:
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				goto struct_fstvar;
				}
			}
struct_nxtvar_1:
		if (Struct(m1))
			{
struct_nxtvar_2:
			m1ptr = XtrStruct(m1);
			i = -ArityFetch(headptr);
			UnifyStruct(m1ptr, headptr);
			Push(0);
			goto head_unify;
			}
		FailInstr(h_struct_g_nxtvar)
		goto fail;
	case Combine(h_struct, g_0fstvar):					/* functor and n operands, no operand*/
		ArgIncr TraceInstr("h_struct_g_fstvar")
		m1ptr = &GoalVar(0);
		goto struct_fstvar;
	case Combine(h_struct, g_0nxtvar):					/* functor and n operands, no operand*/
		ArgIncr TraceInstr("h_struct_g_nxtvar")
		if (Val(m1 = GoalVar(0)))
			goto struct_nxtvar_1;
		goto struct_nxtvar_0;
	case Combine(h_struct, g_1fstvar):					/* functor and n operands, no operand*/
		ArgIncr TraceInstr("h_struct_g_fstvar")
		m1ptr = &GoalVar(1);
		goto struct_fstvar;
	case Combine(h_struct, g_1nxtvar):					/* functor and n operands, no operand*/
		ArgIncr TraceInstr("h_struct_g_nxtvar")
		if (Val(m1 = GoalVar(1)))
			goto struct_nxtvar_1;
		goto struct_nxtvar_0;
	case Combine(h_struct, g_2fstvar):					/* functor and n operands, no operand*/
		ArgIncr TraceInstr("h_struct_g_fstvar")
		m1ptr = &GoalVar(2);
		goto struct_fstvar;
	case Combine(h_struct, g_2nxtvar):					/* functor and n operands, no operand*/
		ArgIncr TraceInstr("h_struct_g_nxtvar")
		if (Val(m1 = GoalVar(2)))
			goto struct_nxtvar_1;
		goto struct_nxtvar_0;
	case Combine(h_struct, g_3fstvar):					/* functor and n operands, no operand*/
		ArgIncr TraceInstr("h_struct_g_fstvar")
		m1ptr = &GoalVar(3);
		goto struct_fstvar;
	case Combine(h_struct, g_3nxtvar):					/* functor and n operands, no operand*/
		ArgIncr TraceInstr("h_struct_g_nxtvar")
		if (Val(m1 = GoalVar(3)))
			goto struct_nxtvar_1;
		goto struct_nxtvar_0;
	case Combine(h_void, g_const):					/* no operand, atom/int (long)*/
		ArgIncr TraceInstr("h_void_g_const")
		LIncr(goalptr);
		goto interpret;
	case Combine(h_void, g_nil):					/* functor and n operands, no operand*/
		ArgIncr TraceInstr("h_void_g_nil")
		goto interpret;
	case Combine(h_void, g_list):					/* no operand, 2 operands */
		ArgIncr TraceInstr("h_void_g_list")
		i = 2;
		TraceAdd(t_g_skip_unify, 2)
goal_list_skip:										/* overreads list-elements */
		while (--i >= 0)
			switch(GoalMux(InstrFetch(goalptr)))
				{
				case GoalMux(g_const):				/* atom/int (long) */
					LIncr(goalptr);
				case GoalMux(g_nil):				/* no operand */
					break;
				case GoalMux(g_list):				/* 2 operands */
					i += 2;
					TraceAdd(t_g_skip_unify, 2)
					break;
				case GoalMux(g_struct):				/* functor (long) and n operands */
					TraceAdd(t_g_skip_unify, ArityFetch(goalptr) + 1)
					i += ArityFetch(goalptr);
					FirstArgIncr(goalptr);
				case GoalMux(g_void):				/* no operand */
					break;
				case GoalMux(g_fstvar):				/* varoffset (short) */
					LoadGoalVar(m1ptr);
					MakeCopyUndef;
					*m1ptr = MakeRef(copyptr);		/* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case GoalMux(g_nxtvar):				/* varoffset (short) */
					SIncr(goalptr);
					break;
				case GoalMux(g_0fstvar):			/* no operand */
					MakeCopyUndef;
					GoalVar(0) = MakeRef(copyptr);	/* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case GoalMux(g_1fstvar):			/* no operand */
					MakeCopyUndef;
					GoalVar(1) = MakeRef(copyptr);	/* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case GoalMux(g_2fstvar):			/* no operand */
					MakeCopyUndef;
					GoalVar(2) = MakeRef(copyptr);	/* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case GoalMux(g_3fstvar):			/* no operand */
					MakeCopyUndef;
					GoalVar(3) = MakeRef(copyptr);	/* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case GoalMux(g_0nxtvar):			/* no operand */
				case GoalMux(g_1nxtvar):
				case GoalMux(g_2nxtvar):
				case GoalMux(g_3nxtvar):
					break;
				default:
					fprintf(stderr, "GoalListSkipError\n");
					return(ErrorNumber = SystemError);
				}
		goto interpret;
	case Combine(h_void, g_struct):					/* no operand, functor and n operands*/
		ArgIncr TraceInstr("h_void_g_struct")
		i = ArityFetch(goalptr);
		TraceAdd(t_g_skip_unify, i + 1)
		FirstArgIncr(goalptr);
		goto goal_list_skip;
	case Combine(h_void, g_void):					/* no operand, no operand*/
		ArgIncr TraceInstr("h_void_g_void")
		goto interpret;
	case Combine(h_void, g_fstvar):					/* no operand, varoffset (short)*/
		ArgIncr TraceInstr("h_void_g_fstvar")
		LoadGoalVar(m1ptr);
		MakeCopyUndef;
		*m1ptr = MakeRef(copyptr);					/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_void, g_nxtvar):					/* no operand, varoffset (short) */
		ArgIncr TraceInstr("h_void_g_nxtvar")
		SIncr(goalptr);
		goto interpret;
	case Combine(h_void, g_0fstvar):				/* no operand, no operand*/
		ArgIncr TraceInstr("h_void_g_fstvar")
		MakeCopyUndef;
		GoalVar(0) = MakeRef(copyptr);				/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_void, g_1fstvar):			/* no operand, no operand*/
		ArgIncr TraceInstr("h_void_g_fstvar")
		MakeCopyUndef;
		GoalVar(1) = MakeRef(copyptr);			/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_void, g_2fstvar):			/* no operand, no operand*/
		ArgIncr TraceInstr("h_void_g_fstvar")
		MakeCopyUndef;
		GoalVar(2) = MakeRef(copyptr);			/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_void, g_3fstvar):			/* no operand, no operand*/
		ArgIncr TraceInstr("h_void_g_fstvar")
		MakeCopyUndef;
		GoalVar(3) = MakeRef(copyptr);			/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_void, g_0nxtvar):			/* no operand, no operand*/
	case Combine(h_void, g_1nxtvar):
	case Combine(h_void, g_2nxtvar):
	case Combine(h_void, g_3nxtvar):
		ArgIncr TraceInstr("h_void_g_nxtvar")
		goto interpret;
	case Combine(h_fstvar, g_const):			/* varoffset (short), atom/int (long) */
		ArgIncr TraceInstr("h_fstvar_g_const")
		LoadHeadVar(m1ptr);
fstvar_const:
		LopFetch(m1, goalptr);
		*m1ptr = m1;
		goto interpret;
	case Combine(h_fstvar, g_nil):				/* varoffset (short), no operand*/
		ArgIncr TraceInstr("h_fstvar_g_nil")
		LoadHeadVar(m1ptr);
fstvar_nil:
		*m1ptr = MakeNil;
		goto interpret;
	case Combine(h_fstvar, g_list):				/* varoffset (short), 2 operands */
		ArgIncr TraceInstr("h_fstvar_g_list")
		LoadHeadVar(m1ptr);
fstvar_list:
		CreateList(m1ptr);
		i = 2;
		Push(0);
		goto goal_copy;
	case Combine(h_fstvar, g_struct):			/* varoffset (short), functor and n operands */
		ArgIncr TraceInstr("h_fstvar_g_struct")
		LoadHeadVar(m1ptr);
fstvar_struct:
		FetchStruct(m1ptr, goalptr, i = ArityFetch(goalptr));
		Push(0);
		goto goal_copy;
	case Combine(h_fstvar, g_void):				/* varoffset (short), no operand */
		ArgIncr TraceInstr("h_fstvar_g_void")
		LoadHeadVar(m1ptr);
fstvar_void:
		MakeCopyUndef;
		*m1ptr = MakeRef(copyptr);				/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fstvar, g_fstvar):			/* varoffset (short), varoffset (short) */
		ArgIncr TraceInstr("h_fstvar_g_fstvar")
		LoadHeadVar(m1ptr);
fstvar_fstvar:
		LoadGoalVar(m2ptr);
		MakeCopyUndef;
		*m2ptr = *m1ptr = MakeRef(copyptr);		/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fstvar, g_nxtvar):			/* varoffset (short), varoffset (short) */
		ArgIncr TraceInstr("h_fstvar_g_nxtvar")
		LoadHeadVar(m1ptr);
fstvar_nxtvar:
		LoadGoalVar(m2ptr);
		*m1ptr = *m2ptr;
		ReduceDeref(*m2ptr, m1)
		goto interpret;
	case Combine(h_fstvar, g_0fstvar):			/* varoffset (short), no operand */
		ArgIncr TraceInstr("h_fstvar_g_fstvar")
		LoadHeadVar(m1ptr);
		MakeCopyUndef;
		GoalVar(0) = *m1ptr = MakeRef(copyptr);	/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fstvar, g_0nxtvar):			/* varoffset (short), no operand */
		ArgIncr TraceInstr("h_fstvar_g_nxtvar")
		LoadHeadVar(m1ptr);
		*m1ptr = GoalVar(0);
		ReduceDeref(GoalVar(0), m1)
		goto interpret;
	case Combine(h_fstvar, g_1fstvar):			/* varoffset (short), no operand */
		ArgIncr TraceInstr("h_fstvar_g_fstvar")
		LoadHeadVar(m1ptr);
		MakeCopyUndef;
		GoalVar(1) = *m1ptr = MakeRef(copyptr);	/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fstvar, g_1nxtvar):			/* varoffset (short), no operand */
		ArgIncr TraceInstr("h_fstvar_g_nxtvar")
		LoadHeadVar(m1ptr);
		*m1ptr = GoalVar(1);
		ReduceDeref(GoalVar(1), m1)
		goto interpret;
	case Combine(h_fstvar, g_2fstvar):			/* varoffset (short), no operand */
		ArgIncr TraceInstr("h_fstvar_g_fstvar")
		LoadHeadVar(m1ptr);
		MakeCopyUndef;
		GoalVar(2) = *m1ptr = MakeRef(copyptr);	/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fstvar, g_2nxtvar):			/* varoffset (short), no operand */
		ArgIncr TraceInstr("h_fstvar_g_nxtvar")
		LoadHeadVar(m1ptr);
		*m1ptr = GoalVar(2);
		ReduceDeref(GoalVar(2), m1)
		goto interpret;
	case Combine(h_fstvar, g_3fstvar):			/* varoffset (short), no operand */
		ArgIncr TraceInstr("h_fstvar_g_fstvar")
		LoadHeadVar(m1ptr);
		MakeCopyUndef;
		GoalVar(3) = *m1ptr = MakeRef(copyptr);	/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fstvar, g_3nxtvar):			/* varoffset (short), no operand */
		ArgIncr TraceInstr("h_fstvar_g_nxtvar")
		LoadHeadVar(m1ptr);
		*m1ptr = GoalVar(3);
		ReduceDeref(GoalVar(3), m1)
		goto interpret;
	case Combine(h_nxtvar, g_const):			/* varoffset (short), atom/int (long) */
		ArgIncr TraceInstr("h_nxtvar_g_const")
		LoadHeadVar(m1ptr);
nxtvar_const:
		LopFetch(m2, goalptr);
		m1 = *m1ptr;
nxtvar_const_tmp0:
		if (NotVal(m1))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignInter(m1ptr, m2)
			}
		if (m1 == m2)
			goto interpret;
		FailInstr(h_nxtvar_g_const)
		goto fail;
	case Combine(h_nxtvar, g_nil):				/* varoffset (short), no operand */
		ArgIncr TraceInstr("h_nxtvar_g_nil")
		LoadHeadVar(m1ptr);
nxtvar_nil:
		m1 = *m1ptr;
nxtvar_nil_tmp0:
		if (NotVal(m1))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignInter(m1ptr, MakeNil)
			}
		if (Nil(m1))
			goto interpret;
		FailInstr(h_nxtvar_g_nil)
		goto fail;
	case Combine(h_nxtvar, g_list):			/* varoffset (short),  2 operands */
		ArgIncr TraceInstr("h_nxtvar_g_list")
		LoadHeadVar(m1ptr);
nxtvar_list:
		m1 = *m1ptr;
nxtvar_list_tmp0:
		if (NotVal(m1))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				goto fstvar_list;
				}
			}
		if (List(m1))
			{
			m1ptr = XtrList(m1);
			TraceInstr("t_xtrlist")
			i = -2;
			TraceAdd(t_g_skip_unify, 2)
			Push(0);
			goto goal_unify;
			}
		FailInstr(h_nxtvar_g_list)
		goto fail;
	case Combine(h_nxtvar, g_struct):			/* varoffset (short),  functor and n operands*/
		ArgIncr TraceInstr("h_nxtvar_g_struct")
		LoadHeadVar(m1ptr);
nxtvar_struct:
		m1 = *m1ptr;
nxtvar_struct_tmp0:
		if (NotVal(m1))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				goto fstvar_struct;
				}
			}
		if (Struct(m1))
			{
			m1ptr = XtrStruct(m1);
			i = -ArityFetch(goalptr);
			TraceAdd(t_g_skip_unify, 1 - i)
			UnifyStruct(m1ptr, goalptr);
			Push(0);
			goto goal_unify;
			}
		FailInstr(h_nxtvar_g_struct)
		goto fail;
	case Combine(h_nxtvar, g_void):				/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxtvar_g_void")
		SIncr(headptr);
		goto interpret;
	case Combine(h_nxtvar, g_fstvar):			/* varoffset (short),  varoffset (short) */
		ArgIncr TraceInstr("h_nxtvar_g_fstvar")
		LoadHeadVar(m1ptr);
nxtvar_fstvar:
		LoadGoalVar(m2ptr);
		*m2ptr = *m1ptr;
		goto interpret;
	case Combine(h_nxtvar, g_nxtvar):			/* varoffset (short),  varoffset (short) */
		ArgIncr TraceInstr("h_nxtvar_g_nxtvar")
		LoadHeadVar(m1ptr);
nxtvar_nxtvar:
		LoadGoalVar(m2ptr);
nxtvar_nxtvar_0:
		m1 = *m1ptr;
nxtvar_nxtvar_tmp0:
		if (NotVal(m1))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
nxtvar_nxtvar_1:
				if (NotVal(m2 = *m2ptr))
					{
					Deref(m2, m2ptr);
					if (RefUndef(m2))
						if (Pointsto(m1ptr, m2ptr))
							{ 
							TraceInstr("t_makeref")
							AssignInter(m1ptr, MakeRef(m2ptr))
							}
						else if (Pointsto(m2ptr, m1ptr))
							{
							TraceInstr("t_makeref")
							AssignInter(m2ptr, MakeRef(m1ptr))
							}
						else
							goto interpret;
					}
				AssignInter(m1ptr, m2)
				}
			}
		if (NotVal(m2 = *m2ptr))
			{
			Deref(m2, m2ptr);
			if (RefUndef(m2))
				AssignInter(m2ptr, m1)
			}
		if (m1 == m2)
			goto interpret;
		if (ListOrStruct(m1) && struct_unify(m1, m2))
			goto interpret;
		FailInstr(h_nxtvar_g_nxtvar)
		goto fail;
	case Combine(h_nxtvar, g_0fstvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxtvar_g_fstvar")
		LoadHeadVar(m1ptr);
		GoalVar(0) = *m1ptr;
		goto interpret;
	case Combine(h_nxtvar, g_0nxtvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxtvar_g_nxtvar")
		LoadHeadVar(m1ptr);
		m2ptr = &GoalVar(0);
		goto nxtvar_nxtvar_0;
	case Combine(h_nxtvar, g_1fstvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxtvar_g_fstvar")
		LoadHeadVar(m1ptr);
		GoalVar(1) = *m1ptr;
		goto interpret;
	case Combine(h_nxtvar, g_1nxtvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxtvar_g_nxtvar")
		LoadHeadVar(m1ptr);
		m2ptr = &GoalVar(1);
		goto nxtvar_nxtvar_0;
	case Combine(h_nxtvar, g_2fstvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxtvar_g_fstvar")
		LoadHeadVar(m1ptr);
		GoalVar(2) = *m1ptr;
		goto interpret;
	case Combine(h_nxtvar, g_2nxtvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxtvar_g_nxtvar")
		LoadHeadVar(m1ptr);
		m2ptr = &GoalVar(2);
		goto nxtvar_nxtvar_0;
	case Combine(h_nxtvar, g_3fstvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxtvar_g_fstvar")
		LoadHeadVar(m1ptr);
		GoalVar(3) = *m1ptr;
		goto interpret;
	case Combine(h_nxtvar, g_3nxtvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxtvar_g_nxtvar")
		LoadHeadVar(m1ptr);
		m2ptr = &GoalVar(3);
		goto nxtvar_nxtvar_0;
	case Combine(h_fsttemp, g_const):			/* varoffset (short),  atom/int (long) */
		ArgIncr TraceInstr("h_fsttmp_g_const")
		LoadTempVar(m1ptr);
		goto fstvar_const;
	case Combine(h_fsttemp, g_nil):				/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_nil")
		LoadTempVar(m1ptr);
		*m1ptr = MakeNil;
		goto interpret;
	case Combine(h_fsttemp, g_list):			/* varoffset (short),  2 operands */
		ArgIncr TraceInstr("h_fsttmp_g_list")
		LoadTempVar(m1ptr);
		goto fstvar_list;
	case Combine(h_fsttemp, g_struct):			/* varoffset (short),  functor and n operands */
		ArgIncr TraceInstr("h_fsttmp_g_struct")
		LoadTempVar(m1ptr);
		goto fstvar_struct;
	case Combine(h_fsttemp, g_void):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_void")
		LoadTempVar(m1ptr);
		MakeCopyUndef;
		*m1ptr = MakeRef(copyptr);				/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fsttemp, g_fstvar):			/* varoffset (short),  varoffset (short) */
		ArgIncr TraceInstr("h_fsttmp_g_fstvar")
		LoadTempVar(m1ptr);
		goto fstvar_fstvar;
	case Combine(h_fsttemp, g_nxtvar):			/* varoffset (short),  varoffset (short) */
		ArgIncr TraceInstr("h_fsttmp_g_nxtvar")
		LoadTempVar(m1ptr);
		goto fstvar_nxtvar;
	case Combine(h_fsttemp, g_0fstvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_fstvar")
		LoadTempVar(m1ptr);
		MakeCopyUndef;
		GoalVar(0) = *m1ptr = MakeRef(copyptr);	/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fsttemp, g_0nxtvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_nxtvar")
		LoadTempVar(m1ptr);
		*m1ptr = GoalVar(0);
		ReduceDeref(GoalVar(0), m1)
		goto interpret;
	case Combine(h_fsttemp, g_1fstvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_fstvar")
		LoadTempVar(m1ptr);
		MakeCopyUndef;
		GoalVar(1) = *m1ptr = MakeRef(copyptr);	/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fsttemp, g_1nxtvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_nxtvar")
		LoadTempVar(m1ptr);
		*m1ptr = GoalVar(1);
		ReduceDeref(GoalVar(1), m1)
		goto interpret;
	case Combine(h_fsttemp, g_2fstvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_fstvar")
		LoadTempVar(m1ptr);
		MakeCopyUndef;
		GoalVar(2) = *m1ptr = MakeRef(copyptr);	/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fsttemp, g_2nxtvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_nxtvar")
		LoadTempVar(m1ptr);
		*m1ptr = GoalVar(2);
		ReduceDeref(GoalVar(2), m1)
		goto interpret;
	case Combine(h_fsttemp, g_3fstvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_fstvar")
		LoadTempVar(m1ptr);
		MakeCopyUndef;
		GoalVar(3) = *m1ptr = MakeRef(copyptr);	/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fsttemp, g_3nxtvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_nxtvar")
		LoadTempVar(m1ptr);
		*m1ptr = GoalVar(3);
		ReduceDeref(GoalVar(3), m1)
		goto interpret;
	case Combine(h_nxttemp, g_const):			/* varoffset (short),  atom/int (long) */
		ArgIncr TraceInstr("h_nxttmp_g_const")
		LoadTempVar(m1ptr);
		goto nxtvar_const;
	case Combine(h_nxttemp, g_nil):				/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_nil")
		LoadTempVar(m1ptr);
		goto nxtvar_nil;
	case Combine(h_nxttemp, g_list):			/* varoffset (short),  2 operands */
		ArgIncr TraceInstr("h_nxttmp_g_list")
		LoadTempVar(m1ptr);
		goto nxtvar_list;
	case Combine(h_nxttemp, g_struct):			/* varoffset (short),  functor and n operands */
		ArgIncr TraceInstr("h_nxttmp_g_struct")
		LoadTempVar(m1ptr);
		goto nxtvar_struct;
	case Combine(h_nxttemp, g_void):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_void")
		SIncr(headptr);
		goto interpret;
	case Combine(h_nxttemp, g_fstvar):			/* varoffset (short),  varoffset (short) */
		ArgIncr TraceInstr("h_nxttmp_g_fstvar")
		LoadTempVar(m1ptr);
		LoadGoalVar(m2ptr);
		*m2ptr = *m1ptr;
		goto interpret;
	case Combine(h_nxttemp, g_nxtvar):			/* varoffset (short),  varoffset (short) */
		ArgIncr TraceInstr("h_nxttmp_g_nxtvar")
		LoadTempVar(m1ptr);
		goto nxtvar_nxtvar;
	case Combine(h_nxttemp, g_0fstvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_fstvar")
		LoadTempVar(m1ptr);
		GoalVar(0) = *m1ptr;
		goto interpret;
	case Combine(h_nxttemp, g_0nxtvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_nxtvar")
		LoadTempVar(m1ptr);
		m2ptr = &GoalVar(0);
		goto nxtvar_nxtvar_0;
	case Combine(h_nxttemp, g_1fstvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_fstvar")
		LoadTempVar(m1ptr);
		GoalVar(1) = *m1ptr;
		goto interpret;
	case Combine(h_nxttemp, g_1nxtvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_nxtvar")
		LoadTempVar(m1ptr);
		m2ptr = &GoalVar(1);
		goto nxtvar_nxtvar_0;
	case Combine(h_nxttemp, g_2fstvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_fstvar")
		LoadTempVar(m1ptr);
		GoalVar(2) = *m1ptr;
		goto interpret;
	case Combine(h_nxttemp, g_2nxtvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_nxtvar")
		LoadTempVar(m1ptr);
		m2ptr = &GoalVar(2);
		goto nxtvar_nxtvar_0;
	case Combine(h_nxttemp, g_3fstvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_fstvar")
		LoadTempVar(m1ptr);
		GoalVar(3) = *m1ptr;
		goto interpret;
	case Combine(h_nxttemp, g_3nxtvar):			/* varoffset (short),  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_nxtvar")
		LoadTempVar(m1ptr);
		m2ptr = &GoalVar(3);
		goto nxtvar_nxtvar_0;
	case Combine(h_fsttmp0, g_const):			/* varoffset (short),  atom/int (long) */
		ArgIncr TraceInstr("h_fsttmp_g_const")
		LopFetch(m1, goalptr);
		temp0 = m1;
		goto interpret;
	case Combine(h_fsttmp0, g_nil):				/* no operand,  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_nil")
		temp0 = MakeNil;
		goto interpret;
	case Combine(h_fsttmp0, g_list):			/* no operand,  2 operands */
		ArgIncr TraceInstr("h_fsttmp_g_list")
		CreateList2(temp0, m1ptr);
		i = 2;
		Push(0);
		goto goal_copy;
	case Combine(h_fsttmp0, g_struct):			/* no operand,  functor and n operands */
		ArgIncr TraceInstr("h_fsttmp_g_struct")
		FetchStruct4(temp0, m1ptr, goalptr, i = ArityFetch(goalptr));
		Push(0);
		goto goal_copy;
	case Combine(h_fsttmp0, g_void):			/* no operand,  no operands */
		ArgIncr TraceInstr("h_fsttmp_g_void")
		MakeCopyUndef;
		temp0 = MakeRef(copyptr);				/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fsttmp0, g_fstvar):			/* no operand,  varoffset (short) */
		ArgIncr TraceInstr("h_fsttmp_g_fstvar")
		LoadGoalVar(m1ptr);
		MakeCopyUndef;
		*m1ptr = temp0 = MakeRef(copyptr);	   /* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fsttmp0, g_nxtvar):			/* no operand,  varoffset (short) */
		ArgIncr TraceInstr("h_fsttmp_g_nxtvar")
		LoadGoalVar(m1ptr);
		temp0 = *m1ptr;
		ReduceDeref(*m1ptr, m1)
		goto interpret;
	case Combine(h_fsttmp0, g_0fstvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_fstvar")
		MakeCopyUndef;
		GoalVar(0) = temp0 = MakeRef(copyptr);	/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fsttmp0, g_0nxtvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_nxtvar")
		temp0 = GoalVar(0);
		ReduceDeref(GoalVar(0), m1)
		goto interpret;
	case Combine(h_fsttmp0, g_1fstvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_fstvar")
		MakeCopyUndef;
		GoalVar(1) = temp0 = MakeRef(copyptr);	/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fsttmp0, g_1nxtvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_nxtvar")
		temp0 = GoalVar(1); 
		ReduceDeref(GoalVar(1), m1)
		goto interpret;
	case Combine(h_fsttmp0, g_2fstvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_fstvar")
		MakeCopyUndef;
		GoalVar(2) = temp0 = MakeRef(copyptr);	/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fsttmp0, g_2nxtvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_nxtvar")
		temp0 = GoalVar(2);
		ReduceDeref(GoalVar(2), m1)
		goto interpret;
	case Combine(h_fsttmp0, g_3fstvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_fstvar")
		MakeCopyUndef;
		GoalVar(3) = temp0 = MakeRef(copyptr);	/* stackchange: no modification */
		TraceInstr("t_makeref")
		goto interpret;
	case Combine(h_fsttmp0, g_3nxtvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_fsttmp_g_nxtvar")
		temp0 = GoalVar(3);
		ReduceDeref(GoalVar(3), m1)
		goto interpret;
	case Combine(h_nxttmp0, g_const):			/* no operand,  atom/int (long) */
		ArgIncr TraceInstr("h_nxttmp_g_const")
		LopFetch(m2, goalptr);
		m1 = temp0;
		goto nxtvar_const_tmp0;
	case Combine(h_nxttmp0, g_nil):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_nil")
		m1 = temp0;
		goto nxtvar_nil_tmp0;
	case Combine(h_nxttmp0, g_list):			/* no operand,  2 operands */
		ArgIncr TraceInstr("h_nxttmp_g_list")
		m1 = temp0;
		goto nxtvar_list_tmp0;
	case Combine(h_nxttmp0, g_struct):			/* no operand,  functor and n operands */
		ArgIncr TraceInstr("h_nxttmp_g_struct")
		m1 = temp0;
		goto nxtvar_struct_tmp0;
	case Combine(h_nxttmp0, g_void):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_void")
		goto interpret;
	case Combine(h_nxttmp0, g_fstvar):			/* no operand,  varoffset (short) */
		ArgIncr TraceInstr("h_nxttmp_g_fstvar")
		LoadGoalVar(m1ptr);
		*m1ptr = temp0;
		goto interpret;
	case Combine(h_nxttmp0, g_nxtvar):			/* no operand,  varoffset (short) */
		ArgIncr TraceInstr("h_nxttmp_g_nxtvar")
		m1 = temp0;
		LoadGoalVar(m2ptr);
		goto nxtvar_nxtvar_tmp0;
	case Combine(h_nxttmp0, g_0fstvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_fstvar")
		GoalVar(0) = temp0;
		goto interpret;
	case Combine(h_nxttmp0, g_0nxtvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_nxtvar")
		m1 = temp0;
		m2ptr = &GoalVar(0);
		goto nxtvar_nxtvar_tmp0;
	case Combine(h_nxttmp0, g_1fstvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_fstvar")
		GoalVar(1) = temp0;
		goto interpret;
	case Combine(h_nxttmp0, g_1nxtvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_nxtvar")
		m1 = temp0;
		m2ptr = &GoalVar(1);
		goto nxtvar_nxtvar_tmp0;
	case Combine(h_nxttmp0, g_2fstvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_fstvar")
		GoalVar(2) = temp0;
		goto interpret;
	case Combine(h_nxttmp0, g_2nxtvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_nxtvar")
		m1 = temp0;
		m2ptr = &GoalVar(2);
		goto nxtvar_nxtvar_tmp0;
	case Combine(h_nxttmp0, g_3fstvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_fstvar")
		GoalVar(3) = temp0;
		goto interpret;
	case Combine(h_nxttmp0, g_3nxtvar):			/* no operand,  no operand */
		ArgIncr TraceInstr("h_nxttmp_g_nxtvar")
		m1 = temp0;
		m2ptr = &GoalVar(3);
		goto nxtvar_nxtvar_tmp0;
	case Combine(h_undefproc, g_const):
	case Combine(h_undefproc, g_nil):
	case Combine(h_undefproc, g_list):
	case Combine(h_undefproc, g_struct):
	case Combine(h_undefproc, g_void):
	case Combine(h_undefproc, g_fstvar):
	case Combine(h_undefproc, g_nxtvar):
	case Combine(h_undefproc, g_0fstvar):
	case Combine(h_undefproc, g_0nxtvar):
	case Combine(h_undefproc, g_1fstvar):
	case Combine(h_undefproc, g_1nxtvar):
	case Combine(h_undefproc, g_2fstvar):
	case Combine(h_undefproc, g_2nxtvar):
	case Combine(h_undefproc, g_3fstvar):
	case Combine(h_undefproc, g_3nxtvar):
	case Combine(c_undefproc, c_call):
	case Combine(c_undefproc, c_lastcall):
	case Combine(c_undefproc, c_v1_lastcall):
undef_proc:
		SDecr(goalptr);
		LDecr(goalptr);
		LopFetch(m1, goalptr);
		m1ptr = ProcFunctor((MWPTR) m1);
		fprintf(stderr, "%s/%d\n", IndexPtr(FunctIndex(m1ptr)),
					   (int) FunctArity(m1ptr));
		return(ErrorNumber = UndefProcError);
	case Combine(c_goal, c_call):
		ArgReset
		TraceInstr("c_goal_c_call")
		*(((MWPTR) headframeptr) - 2) = (MW) goalframeptr;
		*(((MWPTR) headframeptr) - 1) = (MW) goalptr;
		SIncr(headptr);
		goto call_goal_1;
	case Combine(c_1_goal, c_call):
	case Combine(c_2_goal, c_call):
	case Combine(c_3_goal, c_call):
	case Combine(c_4_goal, c_call):
		ArgReset
		TraceInstr("c_goal_c_call")
		*(((MWPTR) headframeptr) - 2) = (MW) goalframeptr;
		*(((MWPTR) headframeptr) - 1) = (MW) goalptr;
call_goal_1:
		goalframeptr = headframeptr;
		goalptr = headptr;
call_goal_2:
		LopFetch(m1,goalptr);
		ClauseAddress(headptr, m1);
call_goal_3:
V1_call_goal_3: 
		headframeptr = (CHARPTR) stackptr;				 /* stackchange: no modification */
		stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));      /* stackchange: no modification */

#ifdef space
		LopFetch(local_copyspace_required_goal, goalptr);
		read_header_copyspace_required(headptr);
		Tracerequiredcopyspace(local_copyspace_required_head);
		Tracerequiredcopyspace(local_copyspace_required_goal);
		/*  don't check environment stack */
		/* NewLocalStackCheck(local_copyspace_required_head + local_copyspace_required_goal); */
		LocalStackCheck;
		NewCopyCheck(local_copyspace_required_head + local_copyspace_required_goal);
#else		
		LocalStackCheck;
#endif

		TraceFrame(FrameSize(headptr))
		if (Alternative(headptr))
			{
			TraceChoice(ComputeArgs(goalptr))
call_goal_4:
			PushChoicePoint(goalptr, headptr);
			}
		TraceStacks
		ReSetRepush
		goto interpret;
	case Combine(c_goal, c_lastcall):
		ArgReset
		TraceInstr("c_goal_c_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			SIncr(headptr);
			goto call_goal_1;
			}
		i = SopFetch(headptr);
		m1ptr = stackptr + i;							/* stackchange: no modification */
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));     /* stackchange: no modification */
		m2ptr = stackptr + i;							/* stackchange: no modification */
		while (--i >= 0)
			*(--m2ptr) = *(--m1ptr);
		goalptr = headptr;
		goto call_goal_2;
	case Combine(c_1_goal, c_lastcall):
		ArgReset
		TraceInstr("c_goal_c_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_goal_1;
			}
		m1ptr = stackptr;							    /* stackchange: no modification */
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));     /* stackchange: no modification */
		*stackptr = *m1ptr;							  /* stackchange: no modification */
		goalptr = headptr;
		goto call_goal_2;
	case Combine(c_2_goal, c_lastcall):
		ArgReset
		TraceInstr("c_goal_c_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_goal_1;
			}
		m1ptr = stackptr;							     /* stackchange: no modification */
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));      /* stackchange: no modification */
		*(stackptr + 1) = *(m1ptr + 1);					       /* stackchange: no modification */
		*stackptr = *m1ptr;							   /* stackchange: no modification */
		goalptr = headptr;
		goto call_goal_2;
	case Combine(c_3_goal, c_lastcall):
		ArgReset
		TraceInstr("c_goal_c_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_goal_1;
			}			     
		m1ptr = stackptr;							     /* stackchange: no modification */
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));      /* stackchange: no modification */
		*(stackptr + 2) = *(m1ptr + 2);					       /* stackchange: no modification */
		*(stackptr + 1) = *(m1ptr + 1);					       /* stackchange: no modification */
		*stackptr = *m1ptr;							   /* stackchange: no modification */
		goalptr = headptr;
		goto call_goal_2;
	case Combine(c_4_goal, c_lastcall):
		ArgReset
		TraceInstr("c_goal_c_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_goal_1;
			}
		m1ptr = stackptr;							     /* stackchange: no modification */
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));      /* stackchange: no modification */
		*(stackptr + 3) = *(m1ptr + 3);					       /* stackchange: no modification */
		*(stackptr + 2) = *(m1ptr + 2);					       /* stackchange: no modification */
		*(stackptr + 1) = *(m1ptr + 1);					       /* stackchange: no modification */
		*stackptr = *m1ptr;							   /* stackchange: no modification */
		goalptr = headptr;
		goto call_goal_2;

/*==================================================================================*/
/* v1-lastcall - combines */
/*==================================================================================*/		
/* no stack frame creation on environment stack*/
	case Combine(c_goal, c_v1_lastcall): 
		ArgReset
		TraceInstr("c_goal_c_v1_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			SIncr(headptr);
			goto call_goal_1;
			}
		i = SopFetch(headptr);
		goalptr = headptr;
		goto call_goal_2;
	case Combine(c_1_goal, c_v1_lastcall):
		ArgReset
		TraceInstr("c_goal_c_v1_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_goal_1;
			}
		goalptr = headptr;
		goto call_goal_2;
	case Combine(c_2_goal, c_v1_lastcall):
		ArgReset
		TraceInstr("c_goal_c_v1_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_goal_1;
			}
		goalptr = headptr;
		goto call_goal_2;
	case Combine(c_3_goal, c_v1_lastcall):
		ArgReset
		TraceInstr("c_goal_c_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_goal_1;
			}			     
		goalptr = headptr;
		goto call_goal_2;
	case Combine(c_4_goal, c_v1_lastcall):
		ArgReset
		TraceInstr("c_goal_c_v1_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_goal_1;
			}
		goalptr = headptr;
		goto call_goal_2;
/*=================================================================================*/


	case Combine(c_nogoal, c_v1_lastcall):
	case Combine(c_nogoal, c_lastcall):
		ArgReset
		TraceInstr("c_nogoal_c_lastcall")
nogoal_lastcall:
		headframeptr = goalframeptr; 
		goalptr = (CODEPTR) (*(((MWPTR) goalframeptr) - 1));
		goalframeptr = (CHARPTR) (*(((MWPTR) goalframeptr) - 2));
#ifdef Trace
		goto nogoal_call;
#endif
	case Combine(c_nogoal, c_call):
		ArgReset
		TraceInstr("c_nogoal_c_call")
nogoal_call:
		stackptr = Min(choicepntptr, (MWPTR) headframeptr);			   /* stackchange: no modification */
nogoal_loop:
		TraceStacks
		ArgReset
		switch(ControlMux(InstrFetch(goalptr)))
			{
			case ControlMux(c_goal):
				TraceInstr("c_nogoal_c_goal")
				goto call_goal_2;
			case ControlMux(c_v1_xgoal):
				TraceInstr("c_nogoal_c_v1_xgoal")
				V1_headvarcount = SopFetch(goalptr); 
				goto V1_xgoal_2;
			case ControlMux(c_xgoal):
				TraceInstr("c_nogoal_c_xgoal")
				goto xgoal_2;
			case ControlMux(c_nogoal):
				TraceInstr("c_nogoal_c_nogoal")
				goto nogoal_lastcall;
			case ControlMux(c_cut):
				TraceInstr("c_nogoal_c_cut")
				while ((CHARPTR) choicepntptr < goalframeptr)
					DerefChoicePntPtr;
				stackptr = (MWPTR) (goalframeptr - SopFetch(goalptr)); /* stackchange: no modification */
				goto nogoal_loop;
			case ControlMux(c_builtin):
				TraceInstr("c_nogoal_c_bip")
				headframeptr = goalframeptr;
				headptr = goalptr;
				nogoal_bip = TRUE;
				goto call_builtin_0;
			case ControlMux(c_metacall):
				TraceInstr("c_nogoal_c_meta")
				goto call_meta_2;
			case ControlMux(c_block_in):
				TraceInstr("c_nogoal_c_block_in")
				goto call_block_in_2;
			case ControlMux(c_block_out):
				LoadGoalVar(m1ptr);
				blockptr = (MWPTR) BlockBlock(m1ptr);
				if ((*goalptr == c_lastcall) || (*goalptr == c_v1_lastcall))
				{
					goalptr++;
					goto nogoal_lastcall;
				}
				goto nogoal_loop;
			case ControlMux(c_exit_block):
				TraceInstr("c_nogoal_c_exit_block")
				headframeptr = goalframeptr;
				headptr = goalptr;
				goto call_exit_block_0;
			default:
				fprintf(stderr, "NogoalError\n");
				return(ErrorNumber = SystemError);
			}
	case Combine(c_cut, c_call):
		ArgReset
		TraceInstr("c_cut_c_call")
#ifdef Trace
		goto cut_lastcall;
#endif
	case Combine(c_cut, c_lastcall):
	case Combine(c_cut, c_v1_lastcall):
		ArgReset
		TraceInstr("c_cut_c_lastcall")
cut_lastcall:
		if ((CHARPTR) choicepntptr < headframeptr)
			{
			DerefChoicePntPtr;
			stackptr += 6;				     /* stackchange: no modification */
			}
		SDecr(goalptr);
		goto interpret;
	case Combine(c_builtin, c_call):
		ArgReset
		TraceInstr("c_bip_c_call")
#ifdef Trace
		goto call_builtin_0;
#endif
	case Combine(c_builtin, c_lastcall):
	case Combine(c_builtin, c_v1_lastcall):
		ArgReset
		TraceInstr("c_bip_c_lastcall")
call_builtin_0:
		bipnr = SopFetch(headptr);
call_builtin_1:
		i = builtin[bipnr].bt_arity;
		TraceInstr("bipnr + MaxTrace")
		m1ptr = a;
		while (--i >= 0)
			{
			switch(HeadMux(InstrFetch(headptr)))
				{
				case HeadMux(h_const):				/* atom/int (long) */
					TraceInstr("t_b_const")
					LopFetch(m1, headptr);
					*m1ptr++ = m1;
					break;
				case HeadMux(h_nil):				/* no operand */
					TraceInstr("t_b_nil")
					*m1ptr++ = MakeNil;
					break;
				case HeadMux(h_list):				/* 2 operands */
					TraceInstr("t_b_list")
					m2ptr = m1ptr++;
					Push(i);
					CreateList(m2ptr);
					i = -2;
					TraceAdd(t_bipallocsize, 2)
					goto builtin_head_copy;
				case HeadMux(h_struct):				/* functor and n operands */
					TraceInstr("t_b_struct")
					m2ptr = m1ptr++;
					Push(i);
					FetchStruct(m2ptr, headptr,
				    i = ArityFetch(headptr));
					TraceAdd(t_bipallocsize, i + 1)
					i = -i;
					goto builtin_head_copy;
				case HeadMux(h_void):				/* no operand */
					TraceInstr("t_b_void")
					MakeCopyUndef;
					*m1ptr++ = MakeRef(copyptr);	     /* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case HeadMux(h_fstvar):				/* varoffset (short) */
					TraceInstr("t_b_fstvar")
					LoadHeadVar(m2ptr);
					TraceInstr("t_bipcopyundef")
					MakeCopyUndef;
					*m2ptr = *m1ptr++ = MakeRef(copyptr);     /* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case HeadMux(h_nxtvar):				/* varoffset (short) */
					TraceInstr("t_b_nxtvar")
					LoadHeadVar(m2ptr);
					*m1ptr++ = *m2ptr;
					break;
				case HeadMux(h_fsttemp):			/* varoffset (short) */
					TraceInstr("t_b_fsttmp")
					LoadTempVar(m2ptr);
					MakeCopyUndef;
					TraceInstr("t_bipcopyundef")
					*m2ptr = *m1ptr++ = MakeRef(copyptr);       /* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case HeadMux(h_nxttemp):			/* varoffset (short) */
					TraceInstr("t_b_nxttmp")
					LoadTempVar(m2ptr);
					*m1ptr++ = *m2ptr;
					break;
				case HeadMux(h_fsttmp0):			/* no operand */
					TraceInstr("t_b_fsttmp")
					MakeCopyUndef;
					TraceInstr("t_bipcopyundef")
					temp0 = *m1ptr++ = MakeRef(copyptr);	 /* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case HeadMux(h_nxttmp0):			/* no operand */
					TraceInstr("t_b_nxttmp")
					*m1ptr++ = temp0;
					break;
				default:
					fprintf(stderr, "BuiltinArgCopyError\n");
					return(ErrorNumber = SystemError);
				}
call_builtin_head: ;
			}
		if ((i = (*builtin[bipnr].bt_bipptr)(a)) != Success)
			{
			nogoal_bip = FALSE;
			if (i == Fail)
				{
				TraceInstr("t_bipfail")
				goto fail;
				}
			else
				goto bip_error_0;
			}
		if (nogoal_bip)
			{
			nogoal_bip = FALSE;
			goalptr = headptr;
			goto nogoal_loop;
			}
		SDecr(goalptr);
		goto interpret;
	case Combine(c_metacall, c_call):
		ArgReset
		TraceInstr("c_meta_c_call")
		*(((MWPTR) headframeptr) - 2) = (MW) goalframeptr;
		*(((MWPTR) headframeptr) - 1) = (MW) goalptr;
call_meta_1:
		SIncr(headptr);
		goalframeptr = headframeptr;
		goalptr = headptr;
call_meta_2:
		goalptr2 = goalptr;
		SIncr(goalptr);
		SIncr(goalptr);
		LoadGoalVar(m1ptr);
call_meta_3:
		m1 = *m1ptr;
		StructDeref(m1, m1ptr);
		if (Atom(m1))
			{
			goalptr2 = goalptr;
call_meta_4:
			m1 = XtrAtomIndex(m1);
			i = 0;
			if ((m2ptr = find_func(m1, i)) == 0)
				return(ErrorNumber);
			}
		else if (Struct(m1))
			{
			m1ptr = XtrStruct(m1);
			m1 = FunctIndex(m2ptr = XtrFunctor(m1ptr));
			i = FunctArity(m2ptr);
			m1ptr = FirstArgPtr(m1ptr);
			}
		else
			return(ErrorNumber = InvalidGoalError);
		if (m2ptr == CutFunctor)
			{
			if (InstrFetch(goalptr) == c_call)
				goto nogoal_call;
			else
				goto nogoal_lastcall;
			}
		if ((bipnr = find_bip(m1, i)) >= 0)
			{
			TraceInstr("bipnr + MaxTrace")
			if ((i = (*builtin[bipnr].bt_bipptr)(m1ptr)) != Success)
				if (i == Fail)
					{
					TraceInstr("t_bipfail")
					goto fail;
					}
				else
					goto bip_error_1;
			if (InstrFetch(goalptr) == c_call)
				goto nogoal_call;
			else
				goto nogoal_lastcall;
			}
		if ((m2ptr = FunctProc(m2ptr)) != 0)
			headptr = (CODEPTR) ProcOffset(m2ptr);
		if ((m2ptr == 0) || (IsUndefProc(headptr)))
			{
			ErrorNumber = UndefProcError;
			goto bip_error_2;
			}
		headframeptr = (CHARPTR) stackptr;				 /* stackchange: no modification */
		stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));      /* stackchange: no modification */
		LocalStackCheck;
		TraceFrame(FrameSize(headptr))
		if (Alternative(headptr))
			{
			TraceChoice(i)
			PushChoicePoint(goalptr2, headptr);
			}
		TraceStacks
		ReSetRepush
		if (i == 0)
			goto interpret;
		i = -i;
		Push(0);
		goto head_unify;
	case Combine(c_metacall, c_lastcall):
	case Combine(c_metacall, c_v1_lastcall):
		ArgReset
		TraceInstr("c_meta_c_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_meta_1;
			}
		i = SopFetch(headptr);
		m1ptr = stackptr + i;						      /* stackchange: no modification */
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));   /* stackchange: no modification */
		m2ptr = stackptr + i;						      /* stackchange: no modification */
		while (--i >= 0)
			*(--m2ptr) = *(--m1ptr);
		goalptr = headptr;
		goto call_meta_2;
	case Combine(h_const, g_meta):
	case Combine(h_nil, g_meta):
	case Combine(h_list, g_meta):
	case Combine(h_struct, g_meta):
	case Combine(h_void, g_meta):
	case Combine(h_fstvar, g_meta):
	case Combine(h_nxtvar, g_meta):
	case Combine(h_fsttemp, g_meta):
	case Combine(h_nxttemp, g_meta):
	case Combine(h_fsttmp0, g_meta):
	case Combine(h_nxttmp0, g_meta):
	case Combine(c_goal, g_meta):
	case Combine(c_1_goal, g_meta):
	case Combine(c_2_goal, g_meta):
	case Combine(c_3_goal, g_meta):
	case Combine(c_4_goal, g_meta):
	case Combine(c_nogoal, g_meta):
	case Combine(c_cut, g_meta):
	case Combine(c_builtin, g_meta):
	case Combine(c_metacall, g_meta):
	case Combine(c_undefproc, g_meta):
	case Combine(c_xgoal, g_meta):
	case Combine(c_1_xgoal, g_meta):
	case Combine(c_2_xgoal, g_meta):
	case Combine(c_3_xgoal, g_meta):
	case Combine(c_4_xgoal, g_meta):
	case Combine(c_v1_xgoal, g_meta):
	case Combine(c_block_in, g_meta):
	case Combine(c_exit_block, g_meta):
		SDecr(headptr);
		if (InstrFetch(goalptr) == c_metacall)
			{
			LoadGoalVar(m1ptr);
			m1 = *m1ptr;
			StructDeref(m1, m1ptr);
			}
		else
			{
			LoadGoalVar(m1ptr);
			blockptr = m1ptr;
			m1 = *(m1ptr = &BlockCall(blockptr));
			StructDeref(m1, m1ptr);
			if (Atom(m1))
				goto interpret;
			}
		m1ptr = XtrStruct(m1);
		i = -(XtrArity(m1ptr));
		m1ptr = FirstArgPtr(m1ptr);
		Push(0);
		goto head_unify;
	case Combine(c_block_in, c_call):
		ArgReset
		TraceInstr("c_block_in_c_call")
		*(((MWPTR) headframeptr) - 2) = (MW) goalframeptr;
		*(((MWPTR) headframeptr) - 1) = (MW) goalptr;
call_block_in_1:
		SIncr(headptr);
		goalframeptr = headframeptr;
		goalptr = headptr;
call_block_in_2:
		goalptr2 = goalptr;
		SIncr(goalptr);
		SIncr(goalptr);
		LoadGoalVar(m1ptr);
		BlockCall(m1ptr) = a[0];
		BlockBall(m1ptr) = a[1];
		BlockExit(m1ptr) = a[2];
		BlockCode(m1ptr) = (MW) (goalptr + 3);				/* c_call, c_block_out, offset */
		BlockFrame(m1ptr) = (MW) goalframeptr;
		BlockStack(m1ptr) = (MW) stackptr;					/* stackchange: no modification */
		BlockTrail(m1ptr) = (MW) trail;
		BlockCopy(m1ptr) = (MW) copyptr;					/* stackchange: no modification */
		BlockBlock(m1ptr) = (MW) blockptr;
		*(--stackptr) = (MW) blockptr;						/* stackchange: no modification */
		blockptr = m1ptr;
		PushChoicePoint(blockoutptr, blockoutptr);
		m1 = *(m1ptr = a);
		StructDeref(m1, m1ptr);
		if (Atom(m1))
			goto call_meta_4;
		goto call_meta_3;
	case Combine(c_block_in, c_lastcall):
	case Combine(c_block_in, c_v1_lastcall):
		ArgReset
		TraceInstr("c_block_in_c_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto call_block_in_1;
			}
		i = SopFetch(headptr);
		m1ptr = stackptr + i;							/* stackchange: no modification */
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));     /* stackchange: no modification */
		m2ptr = stackptr + i;							/* stackchange: no modification */
		while (--i >= 0)
			*(--m2ptr) = *(--m1ptr);
		goalptr = headptr;
		goto call_block_in_2;
bip_error_0:
		m1ptr = a;
		m1 = builtin[bipnr].bt_name;
bip_error_1:
		i = builtin[bipnr].bt_arity;
bip_error_2:
		if (blockptr == 0)
			return(ErrorNumber);

#ifdef stackchange
		copyptr = copyptr + ((MWPTR) heapptr - copyptr) / 2;
#else
		copyptr = copyptr + ((MWPTR) trail - copyptr) / 2;
#endif
		
		m2ptr = berror + 2;
		if (i == 0)
			*m2ptr = MakeAtom(m1);
		else
			{
			CreateStruct(m2ptr, find_func(m1, i), i);
			ctbottom = trail;
			while (--i >= 0)
				if (var_copy_term(m1ptr++, m2ptr++) != Success)
					{
					trail = ctbottom;
					return(ErrorNumber);
					}
			trail = ctbottom;
			}
		switch (ErrorNumber)
			{
			case EndOfInputError:
				(void) find_atom("end_of_file_error", berror + 1);
				break;
			case FileOpenError:
				(void) find_atom("file_open_error", berror + 1);
				break;
			case InvalidGoalError:
				(void) find_atom("database_error", berror + 1);
				break;
			case UndefProcError:
				(void) find_atom("undefined_procedure_error", berror + 1);
				break;
			case BuiltinInstError:
				(void) find_atom("instantiation_error", berror + 1);
				break;
			case BuiltinTypeError:
				(void) find_atom("type_error", berror + 1);
				break;
			case BuiltinRangeError:
				(void) find_atom("range_error", berror + 1);
				break;
			case BuiltinOpError:
				(void) find_atom("operator_error", berror + 1);
				break;
			default:
				return(ErrorNumber);
			}
		ball = berr;
		goto call_exit_block_1;
	case Combine(c_exit_block, c_call):
		ArgReset
		TraceInstr("c_exit_block_c_call")
call_exit_block_0:
		if (blockptr == 0)
			return(ErrorNumber = NoBlockError);

#ifdef stackchange		
		copyptr = copyptr + ((MWPTR) heapptr - copyptr) / 2;
#else
		copyptr = copyptr + ((MWPTR) trail - copyptr) / 2;
#endif

		if (copy_term(&TempVar(0), &ball) != Success)
			return(ErrorNumber);
call_exit_block_1:
		while (blockptr != 0)
			{
			m1ptr = (MWPTR) trail;
			goalptr = (CODEPTR) BlockCode(blockptr);		
			goalframeptr = (CHARPTR) BlockFrame(blockptr);	  
			stackptr = (MWPTR) BlockStack(blockptr);		  /* stackchange: no modification */	      
			trail = (MWPTR*) BlockTrail(blockptr);	  
			copyptr = (MWPTR) BlockCopy(blockptr);		    /* stackchange: no modification */
			/* untrailing */
#ifdef Comp
			while (m1ptr > (MWPTR) trail)
				{
				m2ptr = XtrRef(*(--m1ptr));
				*m2ptr = MakeUndef(m2ptr);
				}
#else
			while (m1ptr > (MWPTR) trail)
				{
				m2ptr = (MWPTR)(*(--m1ptr));
				*m2ptr = MakeUndef(m2ptr);
				}
#endif  
			while (choicepntptr < stackptr)			  /* stackchange: no modification */
				DerefChoicePntPtr;

#ifdef stackchange
			if ((MWPTR) heapptr >= --copyptr)
				return(ErrorNumber = CopyOverflowError);
#else
			if ((MWPTR) trail >= --copyptr)
				return(ErrorNumber = CopyOverflowError);
#endif	

			m2ptr = copyptr;					/* stackchange: no modification */
			if (copy_term(&ball, copyptr) != Success)	       /* stackchange: no modification */
				return(ErrorNumber);
			m3ptr = &BlockBall(blockptr);
			m1ptr = &BlockExit(blockptr);
			blockptr = (MWPTR) BlockBlock(blockptr);
			if ((i = unify(m2ptr, m3ptr)) == Success)
				goto call_meta_3;
			if (i != Fail)
				return(ErrorNumber);
			}
		return(ErrorNumber = NoBlockError);
	case Combine(c_exit_block, c_lastcall):
	case Combine(c_exit_block, c_v1_lastcall):
		ArgReset
		TraceInstr("c_exit_block_c_lastcall")
		goto call_exit_block_0;
	case Combine(c_block_out, c_call):
		blockptr = (MWPTR) *stackptr;					   /* stackchange: no modification */
		goto fail;
	

/* lastcall-optimization */
	case Combine(c_xgoal, c_lastcall):
c_xgoal_c_lastcall:
		ArgReset
		TraceInstr("c_xgoal_c_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			SIncr(headptr);
			goto xgoal_1;
			}
		i = SopFetch(headptr);
		m1ptr = stackptr + i;						      /* stackchange: no modification */
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));   /* stackchange: no modification */
		m2ptr = stackptr + i;						      /* stackchange: no modification */
		while (--i >= 0)
			*(--m2ptr) = *(--m1ptr);
		goalptr = headptr;
		goto xgoal_2;
	case Combine(c_1_xgoal, c_lastcall):
c_1_xgoal_c_lastcall:
		ArgReset
		TraceInstr("c_xgoal_c_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto xgoal_1;
			}
		m1ptr = stackptr;							 /* stackchange: no modification */
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));  /* stackchange: no modification */
		*stackptr = *m1ptr;						       /* stackchange: no modification */
		goalptr = headptr;
		goto xgoal_2;
	case Combine(c_2_xgoal, c_lastcall):
c_2_xgoal_c_lastcall:
		ArgReset
		TraceInstr("c_xgoal_c_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto xgoal_1;
			}
		m1ptr = stackptr;							    /* stackchange: no modification */
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));     /* stackchange: no modification */
		*(stackptr + 1) = *(m1ptr + 1);					      /* stackchange: no modification */
		*stackptr = *m1ptr;							  /* stackchange: no modification */
		goalptr = headptr;
		goto xgoal_2;
	case Combine(c_3_xgoal, c_lastcall):
c_3_xgoal_c_lastcall:
		ArgReset
		TraceInstr("c_xgoal_c_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto xgoal_1;
			}
		m1ptr = stackptr;							    /* stackchange: no modification */
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));     /* stackchange: no modification */
		*(stackptr + 2) = *(m1ptr + 2);					      /* stackchange: no modification */
		*(stackptr + 1) = *(m1ptr + 1);					      /* stackchange: no modification */
		*stackptr = *m1ptr;							  /* stackchange: no modification */
		goalptr = headptr;		  
		goto xgoal_2;
	case Combine(c_4_xgoal, c_lastcall):
c_4_xgoal_c_lastcall:
		ArgReset
		TraceInstr("c_xgoal_c_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto xgoal_1;
			}
		m1ptr = stackptr;							   /* stackchange: no modification */
		stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));    /* stackchange: no modification */
		*(stackptr + 3) = *(m1ptr + 3);					     /* stackchange: no modification */
		*(stackptr + 2) = *(m1ptr + 2);					     /* stackchange: no modification */
		*(stackptr + 1) = *(m1ptr + 1);					     /* stackchange: no modification */
		*stackptr = *m1ptr;							 /* stackchange: no modification */
		goalptr = headptr;
		goto xgoal_2;

/***********************************************************************************/	
/*  VAM-1p-xgoal-commands */
/***********************************************************************************/	
/* no stack frame creation on environment stack */
	case Combine(c_xgoal, c_v1_lastcall):   
c_xgoal_c_v1_lastcall:
		ArgReset
		TraceInstr("c_xgoal_c_v1_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			SIncr(headptr);
			goto xgoal_1;
			}
		i = SopFetch(headptr);
		goalptr = headptr;
		goto xgoal_2;
	case Combine(c_1_xgoal, c_v1_lastcall):
c_1_xgoal_c_v1_lastcall:
		ArgReset
		TraceInstr("c_xgoal_c_v1_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto xgoal_1;
			}
		goalptr = headptr;
		goto xgoal_2;
	case Combine(c_2_xgoal, c_v1_lastcall):
c_2_xgoal_c_v1_lastcall:
		ArgReset
		TraceInstr("c_xgoal_c_v1_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto xgoal_1;
			}
		goalptr = headptr;
		goto xgoal_2;
	case Combine(c_3_xgoal, c_v1_lastcall):
c_3_xgoal_c_v1_lastcall:
		ArgReset
		TraceInstr("c_xgoal_c_v1_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto xgoal_1;
			}
		goalptr = headptr;		  
		goto xgoal_2;
	case Combine(c_4_xgoal, c_v1_lastcall):
c_4_xgoal_c_v1_lastcall:
		ArgReset
		TraceInstr("c_xgoal_c_v1_lastcall")
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			goto xgoal_1;
			}
		goalptr = headptr;
		goto xgoal_2;
/************************************************************************************************/
	case Combine(c_v1_xgoal, c_v1_lastcall): 
		goalptr = headptr; 
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			V1_headvarcount = SopFetch(goalptr); 
			goto V1_xgoal_1;
			}
		V1_headvarcount = SopFetch(goalptr); 
		goto V1_xgoal_2; 
	case Combine(c_v1_xgoal, c_lastcall): 
		ArgReset
		TraceInstr("c_xgoal_c_lastcall")
		goalptr = headptr; 
		if ((CHARPTR) choicepntptr < goalframeptr)
			{
			*(((MWPTR) headframeptr) - 1) = *(((MWPTR) goalframeptr) - 1);
			*(((MWPTR) headframeptr) - 2) = *(((MWPTR) goalframeptr) - 2);
			V1_headvarcount = SopFetch(goalptr); 
			goto V1_xgoal_1;
			}
		V1_headvarcount = SopFetch(goalptr); 
		if (V1_headvarcount > 4)
		{
			m1ptr = stackptr + i;						      /* stackchange: no modification */
			stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));   /* stackchange: no modification */
			m2ptr = stackptr + i;						      /* stackchange: no modification */
			while (--i >= 0)
				*(--m2ptr) = *(--m1ptr);
		}
		else if (V1_headvarcount == 1)
		{
			m1ptr = stackptr;							 /* stackchange: no modification */
			stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));  /* stackchange: no modification */
			*stackptr = *m1ptr;						       /* stackchange: no modification */
		}
		else if (V1_headvarcount == 2)
		{
			m1ptr = stackptr;							    /* stackchange: no modification */
			stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));     /* stackchange: no modification */
			*(stackptr + 1) = *(m1ptr + 1);					      /* stackchange: no modification */
			*stackptr = *m1ptr;							  /* stackchange: no modification */
		}
		else if (V1_headvarcount == 3)
		{
			m1ptr = stackptr;									/* stackchange: no modification */
			stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));     /* stackchange: no modification */
			*(stackptr + 2) = *(m1ptr + 2);						/* stackchange: no modification */
			*(stackptr + 1) = *(m1ptr + 1);						/* stackchange: no modification */
			*stackptr = *m1ptr;									/* stackchange: no modification */
		}
		else if (V1_headvarcount == 4)
		{
			m1ptr = stackptr;							   /* stackchange: no modification */
			stackptr = (MWPTR) ((CHARPTR) stackptr + (goalframeptr - headframeptr));    /* stackchange: no modification */
			*(stackptr + 3) = *(m1ptr + 3);					     /* stackchange: no modification */
			*(stackptr + 2) = *(m1ptr + 2);					     /* stackchange: no modification */
			*(stackptr + 1) = *(m1ptr + 1);					     /* stackchange: no modification */
			*stackptr = *m1ptr;							 /* stackchange: no modification */
		}
		else
		{
			fprintf(stderr, "SwitchV1xgoalError\n");
			return(ErrorNumber = SystemError);
		}
		headframeptr = goalframeptr;
		goto V1_xgoal_2;
/*==================================================================================*/		
	case Combine(c_v1_xgoal, c_call):
c_V1_xgoal_c_call:
		ArgReset
		TraceInstr("c_xgoal_c_call")
		*(((MWPTR) headframeptr) - 2) = (MW) goalframeptr;
		*(((MWPTR) headframeptr) - 1) = (MW) goalptr;
		goalptr = headptr; 
		V1_headvarcount = SopFetch(goalptr); 
		goto V1_xgoal_1; 
V1_xgoal_1:
		goalframeptr = headframeptr;
V1_xgoal_2:
		if (v1_xgoal_codeptr == goalptr)	/* information about recursive xgoal is known */
		{
			goalptr += 6;					/* don't read information after V1_xgoal command */
		}
		else
		{
			v1_xgoal_codeptr = goalptr;
			LopFetch(m1_V1, goalptr);		/* procpointer */
			LopFetch(m2_V1, goalptr);		/* headptr */
			V1_procptr = (MWPTR) m1_V1;		/* v1_procptr */
			V1_headptr = (CODEPTR) m2_V1;	/* v1_headptr */
			LopFetch(m3, goalptr);			/* v1_codeptr */
			V1_codeptr = ((CODEPTR*)(m3));	/* v1_codeptr */
		}
		IndexAddress(headptr, V1_procptr); 
		LoadGoalVar(m1ptr);			/* varoffset of nxtvar */

		/* clause indexing */
		if (NotVal(m1_V1 = *m1ptr))
			{
			Deref(m1_V1, m1ptr);
			if (RefUndef(m1_V1))		/* no VAM1P-code execution */
				{
				AlternativeAddress(headptr);
V1_xgoal_3:
				headframeptr = (CHARPTR) stackptr;				/* stackchange: no modification */
				stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));     /* stackchange: no modification */
		
#ifdef space				
				LopFetch(local_copyspace_required_goal, goalptr);
				read_header_copyspace_required(headptr);
				Tracerequiredcopyspace(local_copyspace_required_head);
				Tracerequiredcopyspace(local_copyspace_required_goal);
				/*  don't check environment stack */
				/* NewLocalStackCheck(local_copyspace_required_head + local_copyspace_required_goal); */
				LocalStackCheck;
				NewCopyCheck(local_copyspace_required_head + local_copyspace_required_goal);
#else
				LocalStackCheck;
#endif

				TraceFrame(FrameSize(headptr))
				if (Alternative(headptr))
					{
					TraceChoice(ComputeArgs(goalptr-2))
					PushChoicePoint((-((MW) goalptr)), headptr);
					}
				TraceStacks
				ReSetRepush
				ArgIncr
				printf("refundef\n");
				switch (HeadMux(InstrFetch(headptr))) 
					{
					case HeadMux(h_const):					/* atom/int (long) */
						TraceInstr("h_const_g_nxtvar")
						LopFetch(m2_V1, headptr);      
						m1 = m1_V1;
						AssignInter(m1ptr, m2);
					case HeadMux(h_nil):					/* no operand */
						TraceInstr("h_nil_g_nxtvar")
						m1 = m1_V1;
						AssignInter(m1ptr, MakeNil);
					case HeadMux(h_list):					/* 2 operands */
						TraceInstr("h_list_g_nxtvar")
						Trail(m1ptr);
						m1 = m1_V1;
						goto list_fstvar;
					case HeadMux(h_struct):					/* functor and n operands */
						TraceInstr("h_struct_g_nxtvar")
						Trail(m1ptr);
						m1 = m1_V1;
						goto struct_fstvar;
					case HeadMux(h_fstvar):					/* varoffset (short) */
						TraceInstr("h_fstvar_g_nxtvar")
						LoadHeadVar(m2ptr_V1);
						*m2ptr_V1 = MakeRef(m1ptr);
						TraceInstr("t_makeref")
						m1 = m1_V1;
						goto interpret;
					case HeadMux(h_void):					/* no operand */
						TraceInstr("h_void_g_nxtvar")
						m1 = m1_V1;
						goto interpret;
					case HeadMux(h_fsttemp):				/* varoffset (short) */
						TraceInstr("h_fsttmp_g_nxtvar")
						LoadTempVar(m2ptr_V1);
						*m2ptr_V1 = MakeRef(m1ptr);
						TraceInstr("t_makeref")
						m1 = m1_V1;
						goto interpret;
					case HeadMux(h_fsttmp0):				/* no operand */
						TraceInstr("h_fsttmp_g_nxtvar")
						temp0 = MakeRef(m1ptr);
						TraceInstr("t_makeref")
						m1 = m1_V1;
						goto interpret;
					case HeadMux(h_undefproc):
						m1 = m1_V1;
						goto undef_proc; 
					default:
						m1 = m1_V1;
						fprintf(stderr, "XgoalUndefError\n");
						return(ErrorNumber = SystemError);
					}
				}
			}
		if (Indexing(headptr) != x_general)     
			{
			if (List(m1_V1))
				{
				headptr = (CODEPTR) Equal(headptr);
				/* deterministic & selfrecursion --> VAM1P-Code */
				if (Alternative(headptr) == 0)
				{
					if (headptr == (CODEPTR) V1_headptr)
					{
					stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));    /* stackchange: no modification */
					LocalStackCheck;
					TraceFrame(FrameSize(headptr))
					ArgIncr
					goalptr = (CODEPTR) ((*V1_codeptr)); 
					goalptr += 2;						/* nxtvar  */
					m1ptr = XtrList(m1_V1);			
					m1 = m1_V1;
					goto vam1p_unify; 
					}
				}
				/* else --> VAM2P-Code */
				headframeptr = (CHARPTR) stackptr;									/* stackchange: no modification */
				stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));		/* stackchange: no modification */
				LocalStackCheck;
				TraceFrame(FrameSize(headptr))
				ArgIncr
				TraceInstr("h_list_g_nxtvar") 
				SIncr(headptr);
				m1ptr = XtrList(m1_V1);
				TraceInstr("t_xtrlist")
				i = -2;
				TraceStacks
				ReSetRepush
				Push(0);
				m1 = m1_V1;
				goto head_unify; 
				}
			if (Nil(m1_V1))
				{
				headptr = (CODEPTR) Greater(headptr);
				/* deterministic & selfrecursion --> VAM1P-Code */
				if (Alternative(headptr) == 0) 
				{
					if ((headptr) ==  (CODEPTR) V1_headptr)
					{
						stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));    /* stackchange: no modification */
						LocalStackCheck;
						TraceFrame(FrameSize(headptr))
						ArgIncr
						TraceInstr("h_nil_g_nxtvar")
						TraceStacks
						ReSetRepush
						m1 = m1_V1;
						goalptr = (CODEPTR) *V1_codeptr; 
						goto vam1p_unify; 
					}
				}
				/* else --> VAM2P-Code */
				headframeptr = (CHARPTR) stackptr;			       /* stackchange: no modification */
				stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));    /* stackchange: no modification */
				LocalStackCheck;
				TraceFrame(FrameSize(headptr))
				ArgIncr
				TraceInstr("h_nil_g_nxtvar")
				TraceStacks
				ReSetRepush
				m1 = m1_V1;
				SIncr(headptr);
				goto interpret; /* nondeterministic --> VAM2P-Code */
				}
			m1 = m1_V1;
			goto fail;
			}
V1_xgoal_4:
		if (ListOrStruct(m1_V1)) 
			if (List(m1_V1))
			{
				m1 = m1_V1;
				goto xfail_1;
			}
			else
				{
				m1ptr = XtrStruct(m1_V1);
				m3 = (MW) XtrFunctor(m1ptr);
				i = XtrArity(m1ptr);
				}
		else if (Nil(m1_V1))
			if ((headptr = (CODEPTR) Greater(headptr)) == 0)
				{
				TraceInstr("t_index_fail")
				m1 = m1_V1;
				goto fail;
				}
			else
			{
				m1 = m1_V1;
				goto xfail_2;
			}
		else
			m3 = m1_V1;
		headptr = (CODEPTR) Less(headptr);
		while (headptr != 0)
			{
			headptr2 = headptr;
			switch(HeadMux(InstrFetch(headptr)))
				{
				case HeadMux(h_const):
					LopFetch(m2_V1, headptr);
					if (m3 != m2_V1)
						if (m3 < m2_V1)
							{
							headptr = (CODEPTR) Less(headptr2);
							continue;
							}
						else
							{
							headptr = (CODEPTR) Greater(headptr2);
							continue;
							}
					/* deterministic & selfrecursion --> VAM1P-Code */
					if (Alternative(headptr2) == 0)
					{
						if (headptr2 == (CODEPTR) V1_headptr)
						{
							stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));		/* stackchange: no modification */
							LocalStackCheck;
							TraceStacks
							ReSetRepush
							m1 = m1_V1;
							goalptr = (CODEPTR) *V1_codeptr;
							goto vam1p_unify;
						}
					}
					/* else --> VAM2P-Code */
					headframeptr = (CHARPTR) stackptr;			      /* stackchange: no modification */
					stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));  /* stackchange: no modification */
					LocalStackCheck;
					TraceFrame(FrameSize(headptr2))
					if (Equal(headptr2))
						{
						TraceChoice(ComputeArgs(goalptr-2))
						PushChoicePoint((-((MW) goalptr)), (-((MW) headptr2)));
						}
					TraceStacks
					ReSetRepush
					ArgIncr TraceInstr("h_const_g_nxtvar")
					m1 = m1_V1;
					goto interpret; 
				case HeadMux(h_struct):
					m2_V1 = (MW) FunctorFetch(headptr);
					if (m3 != m2_V1)
						if (m3 < m2_V1)
							{
							headptr = (CODEPTR) Less(headptr2);
							continue;
							}
						else
							{
							headptr = (CODEPTR) Greater(headptr2);
							continue;
							}
					if (i != ArityFetch(headptr))
						{
						headptr = (CODEPTR) Equal(headptr2);
						continue;
						}
					/* deterministic & selfrecursion --> VAM1P-Code */
					if (Alternative(headptr2) == 0)
					{
						if (headptr2 == (CODEPTR) V1_headptr)
						{
							stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));		/* stackchange: no modification */
							LocalStackCheck;
							TraceStacks
							ReSetRepush
							m1 = m1_V1;
							goalptr = (CODEPTR) *V1_codeptr;
							goto vam1p_unify;
						}
					}
					/* else --> VAM2P-Code */
					i = -i;
					m1ptr = FirstArgPtr(m1ptr);
					FirstArgIncr(headptr);
					headframeptr = (CHARPTR) stackptr;				/* stackchange: no modification */
					stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));    /* stackchange: no modification */
					LocalStackCheck;
					TraceFrame(FrameSize(headptr2))
					if (Equal(headptr2))
						{
						TraceChoice(ComputeArgs(goalptr-2))
						PushChoicePoint((-((MW) goalptr)), (-((MW) headptr2)));
						}
					TraceStacks
					ReSetRepush
					ArgIncr TraceInstr("h_struct_g_nxtvar")
					Push(0);
					m1 = m1_V1;
					goto head_unify; 
				case HeadMux(h_fstvar):
					ArgIncr TraceInstr("h_fstvar_g_nxtvar")
					headframeptr = (CHARPTR) stackptr;				/* stackchange: no modification */
					stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));    /* stackchange: no modification */
					LocalStackCheck;
					LoadHeadVar(m1ptr);
					*m1ptr = m1_V1;
					m1 = m1_V1;
					/* deterministic & selfrecursion --> VAM1P-Code */
					if (Alternative(headptr2) == 0)
					{
						if (headptr2 == (CODEPTR) V1_headptr)
						{
							TraceStacks
							ReSetRepush
							goalptr = (CODEPTR) *V1_codeptr;
							goto vam1p_unify;
						}
					}
					/* else --> VAM2P-Code */
					goto V1_xgoal_5;
				case HeadMux(h_fsttemp):
					ArgIncr TraceInstr("h_fsttmp_g_nxtvar")
					LoadTempVar(m1ptr);
					*m1ptr = m1_V1;
					m1 = m1_V1;
					/* deterministic & selfrecursion --> VAM1P-Code */
					if (Alternative(headptr2) == 0)
					{
						if (headptr2 == (CODEPTR) V1_headptr)
						{
							stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));		/* stackchange: no modification */
							LocalStackCheck;
							TraceStacks
							ReSetRepush
							goalptr = (CODEPTR) *V1_codeptr;
							goto vam1p_unify;
						}
					}
					/* else --> VAM2P-Code */
					goto V1_xgoal_t5;
				case HeadMux(h_fsttmp0):
					ArgIncr TraceInstr("h_fsttmp_g_nxtvar")
					temp0 = m1_V1;
					m1 = m1_V1;
#ifdef Trace
					/* deterministic & selfrecursion --> VAM1P-Code */
					if (Alternative(headptr2) == 0)
					{
						if (headptr2 == (CODEPTR) V1_headptr)
						{
							stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));		/* stackchange: no modification */
							LocalStackCheck;
							TraceStacks
							ReSetRepush
							goalptr = (CODEPTR) *V1_codeptr;
							goto vam1p_unify;
						}
					}
					/* else --> VAM2P-Code */
					goto V1_xgoal_t5;
#endif
				case HeadMux(h_void):
					ArgIncr TraceInstr("h_void_g_nxtvar")

					/* deterministic & selfrecursion --> VAM1P-Code */
					if (Alternative(headptr2) == 0)
					{
						if (headptr2 == (CODEPTR) V1_headptr)
						{
							stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));		/* stackchange: no modification */
							LocalStackCheck;
							TraceStacks
							ReSetRepush
							m1 = m1_V1;
							goalptr = (CODEPTR) *V1_codeptr;
							goto vam1p_unify;
						}
					}
					/* else --> VAM2P-Code */
V1_xgoal_t5:
					headframeptr = (CHARPTR) stackptr;									/* stackchange: no modification */
					stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));		/* stackchange: no modification */
					LocalStackCheck;
V1_xgoal_5:
					TraceFrame(FrameSize(headptr2))
					if (Alternative(headptr2))
						{
						TraceChoice(ComputeArgs(goalptr-2))
						PushChoicePoint((-((MW) goalptr)), headptr2);
						}
					TraceStacks
					ReSetRepush
					m1 = m1_V1;
					goto interpret; 
				case HeadMux(h_undefproc):
					m1 = m1_V1;
					goto undef_proc; 
				default:
					m1 = m1_V1;
					fprintf(stderr, "XgoalValError\n");
					return(ErrorNumber = SystemError);
				}
			}
		m1 = m1_V1;
		TraceInstr("t_index_fail") 
		goto fail;

/*==================================================================================*/


	case Combine(c_xgoal, c_call):
c_xgoal_c_call:
		ArgReset
		TraceInstr("c_xgoal_c_call")
		*(((MWPTR) headframeptr) - 2) = (MW) goalframeptr;
		*(((MWPTR) headframeptr) - 1) = (MW) goalptr;
		SIncr(headptr);
		goto xgoal_1;
	case Combine(c_1_xgoal, c_call):
	case Combine(c_2_xgoal, c_call):
	case Combine(c_3_xgoal, c_call):
	case Combine(c_4_xgoal, c_call):
c_1_4_xgoal_c_call:
		ArgReset
		TraceInstr("c_xgoal_c_call")
		*(((MWPTR) headframeptr) - 2) = (MW) goalframeptr;
		*(((MWPTR) headframeptr) - 1) = (MW) goalptr;
xgoal_1:
		goalframeptr = headframeptr;
		goalptr = headptr;
xgoal_2:
		LopFetch(m2,goalptr);
		IndexAddress(headptr, m2);
		LoadGoalVar(m1ptr);
		/* clause indexing */
		if (NotVal(m1 = *m1ptr))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				AlternativeAddress(headptr);
xgoal_3:
				headframeptr = (CHARPTR) stackptr;				/* stackchange: no modification */
				stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));     /* stackchange: no modification */
		
#ifdef space				
				LopFetch(local_copyspace_required_goal, goalptr);
				read_header_copyspace_required(headptr);
				Tracerequiredcopyspace(local_copyspace_required_head);
				Tracerequiredcopyspace(local_copyspace_required_goal);
				/*  don't check environment stack */
				/* NewLocalStackCheck(local_copyspace_required_head + local_copyspace_required_goal); */
				LocalStackCheck;
				NewCopyCheck(local_copyspace_required_head + local_copyspace_required_goal);
#else
				LocalStackCheck;
#endif

				TraceFrame(FrameSize(headptr))
				if (Alternative(headptr))
					{
					TraceChoice(ComputeArgs(goalptr-2))
					PushChoicePoint((-((MW) goalptr)), headptr);
					}
				TraceStacks
				ReSetRepush
				ArgIncr
				switch (HeadMux(InstrFetch(headptr)))
					{
					case HeadMux(h_const):					/* atom/int (long) */
						TraceInstr("h_const_g_nxtvar")
						LopFetch(m2, headptr);
						AssignInter(m1ptr, m2);
					case HeadMux(h_nil):					/* no operand */
						TraceInstr("h_nil_g_nxtvar")
						AssignInter(m1ptr, MakeNil);
					case HeadMux(h_list):					/* 2 operands */
						TraceInstr("h_list_g_nxtvar")
						Trail(m1ptr);
						goto list_fstvar;
					case HeadMux(h_struct):					/* functor and n operands */
						TraceInstr("h_struct_g_nxtvar")
						Trail(m1ptr);
						goto struct_fstvar;
					case HeadMux(h_fstvar):					/* varoffset (short) */
						TraceInstr("h_fstvar_g_nxtvar")
						LoadHeadVar(m2ptr);
						*m2ptr = MakeRef(m1ptr);
						TraceInstr("t_makeref")
						goto interpret;
					case HeadMux(h_void):					/* no operand */
						TraceInstr("h_void_g_nxtvar")
						goto interpret;
					case HeadMux(h_fsttemp):				/* varoffset (short) */
						TraceInstr("h_fsttmp_g_nxtvar")
						LoadTempVar(m2ptr);
						*m2ptr = MakeRef(m1ptr);
						TraceInstr("t_makeref")
						goto interpret;
					case HeadMux(h_fsttmp0):				/* no operand */
						TraceInstr("h_fsttmp_g_nxtvar")
						temp0 = MakeRef(m1ptr);
						TraceInstr("t_makeref")
						goto interpret;
					case HeadMux(h_undefproc):
						goto undef_proc;
					default:
						fprintf(stderr, "XgoalUndefError\n");
						return(ErrorNumber = SystemError);
					}
				}
			}
		if (Indexing(headptr) != x_general)     /* switch */
			{
			if (List(m1))
				{
				headptr = (CODEPTR) Equal(headptr);
				headframeptr = (CHARPTR) stackptr;			       /* stackchange: no modification */
				stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));    /* stackchange: no modification */
				LocalStackCheck;
				TraceFrame(FrameSize(headptr))
				ArgIncr
				TraceInstr("h_list_g_nxtvar")
				SIncr(headptr);
				m1ptr = XtrList(m1);  
				TraceInstr("t_xtrlist")
				i = -2;
				TraceStacks
				ReSetRepush
				Push(0);
				goto head_unify;
				}
			if (Nil(m1))
				{
				headptr = (CODEPTR) Greater(headptr);
				headframeptr = (CHARPTR) stackptr;			       /* stackchange: no modification */
				stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));    /* stackchange: no modification */
				LocalStackCheck;
				TraceFrame(FrameSize(headptr))
				ArgIncr
				TraceInstr("h_nil_g_nxtvar")
				SIncr(headptr);
				TraceStacks
				ReSetRepush
				goto interpret;
				}
			goto fail;
			}
xgoal_4:
		if (ListOrStruct(m1))
			if (List(m1))
				goto xfail_1;
			else
				{
				m1ptr = XtrStruct(m1);
				m3 = (MW) XtrFunctor(m1ptr);
				i = XtrArity(m1ptr);
				}
		else if (Nil(m1))
			if ((headptr = (CODEPTR) Greater(headptr)) == 0)
				{
				TraceInstr("t_index_fail")
				goto fail;
				}
			else
				goto xfail_2;
		else
			m3 = m1;
		headptr = (CODEPTR) Less(headptr);
		while (headptr != 0)
			{
			headptr2 = headptr;
			switch(HeadMux(InstrFetch(headptr)))
				{
				case HeadMux(h_const):
					LopFetch(m2, headptr);
					if (m3 != m2)
						if (m3 < m2)
							{
							headptr = (CODEPTR) Less(headptr2);
							continue;
							}
						else
							{
							headptr = (CODEPTR) Greater(headptr2);
							continue;
							}
					headframeptr = (CHARPTR) stackptr;			      /* stackchange: no modification */
					stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));  /* stackchange: no modification */
					LocalStackCheck;
					TraceFrame(FrameSize(headptr2))
					if (Equal(headptr2))
						{
						TraceChoice(ComputeArgs(goalptr-2))
						PushChoicePoint((-((MW) goalptr)), (-((MW) headptr2)));
						}
					TraceStacks
					ReSetRepush
					ArgIncr TraceInstr("h_const_g_nxtvar")
					goto interpret;
				case HeadMux(h_struct):
					m2 = (MW) FunctorFetch(headptr);
					if (m3 != m2)
						if (m3 < m2)
							{
							headptr = (CODEPTR) Less(headptr2);
							continue;
							}
						else
							{
							headptr = (CODEPTR) Greater(headptr2);
							continue;
							}
					if (i != ArityFetch(headptr))
						{
						headptr = (CODEPTR) Equal(headptr2);
						continue;
						}
					i = -i;
					m1ptr = FirstArgPtr(m1ptr);
					FirstArgIncr(headptr);
					headframeptr = (CHARPTR) stackptr;				/* stackchange: no modification */
					stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));    /* stackchange: no modification */
					LocalStackCheck;
					TraceFrame(FrameSize(headptr2))
					if (Equal(headptr2))
						{
						TraceChoice(ComputeArgs(goalptr-2))
						PushChoicePoint((-((MW) goalptr)), (-((MW) headptr2)));
						}
					TraceStacks
					ReSetRepush
					ArgIncr TraceInstr("h_struct_g_nxtvar")
					Push(0);
					goto head_unify;
				case HeadMux(h_fstvar):
					ArgIncr TraceInstr("h_fstvar_g_nxtvar")
					headframeptr = (CHARPTR) stackptr;				/* stackchange: no modification */
					stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));    /* stackchange: no modification */
					LocalStackCheck;
					LoadHeadVar(m1ptr);
					*m1ptr = m1;
					goto xgoal_5;
				case HeadMux(h_fsttemp):
					ArgIncr TraceInstr("h_fsttmp_g_nxtvar")
					LoadTempVar(m1ptr);
					*m1ptr = m1;
					goto xgoal_t5;
				case HeadMux(h_fsttmp0):
					ArgIncr TraceInstr("h_fsttmp_g_nxtvar")
					temp0 = m1;
#ifdef Trace
					goto xgoal_t5;
#endif
				case HeadMux(h_void):
					ArgIncr TraceInstr("h_void_g_nxtvar")
xgoal_t5:
					headframeptr = (CHARPTR) stackptr;				 /* stackchange: no modification */
					stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr2));     /* stackchange: no modification */
					LocalStackCheck;
xgoal_5:
					TraceFrame(FrameSize(headptr2))
					if (Alternative(headptr2))
						{
						TraceChoice(ComputeArgs(goalptr-2))
						PushChoicePoint((-((MW) goalptr)), headptr2);
						}
					TraceStacks
					ReSetRepush
					goto interpret;
				case HeadMux(h_undefproc):
					goto undef_proc;
				default:
					fprintf(stderr, "XgoalValError\n");
					return(ErrorNumber = SystemError);
				}
			}
		TraceInstr("t_index_fail")
		goto fail;
	default:
		fprintf(stderr, "MainSwitchError\n");
		return(ErrorNumber = SystemError);
	}

fail:
	TraceInstr("t_fail")
	TraceStacks
	ArgReset
	SetRepush
	m1ptr = (MWPTR) trail;
	PopChoicePoint;


#ifdef Comp
	while (m1ptr > (MWPTR) trail)
		{
		m2ptr = XtrRef(*(--m1ptr));
		*m2ptr = MakeUndef(m2ptr);
		}
#else
	while (m1ptr > (MWPTR) trail)
		{
		m2ptr =(MWPTR)(*(--m1ptr));
		*m2ptr = MakeUndef(m2ptr);
		}
#endif
	if ((MW) goalptr > 0)
		{
		if ((headptr = (CODEPTR) Alternative(headptr)) == 0)
			goto fail;
		goto call_goal_3;
		}
	goalptr = (CODEPTR) (-((MW) goalptr));
	LoadOffsetGoalVar(-1, m1ptr);
	if (NotVal(m1 = *m1ptr))
		{
		Deref(m1, m1ptr);
		if (RefUndef(m1))
			{
			headptr = (CODEPTR) Alternative(headptr);
			goto xgoal_3;
			}
		}
	if ((MW) headptr > 0)
		goto xgoal_4;
	headptr = (CODEPTR) (-((MW) headptr));
xfail_1:
	if ((headptr = (CODEPTR) Equal(headptr)) == 0)
		{
		TraceInstr("t_index_fail")
		goto fail;
		}
xfail_2:
	headptr2 = headptr;
	headframeptr = (CHARPTR) stackptr;				  /* stackchange: no modification */
	stackptr = (MWPTR) ((CHARPTR) stackptr - FrameSize(headptr));       /* stackchange: no modification */
	LocalStackCheck;
	TraceFrame(FrameSize(headptr))
	ArgIncr
	switch(HeadMux(InstrFetch(headptr)))
		{
		case HeadMux(h_const):
			TraceInstr("h_const_g_nxtvar")
			LIncr(headptr);
#ifdef Trace
		goto xfail_t2;
#endif
		case HeadMux(h_nil):
			TraceInstr("h_nil_g_nxtvar")
xfail_t2:
			if (Equal(headptr2))
				{
				TraceChoice(ComputeArgs(goalptr-2))
				PushChoicePoint((-((MW) goalptr)), (-((MW) headptr2)));
				}
			TraceStacks
			ReSetRepush
			goto interpret;
		case HeadMux(h_list):
			TraceInstr("h_list_g_nxtvar")
			m1ptr = XtrList(m1);
			TraceInstr("t_xtrlist")
			i = -2;
xfail_3:
			if (Equal(headptr2))
				{
				TraceChoice(ComputeArgs(goalptr-2))
				PushChoicePoint((-((MW) goalptr)), (-((MW) headptr2)));
				}
			TraceStacks
			ReSetRepush
			Push(0);
			goto head_unify;
		case HeadMux(h_struct):
			TraceInstr("h_struct_g_nxtvar")
			m1ptr = XtrStruct(m1);
			i = XtrArity(m1ptr);
			if (i != ArityFetch(headptr))
				goto xfail_1;
			i = -i;
			m1ptr = FirstArgPtr(m1ptr);
			FirstArgIncr(headptr);
			goto xfail_3;
		case HeadMux(h_fstvar):
			TraceInstr("h_fstvar_g_nxtvar")
			LoadHeadVar(m1ptr);
xfail_4:
			*m1ptr = m1;
#ifdef Trace
			goto xfail_t4;
#endif
		case HeadMux(h_void):
			TraceInstr("h_void_g_nxtvar")
xfail_t4:
			if (Alternative(headptr2))
				{
				TraceChoice(ComputeArgs(goalptr-2))
				PushChoicePoint((-((MW) goalptr)), headptr2);
				}
			TraceStacks
			ReSetRepush
			goto interpret;
		case HeadMux(h_fsttemp):
			TraceInstr("h_fsttmp_g_nxtvar")
			LoadTempVar(m1ptr);
			goto xfail_4;
		case HeadMux(h_fsttmp0):
			TraceInstr("h_fsttmp_g_nxtvar")
			temp0 = m1;
			goto xfail_t4;
		case HeadMux(h_undefproc):
			goto undef_proc;
		default:
			fprintf(stderr, "XfailError\n");
			return(ErrorNumber = SystemError);
		}


builtin_head_copy:
while (++i <= 0)
	switch(HeadMux(InstrFetch(headptr)))
		{
		case HeadMux(h_const):						/* atom/int (long) */
			TraceInstr("b_copy_h_const")
			LopFetch(m1, headptr);
			*m2ptr++ = m1;
			break;
		case HeadMux(h_nil):						/* no operand */
			TraceInstr("b_copy_h_nil")
			*m2ptr++ = MakeNil;
			break;
		case HeadMux(h_list):						/* 2 operands */
			TraceInstr("b_copy_h_list")
			if (i != 0)
				{
				Push(m2ptr+1);
				Push(i);
				}
			CreateList(m2ptr);
			TraceAdd(t_bipallocsize, 2)
			i = -2;
			break;
		case HeadMux(h_struct):						/* functor and n operands */
			TraceInstr("b_copy_h_struct")
			if (i != 0)
				{
				Push(m2ptr+1);
				Push(i);
				}
			FetchStruct(m2ptr, headptr, i = (ArityFetch(headptr)));
			TraceAdd(t_bipallocsize, i + 1)
			i = -i;
			break;
		case HeadMux(h_fstvar):					/* varoffset (short) */
			TraceInstr("b_copy_h_fstvar")
			LoadHeadVar(m3ptr);
			*m3ptr = MakeRef(m2ptr);
			TraceInstr("t_makeref")
		case HeadMux(h_void):					/* no operand */
			TraceInstr("b_copy_h_void")
			*m2ptr++ = MakeUndef(m2ptr);
			break;
		case HeadMux(h_nxtvar):					/* varoffset (short) */
			TraceInstr("b_copy_h_nxtvar")
			LoadHeadVar(m3ptr);
			*m2ptr++ = *m3ptr;
			break;
		case HeadMux(h_fsttemp):				/* varoffset (short) */				
			TraceInstr("b_copy_h_fsttmp")
			LoadTempVar(m3ptr);
			*m3ptr = MakeRef(m2ptr);
			TraceInstr("t_makeref")
			*m2ptr++ = MakeUndef(m2ptr);
			break;
		case HeadMux(h_nxttemp):				/* varoffset (short) */				
			TraceInstr("b_copy_h_nxttmp")
			LoadTempVar(m3ptr);
			*m2ptr++ = *m3ptr;
			break;
		case HeadMux(h_fsttmp0):				/* no operand */				
			TraceInstr("b_copy_h_fsttmp")
			temp0 = MakeRef(m2ptr);
			TraceInstr("t_makeref")
			*m2ptr++ = MakeUndef(m2ptr);
			break;
		case HeadMux(h_nxttmp0):				/* no operand */				
			TraceInstr("b_copy_h_nxttmp")
			*m2ptr++ = temp0;
			break;
		default:
			fprintf(stderr, "BuiltinCopyError\n");
			return(ErrorNumber = SystemError);
		}
if (Pop((int), i) >= 0)
	goto call_builtin_head;
Pop((MWPTR), m2ptr);
goto builtin_head_copy;


builtin_goal_copy:
while (++i <= 0)
	switch(HeadMux(InstrFetch(goalptr)))
		{
		case HeadMux(h_const):					/* atom/int (long) */
			TraceInstr("b_copy_h_const")
			LopFetch(m1, goalptr);
			*m2ptr++ = m1;
			break;
		case HeadMux(h_nil):					/* no operand */
			TraceInstr("b_copy_h_nil")
			*m2ptr++ = MakeNil;
			break;
		case HeadMux(h_list):					/* 2 operands */
			TraceInstr("b_copy_h_list")
			if (i != 0)
				{
				Push(m2ptr+1);
				Push(i);
				}
			CreateList(m2ptr);
			TraceAdd(t_bipallocsize, 2)
			i = -2;
			break;
		case HeadMux(h_struct):					/* functor and n operands */
			TraceInstr("b_copy_h_struct")
			if (i != 0)
				{
				Push(m2ptr+1);
				Push(i);
				}
			FetchStruct(m2ptr, goalptr, i = (ArityFetch(goalptr)));
			TraceAdd(t_bipallocsize, i + 1)
			i = -i;
			break;
		case HeadMux(h_fstvar):				/* varoffset (short) */
			TraceInstr("b_copy_h_fstvar")
			LoadGoalVar(m3ptr);
			*m3ptr = MakeRef(m2ptr);
			TraceInstr("t_makeref")
		case HeadMux(h_void):				/* no operand */
			TraceInstr("b_copy_h_void")
			*m2ptr++ = MakeUndef(m2ptr);
			break;
		case HeadMux(h_nxtvar):				/* varoffset (short) */
			TraceInstr("b_copy_h_nxtvar")
			LoadGoalVar(m3ptr);
			*m2ptr++ = *m3ptr;
			break;
		case HeadMux(h_fsttemp):			/* varoffset (short) */
			TraceInstr("b_copy_h_fsttmp")
			LoadGoalTempVar(m3ptr);
			*m3ptr = MakeRef(m2ptr);
			TraceInstr("t_makeref")
			*m2ptr++ = MakeUndef(m2ptr);
			break;
		case HeadMux(h_nxttemp):			/* varoffset (short) */
			TraceInstr("b_copy_h_nxttmp")
			LoadGoalTempVar(m3ptr);
			*m2ptr++ = *m3ptr;
			break;
		case HeadMux(h_fsttmp0):			/* no operand */
			TraceInstr("b_copy_h_fsttmp")
			temp0 = MakeRef(m2ptr);
			TraceInstr("t_makeref")
			*m2ptr++ = MakeUndef(m2ptr);
			break;
		case HeadMux(h_nxttmp0):			/* no operand */
			TraceInstr("b_copy_h_nxttmp")
			*m2ptr++ = temp0;
			break;
		default:
			fprintf(stderr, "BuiltinCopyError\n");
			return(ErrorNumber = SystemError);
		}
if (Pop((int), i) >= 0)
	goto call_builtin_goal;
Pop((MWPTR), m2ptr);
goto builtin_goal_copy;


head_copy:
while (--i >= 0)
	switch(HeadMux(InstrFetch(headptr)))
		{
		case HeadMux(h_const):					/* atom/int (long) */
			TraceInstr("h_copy_h_const")
			LopFetch(m1, headptr);
			*m1ptr++ = m1;
			break;
		case HeadMux(h_nil):					/* no operand */
			TraceInstr("h_copy_h_nil")
			*m1ptr++ = MakeNil;
			break;
		case HeadMux(h_list):					/* 2 operands */
			TraceInstr("h_copy_h_list")
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			CreateList(m1ptr);
			i = 2;
			break;
		case HeadMux(h_struct):					/* functor and n operands */
			TraceInstr("h_copy_h_struct")
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			FetchStruct(m1ptr, headptr, i = ArityFetch(headptr));
			break;
		case HeadMux(h_fstvar):					/* varoffset (short) */
			TraceInstr("h_copy_h_fstvar")
			LoadHeadVar(m2ptr);
			*m2ptr = MakeRef(m1ptr);
			TraceInstr("t_makeref")
		case HeadMux(h_void):					/* no operand */
			TraceInstr("h_copy_h_void")
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case HeadMux(h_nxtvar):					/* varoffset (short) */
			TraceInstr("h_copy_h_nxtvar")
			LoadHeadVar(m2ptr);
			*m1ptr++ = *m2ptr;
			break;
		case HeadMux(h_fsttemp):				/* varoffset (short) */
			TraceInstr("h_copy_h_fsttmp")
			LoadTempVar(m2ptr);
			*m2ptr = MakeRef(m1ptr);
			TraceInstr("t_makeref")
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case HeadMux(h_nxttemp):				/* varoffset (short) */
			TraceInstr("h_copy_h_nxttmp")
			LoadTempVar(m2ptr);
			*m1ptr++ = *m2ptr;
			break;
		case HeadMux(h_fsttmp0):				/* no operand */
			TraceInstr("h_copy_h_fsttmp")
			temp0 = MakeRef(m1ptr);
			TraceInstr("t_makeref")
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case HeadMux(h_nxttmp0):				/* no operand */
			TraceInstr("h_copy_h_nxttmp")
			*m1ptr++ = temp0;
			break;
		default:
			fprintf(stderr, "HeadCopyError\n");
			return(ErrorNumber = SystemError);
		}
if (Pop((int), i) == 0)
	goto interpret;
Pop((MWPTR), m1ptr);
if (i > 0)
	goto head_copy;
/* goto head_unify; */

head_unify:
while (++i <= 0)
	switch(HeadMux(InstrFetch(headptr)))
		{
		case HeadMux(h_const):					/* atom/int (long) */
			TraceInstr("h_unify_h_const")
			LopFetch(m1, headptr);
			if (NotVal(m2 = *m1ptr++))
				{
				m2ptr = m1ptr-1;
				StructDeref(m2, m2ptr);
				if (RefUndef(m2))
					AssignBreak(m2ptr, m1)
				}
			if (m1 == m2)
				break;
			FailInstr(h_unify_h_const)
			goto fail;
		case HeadMux(h_nil):					/* no operand */
			TraceInstr("h_unify_h_nil")
			if (NotVal(m1 = *m1ptr++))
				{
				m2ptr = m1ptr-1;
				StructDeref(m1, m2ptr);
				if (RefUndef(m1))
					AssignBreak(m2ptr, MakeNil)
				}
			if (Nil(m1))
				break;
			FailInstr(h_unify_h_nil)
			goto fail;
		case HeadMux(h_list):					/* 2 operand */
			TraceInstr("h_unify_h_list")
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			if (NotVal(m1 = *m1ptr))
				{
				StructDeref(m1, m1ptr);
				if (RefUndef(m1))
					{
					Trail(m1ptr);
					CreateList(m1ptr);
					i = 2;
					goto head_copy;
					}
				}
			if (NotList(m1))
				{
				FailInstr(h_unify_h_list)
				goto fail;
				}
			m1ptr = XtrList(m1);
			TraceInstr("t_xtrlist")
			i = -2;
			break;
		case HeadMux(h_struct):					/* functor and n operands */
			TraceInstr("h_unify_h_struct")
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			if (NotVal(m1 = *m1ptr))
				{
				StructDeref(m1, m1ptr);
				if (RefUndef(m1))
					{
					Trail(m1ptr);
					FetchStruct(m1ptr, headptr, i = ArityFetch(headptr));
					goto head_copy;
					}
				}
			if (NotStruct(m1))
				{
				FailInstr(h_unify_h_struct)
				goto fail;
				}
			m1ptr = XtrStruct(m1);
			i = -ArityFetch(headptr);
			UnifyStruct(m1ptr, headptr);
			break;
		case HeadMux(h_void):					/* no operand */
			TraceInstr("h_unify_h_void")
			m1ptr++;
			break;
		case HeadMux(h_fstvar):					/* varoffset (short) */
			TraceInstr("h_unify_h_fstvar")
			LoadHeadVar(m2ptr);
unify_fstvar:
#ifdef UndefSelfRef
			*m2ptr = *m1ptr++;
#else
			if (Undef(*m2ptr = *m1ptr++))
				{
				*m2ptr = MakeRef(m1ptr-1);
				TraceInstr("t_makeref")
				}
#endif /* UndefSelfRef */
			break;
		case HeadMux(h_nxtvar):					/* varoffset (short) */
			TraceInstr("h_unify_h_nxtvar")
			LoadHeadVar(m2ptr);
unify_nxtvar:
			m2 = *m2ptr;
unify_nxtvar_tmp0:
			m3ptr = m1ptr++;
			if (NotVal(m1 = *m3ptr))
				{
				StructDeref(m1, m3ptr);
				if (RefUndef(m1))
					{
					if (NotVal(m2))
						{
						Deref(m2, m2ptr);
						if (RefUndef(m2))
							if (Pointsto(m3ptr, m2ptr))
								{ 
								TraceInstr("t_makeref")
								AssignBreak(m3ptr, MakeRef(m2ptr))
								}
							else if (Pointsto(m2ptr, m3ptr))
								{
								TraceInstr("t_makeref")
								AssignBreak(m2ptr, MakeRef(m3ptr))
								}
							else
								break;
						}
					AssignBreak(m3ptr, m2)
					}
				}
			if (NotVal(m2))
				{
				Deref(m2, m2ptr);
				if (RefUndef(m2))
					AssignBreak(m2ptr, m1)
				}
			if (m1 == m2)
				break;
			if (ListOrStruct(m1) && struct_unify(m1, m2))
				break;
			FailInstr(h_unify_h_nxtvar)
			goto fail;
		case HeadMux(h_fsttemp):					/* varoffset (short) */
			TraceInstr("h_unify_h_fsttmp")
			LoadTempVar(m2ptr);
			goto unify_fstvar;
		case HeadMux(h_nxttemp):					/* varoffset (short) */
			TraceInstr("h_unify_h_nxttmp")
			LoadTempVar(m2ptr);
			goto unify_nxtvar;
		case HeadMux(h_fsttmp0):					/* no operand */
			TraceInstr("h_unify_h_fsttmp")
#ifdef UndefSelfRef
			temp0 = *m1ptr++;
#else
			if (Undef(temp0 = *m1ptr))
				{
				temp0 = MakeRef(m1ptr);
				TraceInstr("t_makeref")
				}
			m1ptr++;
#endif /* UndefSelfRef */
			break;
		case HeadMux(h_nxttmp0):					/* no operand */
			TraceInstr("h_unify_h_nxttmp")
			m2 = temp0;
			goto unify_nxtvar_tmp0;
		case HeadMux(h_undefproc):
			return(ErrorNumber = UndefProcError);
		default:
			fprintf(stderr, "HeadUnifyError\n");
			return(ErrorNumber = SystemError);
		}
if (Pop((int), i) == 0)
	goto interpret;
Pop((MWPTR), m1ptr);
goto head_unify;


goal_copy:
while (--i >= 0)
	switch(GoalMux(InstrFetch(goalptr)))
		{
		case GoalMux(g_const):					/* atom/int (long) */
			TraceInstr("g_copy_g_const")
			LopFetch(m1, goalptr);
			*m1ptr++ = m1;
			break;
		case GoalMux(g_nil):					/* no operand */
			TraceInstr("g_copy_g_nil")
			*m1ptr++ = MakeNil;
			break;
		case GoalMux(g_list):					/* 2 operands */
			TraceInstr("g_copy_g_list")
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			CreateList(m1ptr);
			i = 2;
			TraceAdd(t_g_skip_unify, 2)
			break;
		case GoalMux(g_struct):					/* functor and n operands */
			TraceInstr("g_copy_g_struct")
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			FetchStruct(m1ptr, goalptr, i = ArityFetch(goalptr));
			TraceAdd(t_g_skip_unify, i + 1)
			break;
		case GoalMux(g_void):					/* no operand */
			TraceInstr("g_copy_g_void")
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case GoalMux(g_fstvar):					/* varoffset (short) */
			TraceInstr("g_copy_g_fstvar")
			LoadGoalVar(m2ptr);
			*m2ptr = MakeRef(m1ptr);
			TraceInstr("t_makeref")
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case GoalMux(g_nxtvar):					/* varoffset (short) */
			TraceInstr("g_copy_g_nxtvar")
			LoadGoalVar(m2ptr);
			*m1ptr++ = *m2ptr;
			break;
		case GoalMux(g_0fstvar):				/* no operand */
			TraceInstr("g_copy_g_fstvar")
			GoalVar(0) = MakeRef(m1ptr);
			TraceInstr("t_makeref")
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case GoalMux(g_0nxtvar):				/* no operand */
			TraceInstr("g_copy_g_nxtvar")
			*m1ptr++ = GoalVar(0);
			break;
		case GoalMux(g_1fstvar):				/* no operand */
			TraceInstr("g_copy_g_fstvar")
			GoalVar(1) = MakeRef(m1ptr);
			TraceInstr("t_makeref")
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case GoalMux(g_1nxtvar):				/* no operand */
			TraceInstr("g_copy_g_nxtvar")
			*m1ptr++ = GoalVar(1);
			break;
		case GoalMux(g_2fstvar):				/* no operand */
			TraceInstr("g_copy_g_fstvar")
			GoalVar(2) = MakeRef(m1ptr);
			TraceInstr("t_makeref")
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case GoalMux(g_2nxtvar):				/* no operand */
			TraceInstr("g_copy_g_nxtvar")
			*m1ptr++ = GoalVar(2);
			break;
		case GoalMux(g_3fstvar):				/* no operand */
			TraceInstr("g_copy_g_fstvar")
			GoalVar(3) = MakeRef(m1ptr);
			TraceInstr("t_makeref")
			*m1ptr++ = MakeUndef(m1ptr);
			break;
		case GoalMux(g_3nxtvar):				/* no operand */
			TraceInstr("g_copy_g_nxtvar")
			*m1ptr++ = GoalVar(3);
			break;
		default:
			fprintf(stderr, "GoalCopyError\n");
			return(ErrorNumber = SystemError);
		}
if (Pop((int), i) == 0)
	goto interpret;
Pop((MWPTR), m1ptr);
if (i > 0)
	goto goal_copy;
/* goto goal_unify; */

goal_unify:
while (++i <= 0)
	switch(GoalMux(InstrFetch(goalptr)))
		{
		case GoalMux(g_const):				/* atom/int (long) */
			TraceInstr("g_unify_g_const")
			LopFetch(m1, goalptr);
			if (NotVal(m2 = *m1ptr++))
				{
				m2ptr = m1ptr-1;
				StructDeref(m2, m2ptr);
				if (RefUndef(m2))
					AssignBreak(m2ptr, m1)
				}
			if (m1 == m2)
				break;
			FailInstr(g_unify_g_const)
			goto fail;
		case GoalMux(g_nil):				/* no operand */
			TraceInstr("g_unify_g_nil")
			if (NotVal(m1 = *m1ptr++))
				{
				m2ptr = m1ptr-1;
				StructDeref(m1, m2ptr);
				if (RefUndef(m1))
					AssignBreak(m2ptr, MakeNil)
				}
			if (Nil(m1))
				break;
			FailInstr(g_unify_g_nil)
			goto fail;
		case GoalMux(g_list):				/* 2 operands */
			TraceInstr("g_unify_g_list")
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			if (NotVal(m1 = *m1ptr))
				{
				StructDeref(m1, m1ptr);
				if (RefUndef(m1))
					{
					Trail(m1ptr);
					CreateList(m1ptr);
					i = 2;
					goto goal_copy;
					}
				}
			if (NotList(m1))
				{
				FailInstr(g_unify_g_list)
				goto fail;
				}
			m1ptr = XtrList(m1);
			TraceInstr("t_xtrlist")
			i = -2;
			break;
		case GoalMux(g_struct):				/* functor and n operands */
			TraceInstr("g_unify_g_struct")
			if (i != 0)
				{
				Push(m1ptr+1);
				Push(i);
				}
			if (NotVal(m1 = *m1ptr))
				{
				StructDeref(m1, m1ptr);
				if (RefUndef(m1))
					{
					Trail(m1ptr);
					FetchStruct(m1ptr, goalptr, i = ArityFetch(goalptr));
					goto goal_copy;
					}
				}
			if (NotStruct(m1))
				{
				FailInstr(g_unify_g_struct)
				goto fail;
				}
			m1ptr = XtrStruct(m1);
			i = -ArityFetch(goalptr);
			UnifyStruct(m1ptr, goalptr);
			break;
		case GoalMux(g_void):				/* no operand */
			TraceInstr("g_unify_g_void")
			m1ptr++;
			break;
		case GoalMux(g_fstvar):				/* varoffset (short) */
			TraceInstr("g_unify_g_fstvar")
			LoadGoalVar(m2ptr);
#ifdef UndefSelfRef
			*m2ptr = *m1ptr++;
#else
			if (Undef(*m2ptr = *m1ptr++))
				{
				*m2ptr = MakeRef(m1ptr-1);
				TraceInstr("t_makeref")
				}
#endif /* UndefSelfRef */
			break;
		case GoalMux(g_nxtvar):				/* varoffset (short) */
			TraceInstr("g_unify_g_nxtvar")
			m3ptr = m1ptr++;
			LoadGoalVar(m2ptr);
unify_g_nxtvar_0:
			if (NotVal(m1 = *m3ptr))
				{
				StructDeref(m1, m3ptr);
				if (RefUndef(m1))
					{
					if (NotVal(m2 = *m2ptr))
						{
						Deref(m2, m2ptr);
						if (RefUndef(m2))
							if (Pointsto(m3ptr, m2ptr))
								{
								TraceInstr("t_makeref")
								AssignBreak(m3ptr, MakeRef(m2ptr))
								}
							else if (Pointsto(m2ptr, m3ptr))
								{
								TraceInstr("t_makeref")
								AssignBreak(m2ptr, MakeRef(m3ptr))
								}
							else
								break;
						}
					AssignBreak(m3ptr, m2)
					}
				}
			if (NotVal(m2 = *m2ptr))
				{
				Deref(m2, m2ptr);
				if (RefUndef(m2))
					AssignBreak(m2ptr, m1)
				}
			if (m1 == m2)
				break;
			if (ListOrStruct(m1) && struct_unify(m1, m2))
				break;
			FailInstr(g_unify_g_nxtvar)
			goto fail;
		case GoalMux(g_0fstvar):				/* no operand */
			TraceInstr("g_unify_g_fstvar")
#ifdef UndefSelfRef
			GoalVar(0) = *m1ptr++;
#else
			if (Undef(GoalVar(0) = *m1ptr++))
				{
				GoalVar(0) = MakeRef(m1ptr-1);
				TraceInstr("t_makeref")
				}
#endif /* UndefSelfRef */
			break;
		case GoalMux(g_0nxtvar):				/* no operand */
			TraceInstr("g_unify_g_nxtvar")
			m3ptr = m1ptr++;
			m2ptr = &GoalVar(0);
			goto unify_g_nxtvar_0;
		case GoalMux(g_1fstvar):				/* no operand */
			TraceInstr("g_unify_g_fstvar")
#ifdef UndefSelfRef
			GoalVar(1) = *m1ptr++;
#else
			if (Undef(GoalVar(1) = *m1ptr++))
				{
				GoalVar(1) = MakeRef(m1ptr-1);
				TraceInstr("t_makeref")
				}
#endif /* UndefSelfRef */
			break;
		case GoalMux(g_1nxtvar):				/* no operand */
			TraceInstr("g_unify_g_nxtvar")
			m3ptr = m1ptr++;
			m2ptr = &GoalVar(1);
			goto unify_g_nxtvar_0;
		case GoalMux(g_2fstvar):
			TraceInstr("g_unify_g_fstvar")
#ifdef UndefSelfRef
			GoalVar(2) = *m1ptr++;
#else
			if (Undef(GoalVar(2) = *m1ptr++))
				{
				GoalVar(2) = MakeRef(m1ptr-1);
				TraceInstr("t_makeref")
				}
#endif /* UndefSelfRef */
			break;
		case GoalMux(g_2nxtvar):				/* no operand */
			TraceInstr("g_unify_g_nxtvar")
			m3ptr = m1ptr++;
			m2ptr = &GoalVar(2);
			goto unify_g_nxtvar_0;
		case GoalMux(g_3fstvar):				/* no operand */
			TraceInstr("g_unify_g_fstvar")
#ifdef UndefSelfRef
			GoalVar(3) = *m1ptr++;
#else
			if (Undef(GoalVar(3) = *m1ptr++))
				{
				GoalVar(3) = MakeRef(m1ptr-1);
				TraceInstr("t_makeref")
				}
#endif /* UndefSelfRef */
			break;
		case GoalMux(g_3nxtvar):				/* no operand */
			TraceInstr("g_unify_g_nxtvar")
			m3ptr = m1ptr++;
			m2ptr = &GoalVar(3);
			goto unify_g_nxtvar_0;
		default:
			fprintf(stderr, "GoalUnifyError\n");
			return(ErrorNumber = SystemError);
		}
if (Pop((int), i) == 0)
	goto interpret;
Pop((MWPTR), m1ptr);
goto goal_unify;


/*                   evaluating VAM1P-commands               */
/*-----------------------------------------------------------*/
vam1p_unify: 
switch(UnifyMux(InstrFetch(goalptr)))
	{
	case UnifyMux(v1_lastcall):						/* switch to VAM2P-Mode */
		TraceSwitchVam12p
		TraceInstr("v1_t_unify_lastcall")
		headptr = (CODEPTR) LopRead(goalptr);		/* headptr = operand of v1_lastcall */
		SDecr(goalptr);								/* reread v1_lastcall for VAM2P-code evaluation */
		goto interpret;
	case UnifyMux(v1_unify_const):					/* unify list/struct argument, atom/int (long) */
		TraceInstr("v1_t_unify_const")
		LopFetch(m1, goalptr);
		if (NotVal(m2 = *m1ptr++))
			{
			m2ptr = m1ptr-1;
			StructDeref(m2, m2ptr);
			if (RefUndef(m2))
				AssignVam1pUnify(m2ptr, m1)
			}
		if (m1 == m2)
			goto vam1p_unify;
		FailInstr(v1_t_unify_const)
		goto fail;

	case UnifyMux(v1_unify_nil):					/* unify list/struct argument, no operand*/
		TraceInstr("v1_t_unify_nil")
		if (NotVal(m1 = *m1ptr++))
			{
			m2ptr = m1ptr-1;
			StructDeref(m1, m2ptr);
			if (RefUndef(m1))
				AssignVam1pUnify(m2ptr, MakeNil)
			}
		if (Nil(m1))
			goto vam1p_unify;
		FailInstr(v1_t_unify_nil)
		goto fail;

	case UnifyMux(v1_unify_list):					/* unify list/struct argument, push adress of list */
		Push(m1ptr+1);

	case UnifyMux(v1_unify_last_list):				/* unify list/struct argument, 2 operands */
		TraceInstr("v1_t_unify_list")
		if (NotVal(m1 = *m1ptr))
			{
			StructDeref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				CreateList(m1ptr);
				goto vam1p_copy;
				}
			}
		if (NotList(m1))
			{
			FailInstr(v1_t_unify_list)
			goto fail;
			}
		m1ptr = XtrList(m1);
		TraceInstr("t_xtrlist")
		goto vam1p_unify;

	case UnifyMux(v1_unify_struct):					/* unify list/struct argument, push addres of struct */
		Push(m1ptr+1);

	case UnifyMux(v1_unify_last_struct):			/* unify list/struct argument, functor and n operands */
		TraceInstr("v1_t_unify_struct")
		if (NotVal(m1 = *m1ptr))
			{
			StructDeref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				FetchStruct(m1ptr, goalptr, ArityFetch(goalptr));
				goto vam1p_copy;
				}
			}
		if (NotStruct(m1))
			{
			FailInstr(v1_t_unify_struct)
			goto fail;
			}
		m1ptr = XtrStruct(m1);
		UnifyStruct(m1ptr, goalptr);
		goto vam1p_unify;

	case UnifyMux(v1_unify_void):					/* unify list/struct argument, no operand*/
		TraceInstr("v1_t_unify_void")
		m1ptr++;
		goto vam1p_unify;

	case UnifyMux(v1_unify_fsttmp):					/* unify list/struct argument, varoffset (short) */
		TraceInstr("v1_t_unify_fsttmp")
		LoadTempVar(m2ptr);
#ifdef UndefSelfRef
		*m2ptr = *m1ptr++;
#else
		if (Undef(*m2ptr = *m1ptr++))
			{
			*m2ptr = MakeRef(m1ptr-1);
			TraceInstr("t_makeref")
			}
#endif /* UndefSelfRef */
		goto vam1p_unify;

	case UnifyMux(v1_unify_nxttmp):					/* unify list/struct argument, varoffset (short) */
		TraceInstr("v1_t_unify_nxttmp")
		LoadTempVar(m2ptr);
		m2 = *m2ptr;
		goto v_unify_nxtvar;

	case UnifyMux(v1_unify_fsttmp0):					/* unify list/struct argument, no operand */
		TraceInstr("v1_t_unify_fsttmp")
#ifdef UndefSelfRef
		temp0 = *m1ptr++;
#else
		if (Undef(temp0 = *m1ptr))
			{
			temp0 = MakeRef(m1ptr);
			TraceInstr("t_makeref")
			}
		m1ptr++;
#endif /* UndefSelfRef */
		goto vam1p_unify;

	case UnifyMux(v1_unify_nxttmp0):					/* unify list/struct argument, no operand */
		TraceInstr("v1_t_unify_nxttmp")
		m2 = temp0;
		goto v_unify_nxtvar;

	case UnifyMux(v1_unify_fstvar):					/* unify list/struct argument, varoffset (short) */
		TraceInstr("v1_t_unify_fstvar")
		LoadGoalVar(m2ptr);
#ifdef UndefSelfRef
		*m2ptr = *m1ptr++;
#else
		if (Undef(*m2ptr = *m1ptr++))
			{
			*m2ptr = MakeRef(m1ptr-1);
			TraceInstr("t_makeref")
			}
#endif /* UndefSelfRef */
		goto vam1p_unify;

	case UnifyMux(v1_unify_nxtvar):					/* unify list/struct argument, varoffset (short) */
		TraceInstr("v1_t_unify_nxtvar")
		LoadGoalVar(m2ptr);
		m2 = *m2ptr;
v_unify_nxtvar:
		m3ptr = m1ptr++;
		if (NotVal(m1 = *m3ptr))
			{
			StructDeref(m1, m3ptr);
			if (RefUndef(m1))
				{
				if (NotVal(m2))
					{
					Deref(m2, m2ptr);
					if (RefUndef(m2))
						if (Pointsto(m3ptr, m2ptr))
							{
							TraceInstr("t_makeref")
							AssignVam1pUnify(m3ptr, MakeRef(m2ptr))
							}
						else if (Pointsto(m2ptr, m3ptr))
							{
							TraceInstr("t_makeref")
							AssignVam1pUnify(m2ptr, MakeRef(m3ptr))
							}
						else
							goto vam1p_unify;
					}
				AssignVam1pUnify(m3ptr, m2)
				}
			}
		if (NotVal(m2))
			{
			Deref(m2, m2ptr);
			if (RefUndef(m2))
				AssignVam1pUnify(m2ptr, m1)
			}
		if (m1 == m2)
			goto vam1p_unify;
		if (ListOrStruct(m1) && struct_unify(m1, m2))
			goto vam1p_unify;
		FailInstr(v1_t_unify_nxtvar)
		goto fail;

	case UnifyMux(v1_unify_0fstvar):					/* unify list/struct argument, no operand */
		TraceInstr("v1_t_unify_fstvar")
#ifdef UndefSelfRef
		GoalVar(0) = *m1ptr++;
#else
		if (Undef(GoalVar(0) = *m1ptr++))
			{
			GoalVar(0) = MakeRef(m1ptr-1);
			TraceInstr("t_makeref")
			}
#endif /* UndefSelfRef */
		goto vam1p_unify;

	case UnifyMux(v1_unify_0nxtvar):					/* unify list/struct argument, no operand */
		TraceInstr("v1_t_unify_nxtvar")
		m2 = GoalVar(0);
		goto v_unify_nxtvar;

	case UnifyMux(v1_unify_1fstvar):					/* unify list/struct argument, no operand */
		TraceInstr("v1_t_unify_fstvar")
#ifdef UndefSelfRef
		GoalVar(1) = *m1ptr++;
#else
		if (Undef(GoalVar(1) = *m1ptr++))
			{
			GoalVar(1) = MakeRef(m1ptr-1);
			TraceInstr("t_makeref")
			}
#endif /* UndefSelfRef */
		goto vam1p_unify;

	case UnifyMux(v1_unify_1nxtvar):					/* unify list/struct argument, no operand */
		TraceInstr("v1_t_unify_nxtvar")
		m2 = GoalVar(1);
		goto v_unify_nxtvar;

	case UnifyMux(v1_unify_2fstvar):					/* unify list/struct argument, no operand */
		TraceInstr("v1_t_unify_fstvar")
#ifdef UndefSelfRef
		GoalVar(2) = *m1ptr++;
#else
		if (Undef(GoalVar(2) = *m1ptr++))
			{
			GoalVar(2) = MakeRef(m1ptr-1);
			TraceInstr("t_makeref")
			}
#endif /* UndefSelfRef */
		goto vam1p_unify;

	case UnifyMux(v1_unify_2nxtvar):					/* unify list/struct argument, no operand */
		TraceInstr("v1_t_unify_nxtvar")
		m2 = GoalVar(2);
		goto v_unify_nxtvar;

	case UnifyMux(v1_unify_3fstvar):					/* unify list/struct argument, no operand */
		TraceInstr("v1_t_unify_fstvar")
#ifdef UndefSelfRef
		GoalVar(3) = *m1ptr++;
#else
		if (Undef(GoalVar(3) = *m1ptr++))
			{
			GoalVar(3) = MakeRef(m1ptr-1);
			TraceInstr("t_makeref")
			}
#endif /* UndefSelfRef */
		goto vam1p_unify;

	case UnifyMux(v1_unify_3nxtvar):					/* unify list/struct argument, no operand */
		TraceInstr("v1_t_unify_nxtvar")
		m2 = GoalVar(3);
		goto v_unify_nxtvar;

	case UnifyMux(v1_pop):
		TraceInstr("v1_t_pop")
		Pop((MWPTR), m1ptr);
		goto vam1p_unify;

	case UnifyMux(v1_fstvar_const):				/* varoffset (short), atom/int (long) */
v_fstvar_const:
		LoadGoalVar(m1ptr);
		LopFetch(m1, goalptr);
		*m1ptr = m1;
		goto vam1p_unify;

	case UnifyMux(v1_nxtvar_const):				/* varoffset (short), atom/int (long) */
v_nxtvar_const:
		LoadGoalVar(m1ptr);
		LopFetch(m2, goalptr);
		if (NotVal(m1 = *m1ptr))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignVam1pUnify(m1ptr, m2)
			}
		if (m1 == m2)
			goto vam1p_unify;
		goto fail;

	case UnifyMux(v1_fsttmp_const):				/* varoffset (short), atom/int (long) */
v_fsttmp_const:
		LoadTempVar(m1ptr);
		LopFetch(m1, goalptr);
		*m1ptr = m1;
		goto vam1p_unify;

	case UnifyMux(v1_nxttmp_const):				/* varoffset (short), atom/int (long) */
v_nxttmp_const:
		LoadTempVar(m1ptr);
		LopFetch(m2, goalptr);
		if (NotVal(m1 = *m1ptr))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignVam1pUnify(m1ptr, m2)
			}
		if (m1 == m2)
			goto vam1p_unify;
		goto fail;

	case UnifyMux(v1_fsttmp0_const):				/* no operand, atom/int (long) */
v_fsttmp0_const:
		LopFetch(m1, goalptr);
		temp0 = m1;
		goto vam1p_unify;

	case UnifyMux(v1_nxttmp0_const):				/* no operand, atom/int (long) */
v_nxttmp0_const:
		LopFetch(m2, goalptr);
		if (NotVal(m1 = temp0))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignVam1pUnify(m1ptr, m2)
			}
		if (m1 == m2)
			goto vam1p_unify;
		goto fail;

	case UnifyMux(v1_fstvar_nil):				/* varoffset (short), no operand */
v_fstvar_nil:
		LoadGoalVar(m1ptr);
		*m1ptr = MakeNil;
		goto vam1p_unify;

	case UnifyMux(v1_nxtvar_nil):				/* varoffset (short), no operand */
v_nxtvar_nil:
		LoadGoalVar(m1ptr);
		if (NotVal(m1 = *m1ptr))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignVam1pUnify(m1ptr, MakeNil)
			}
		if (Nil(m1))
			goto vam1p_unify;
		goto fail;

	case UnifyMux(v1_fsttmp_nil):				/* varoffset (short), no operand */
v_fsttmp_nil:
		LoadTempVar(m1ptr);
		*m1ptr = MakeNil;
		goto vam1p_unify;

	case UnifyMux(v1_nxttmp_nil):				/* varoffset (short), no operand */
v_nxttmp_nil:
		LoadTempVar(m1ptr);
		if (NotVal(m1 = *m1ptr))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignVam1pUnify(m1ptr, MakeNil)
			}
		if (Nil(m1))
			goto vam1p_unify;
		goto fail;

	case UnifyMux(v1_fsttmp0_nil):				/* no operand, no operand */
v_fsttmp0_nil:
		temp0 = MakeNil;
		goto vam1p_unify;

	case UnifyMux(v1_nxttmp0_nil):				/* no operand, no operand */
v_nxttmp0_nil:
		if (NotVal(m1 = temp0))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				AssignVam1pUnify(m1ptr, MakeNil)
			}
		if (Nil(m1))
			goto vam1p_unify;
		goto fail;

	case UnifyMux(v1_fstvar_list):				/* varoffset (short), 2 operands */
v_fstvar_list:
		LoadGoalVar(m1ptr);
		CreateList(m1ptr);
		goto vam1p_copy;

	case UnifyMux(v1_nxtvar_list):				/* varoffset (short), 2 operands */
v_nxtvar_list:  
		LoadGoalVar(m1ptr); 
		m1 = *m1ptr; 
v_nxtvar_0_list:
		if (NotVal(m1))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				CreateList(m1ptr);
				goto vam1p_copy;
				}
			}
		if (List(m1))
			{
			m1ptr = XtrList(m1);
			TraceInstr("t_xtrlist")
			goto vam1p_unify;
			}
		goto fail;

	case UnifyMux(v1_fsttmp_list):				/* varoffset (short), 2 operands */
v_fsttmp_list:
		LoadTempVar(m1ptr);
		CreateList(m1ptr);
		goto vam1p_copy;

	case UnifyMux(v1_nxttmp_list):				/* varoffset (short), 2 operands */
v_nxttmp_list:
		LoadTempVar(m1ptr);
		m1 = *m1ptr;
		goto v_nxtvar_0_list;

	case UnifyMux(v1_fsttmp0_list):				/* no operand, 2 operands */
v_fsttmp0_list:
		CreateList2(temp0, m1ptr);
		goto vam1p_copy;

	case UnifyMux(v1_nxttmp0_list):				/* no operand, 2 operands */
v_nxttmp0_list:
		m1 = temp0;
		goto v_nxtvar_0_list;

	case UnifyMux(v1_fstvar_struct):				/* varoffset (short), functor and n operands */
v_fstvar_struct:
		LoadGoalVar(m1ptr);
		FetchStruct(m1ptr, headptr, ArityFetch(goalptr));
		goto vam1p_copy;

	case UnifyMux(v1_nxtvar_struct):				/* varoffset (short), functor and n operands */
v_nxtvar_struct:
		LoadGoalVar(m1ptr);
		m1 = *m1ptr;
v_nxtvar_0_struct:
		if (NotVal(m1))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				Trail(m1ptr);
				FetchStruct(m1ptr, goalptr, ArityFetch(goalptr));
				goto vam1p_copy;
				}
			}
		if (Struct(m1))
			{
			m1ptr = XtrStruct(m1);
			UnifyStruct(m1ptr, goalptr);
			goto vam1p_unify;
			}
		goto fail;

	case UnifyMux(v1_fsttmp_struct):				/* varoffset (short), functor and n operands */
v_fsttmp_struct:
		LoadTempVar(m1ptr);
		FetchStruct(m1ptr, goalptr, ArityFetch(goalptr));
		goto vam1p_copy;

	case UnifyMux(v1_nxttmp_struct):
v_nxttmp_struct:
		LoadTempVar(m1ptr);
		m1 = *m1ptr;
		goto v_nxtvar_0_struct;

	case UnifyMux(v1_fsttmp0_struct):				/* no operand, functor and n operands */
v_fsttmp0_struct:
		FetchStruct4(temp0, m1ptr, goalptr, ArityFetch(goalptr));
		goto vam1p_copy;

	case UnifyMux(v1_nxttmp0_struct):				/* no operand, functor and n operands */
v_nxttmp0_struct:
		m1 = temp0;
		goto v_nxtvar_0_struct;

	case UnifyMux(v1_fstvar_void):				/* varoffset (short), no operand */
v_fstvar_void:
		LoadGoalVar(m1ptr);
		MakeCopyUndef;
		*m1ptr = MakeRef(copyptr);		   /* stackchange: no modification */
		TraceInstr("t_makeref")
		goto vam1p_unify;

	case UnifyMux(v1_fsttmp_void):				/* varoffset (short), no operand */
v_fsttmp_void:
		LoadTempVar(m1ptr);
		MakeCopyUndef;
		*m1ptr = MakeRef(copyptr);		   /* stackchange: no modification */
		TraceInstr("t_makeref")
		goto vam1p_unify;

	case UnifyMux(v1_fsttmp0_void):				/* varoffset (short), no operand */
v_fsttmp0_void:
		MakeCopyUndef;
		temp0 = MakeRef(copyptr);		   /* stackchange: no modification */
		TraceInstr("t_makeref")
		goto vam1p_unify;

	case UnifyMux(v1_fstvar_fstvar):				/* varoffset (short), varoffset (short) */
v_fstvar_fstvar:
		LoadGoalVar(m1ptr);
		LoadGoalVar(m2ptr);
		MakeCopyUndef;
		*m2ptr = *m1ptr = MakeRef(copyptr);	 /* stackchange: no modification */
		TraceInstr("t_makeref")
		goto vam1p_unify;

	case UnifyMux(v1_fstvar_nxtvar):				/* varoffset (short), varoffset (short) */
		{
v_fstvar_nxtvar:
		LoadGoalVar(m1ptr);
		LoadGoalVar(m2ptr); 
		MakeCopyUndef;
		*m1ptr = *m2ptr;
		TraceInstr("t_makeref")
		goto vam1p_unify;
		}
	case UnifyMux(v1_fstvar_fsttmp):				/* varoffset (short), varoffset (short) */
v_fstvar_fsttmp:
		LoadGoalVar(m1ptr);
		LoadTempVar(m2ptr);
		MakeCopyUndef;
		*m2ptr = *m1ptr = MakeRef(copyptr);	   /* stackchange: no modification */
		TraceInstr("t_makeref")
		goto vam1p_unify;

	case UnifyMux(v1_fstvar_nxttmp):				/* varoffset (short), varoffset (short) */
v_fstvar_nxttmp:
		LoadGoalVar(m1ptr);
		LoadTempVar(m2ptr);
		MakeCopyUndef;
		*m1ptr = *m2ptr;
		TraceInstr("t_makeref")
		goto vam1p_unify;

	case UnifyMux(v1_fstvar_fsttmp0):				/* varoffset (short), no operand */
v_fstvar_fsttmp0:
		LoadGoalVar(m1ptr);
		MakeCopyUndef;
		temp0 = *m1ptr = MakeRef(copyptr);	      /* stackchange: no modification */
		TraceInstr("t_makeref")
		goto vam1p_unify;

	case UnifyMux(v1_fstvar_nxttmp0):				/* varoffset (short), no operand */
v_fstvar_nxttmp0:
		LoadGoalVar(m1ptr);
		MakeCopyUndef;
		*m1ptr = temp0;
		TraceInstr("t_makeref")
		goto vam1p_unify;

	case UnifyMux(v1_fsttmp_nxtvar):				/* varoffset (short), varoffset (short) */
v_fsttmp_nxtvar:
		LoadTempVar(m1ptr);
		LoadGoalVar(m2ptr);
		MakeCopyUndef;
		*m1ptr = *m2ptr;
		TraceInstr("t_makeref")
		goto vam1p_unify;

	case UnifyMux(v1_fsttmp0_nxtvar):				/* no operand, varoffset (short) */
v_fsttmp0_nxtvar:
		LoadGoalVar(m1ptr);
		MakeCopyUndef;
		temp0 = *m1ptr;
		TraceInstr("t_makeref")
		goto vam1p_unify;

	case UnifyMux(v1_nxtvar_nxtvar):				/* varoffset (short), varoffset (short) */
v_nxtvar_nxtvar:
		LoadGoalVar(m1ptr);
		LoadGoalVar(m2ptr);
		m2 = *m2ptr;
v_nxtvar_nxtvar_0:
		if (NotVal(m1 = *m1ptr))
			{
			Deref(m1, m1ptr);
			if (RefUndef(m1))
				{
				if (NotVal(m2))
					{
					Deref(m2, m2ptr);
					if (RefUndef(m2))
						if (Pointsto(m1ptr, m2ptr))
							{
							TraceInstr("t_makeref")
							AssignVam1pUnify(m1ptr, MakeRef(m2ptr))
							}
						else if (Pointsto(m2ptr, m1ptr))
							{
							TraceInstr("t_makeref")
							AssignVam1pUnify(m2ptr, MakeRef(m1ptr))
							}
						else
							goto vam1p_unify;
					}
				AssignVam1pUnify(m1ptr, m2)
				}
			}
		if (NotVal(m2))
			{
			Deref(m2, m2ptr);
			if (RefUndef(m2))
				AssignVam1pUnify(m2ptr, m1)
			}
		if (m1 == m2)
			goto vam1p_unify;
		if (ListOrStruct(m1) && struct_unify(m1, m2))
			goto vam1p_unify;
		FailInstr(v1_t_nxtvar_nxtvar)
		goto fail;

	case UnifyMux(v1_nxtvar_nxttmp):				/* varoffset (short), varoffset (short) */
v_nxtvar_nxttmp:
		LoadGoalVar(m1ptr);
		LoadTempVar(m2ptr);
		m2 = *m2ptr;
		goto v_nxtvar_nxtvar_0;

	case UnifyMux(v1_nxtvar_nxttmp0):				/* varoffset (short), no operand */
v_nxtvar_nxttmp0:
		LoadGoalVar(m1ptr);
		m2 = temp0;
		goto v_nxtvar_nxtvar_0;
		
	case UnifyMux(v1_goal):							/* not used */
v_goal:
		ArgReset
		TraceInstr("c_goal_c_lastcall")
		goalptr -= SopRead(goalptr);
		goto call_goal_2;
		
	case UnifyMux(v1_builtin):							/* not used */
v_builtin:
		ArgReset
		TraceInstr("c_bip_c_lastcall")
		bipnr = SopFetch(goalptr);
		i = builtin[bipnr].bt_arity;
		TraceInstr("bipnr + MaxTrace")
		m1ptr = a;
		while (--i >= 0)
			{
			switch(HeadMux(InstrFetch(goalptr)))
				{
				case HeadMux(h_const):				/* atom/int (long) */
					TraceInstr("t_b_const")
					LopFetch(m1, goalptr);
					*m1ptr++ = m1;
					break;
				case HeadMux(h_nil):				/*no operand */
					TraceInstr("t_b_nil")
					*m1ptr++ = MakeNil;
					break;
				case HeadMux(h_list):				/* 2 operands */
					TraceInstr("t_b_list")
					m2ptr = m1ptr++;
					Push(i);
					CreateList(m2ptr);
					i = -2;
					TraceAdd(t_bipallocsize, 2)
					goto builtin_goal_copy;
				case HeadMux(h_struct):				/* functor and n operands */
					TraceInstr("t_b_struct")
					m2ptr = m1ptr++;
					Push(i);
					FetchStruct(m2ptr, goalptr,
						    i = ArityFetch(goalptr));
					TraceAdd(t_bipallocsize, i + 1)
					i = -i;
					goto builtin_goal_copy;
				case HeadMux(h_void):				/* no operand */
					TraceInstr("t_b_void")
					MakeCopyUndef;
					*m1ptr++ = MakeRef(copyptr);	   /* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case HeadMux(h_fstvar):				/* varoffset (short) */
					TraceInstr("t_b_fstvar")
					LoadGoalVar(m2ptr);
					TraceInstr("t_bipcopyundef")
					MakeCopyUndef;
					*m2ptr = *m1ptr++ = MakeRef(copyptr);       /* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case HeadMux(h_nxtvar):				/* varoffset (short) */
					TraceInstr("t_b_nxtvar")
					LoadGoalVar(m2ptr);
					*m1ptr++ = *m2ptr;
					break;
				case HeadMux(h_fsttemp):				/* varoffset (short) */
					TraceInstr("t_b_fsttmp")
					LoadGoalTempVar(m2ptr);
					MakeCopyUndef;
					TraceInstr("t_bipcopyundef")
					*m2ptr = *m1ptr++ = MakeRef(copyptr);       /* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case HeadMux(h_nxttemp):				/* varoffset (short) */
					TraceInstr("t_b_nxttmp")
					LoadGoalTempVar(m2ptr);
					*m1ptr++ = *m2ptr;
					break;
				case HeadMux(h_fsttmp0):				/* no operand */
					TraceInstr("t_b_fsttmp")
					MakeCopyUndef;
					TraceInstr("t_bipcopyundef")
					temp0 = *m1ptr++ = MakeRef(copyptr);	/* stackchange: no modification */
					TraceInstr("t_makeref")
					break;
				case HeadMux(h_nxttmp0):				/* no operand */
					TraceInstr("t_b_nxttmp")
					*m1ptr++ = temp0;
					break;
				default:
					fprintf(stderr, "BuiltinArgCopyError\n");
					return(ErrorNumber = SystemError);
				}
call_builtin_goal: ;
			}
		if ((i = (*builtin[bipnr].bt_bipptr)(a)) != Success)
			if (i == Fail)
				{
				TraceInstr("t_bipfail")
				goto fail;
				}
			else
				goto bip_error_0;
		goto vam1p_unify;
		
	case UnifyMux(v1_metacall):
v_metacall:
		ArgReset
		TraceInstr("c_meta_c_lastcall")
		goalptr -= SopRead(goalptr);
		goto call_meta_2;
		
	case UnifyMux(v1_xgoal):		/* not used */
v_xgoal:
		ArgReset
		TraceInstr("c_xgoal_c_lastcall")
		goalptr -= SopRead(goalptr); 
		goto V1_xgoal_2;

	default:
		fprintf(stderr, "Vam1pUnifyError\n");
		return(ErrorNumber = SystemError);
	}


vam1p_copy:

switch(CopyMux(InstrFetch(goalptr)))
	{
	case CopyMux(v1_lastcall):						/* switch to VAM2P-Code */
		TraceSwitchVam12p
		TraceInstr("v1_t_unify_lastcall")
		headptr = (CODEPTR) LopRead(goalptr);		/* headprt = argument of V1_lastcall-command */	
		SDecr(goalptr);								/* reread V1_lastcall-command for VAM2P-code evaluation */
		goto interpret;
	case CopyMux(v1_unify_const):					/* unify list/struct-element, atom/int (long)*/
		TraceInstr("v1_t_unify_const")
		LopFetch(m1, goalptr);
		*m1ptr++ = m1;
		goto vam1p_copy;

	case CopyMux(v1_unify_nil):					/* unify list/struct-element, no operand*/
		TraceInstr("v1_t_unify_nil")
		*m1ptr++ = MakeNil;
		goto vam1p_copy;

	case CopyMux(v1_unify_list):					/* unify list/struct-element, 2 operands */
		Push(-((MW) m1ptr+1));
	case CopyMux(v1_unify_last_list):					/* unify list/struct-element, 2 operands */
		TraceInstr("v1_t_unify_list")
		CreateList(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_struct):					/* unify list/struct-element, functor and n operands */
		Push(-((MW) m1ptr+1));
	case CopyMux(v1_unify_last_struct):					/* unify list/struct-element, functor and n operands */
		TraceInstr("v1_t_unify_struct")
		FetchStruct(m1ptr, goalptr, ArityFetch(goalptr));
		goto vam1p_copy;

	case CopyMux(v1_unify_void):					/* unify list/struct-element, no operand*/
		TraceInstr("v1_t_unify_void")
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_fsttmp):					/* unify list/struct-element, varoffset (short)*/
		TraceInstr("v1_t_unify_fsttmp")
		LoadTempVar(m2ptr);
		*m2ptr = MakeRef(m1ptr);
		TraceInstr("t_makeref")
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_nxttmp):					/* unify list/struct-element, varoffset (short)*/
		TraceInstr("v1_t_unify_nxttmp")
		LoadTempVar(m2ptr);
		*m1ptr++ = *m2ptr;
		goto vam1p_copy;

	case CopyMux(v1_unify_fsttmp0):					/* unify list/struct-element, no operand*/
		TraceInstr("v1_t_unify_fsttmp")
		temp0 = MakeRef(m1ptr);
		TraceInstr("t_makeref")
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_nxttmp0):					/* unify list/struct-element, no operand*/
		TraceInstr("v1_t_unify_nxttmp")
		*m1ptr++ = temp0;
		goto vam1p_copy;

	case CopyMux(v1_unify_fstvar): 					/* unify list/struct-element, varoffset (short)*/
		TraceInstr("v1_t_unify_fstvar")
		LoadGoalVar(m2ptr);
		*m2ptr = MakeRef(m1ptr);
		TraceInstr("t_makeref")
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_nxtvar):					/* unify list/struct-element, varoffset (short)*/
		TraceInstr("v1_t_unify_nxtvar")
		LoadGoalVar(m2ptr);
		*m1ptr++ = *m2ptr;
		goto vam1p_copy;

	case CopyMux(v1_unify_0fstvar):					/* unify list/struct-element, no operand*/
		TraceInstr("v1_t_unify_fstvar")
		GoalVar(0) = MakeRef(m1ptr);
		TraceInstr("t_makeref")
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_0nxtvar):					/* unify list/struct-element, no operand*/
		TraceInstr("v1_t_unify_nxtvar")
		*m1ptr++ = GoalVar(0);
		goto vam1p_copy;

	case CopyMux(v1_unify_1fstvar):					/* unify list/struct-element, no operand*/
		TraceInstr("v1_t_unify_fstvar")
		GoalVar(1) = MakeRef(m1ptr);
		TraceInstr("t_makeref")
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_1nxtvar):					/* unify list/struct-element, no operand*/
		TraceInstr("v1_t_unify_nxtvar")
		*m1ptr++ = GoalVar(1);
		goto vam1p_copy;

	case CopyMux(v1_unify_2fstvar):					/* unify list/struct-element, no operand*/
		TraceInstr("v1_t_unify_fstvar")
		GoalVar(2) = MakeRef(m1ptr);
		TraceInstr("t_makeref")
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_2nxtvar):					/* unify list/struct-element, no operand*/
		TraceInstr("v1_t_unify_nxtvar")
		*m1ptr++ = GoalVar(2);
		goto vam1p_copy;

	case CopyMux(v1_unify_3fstvar):					/* unify list/struct-element, no operand*/
		TraceInstr("v1_t_unify_fstvar")
		GoalVar(3) = MakeRef(m1ptr);
		TraceInstr("t_makeref")
		*m1ptr++ = MakeUndef(m1ptr);
		goto vam1p_copy;

	case CopyMux(v1_unify_3nxtvar):					/* unify list/struct-element, no operand*/
		TraceInstr("v1_t_unify_nxtvar")
		*m1ptr++ = GoalVar(3);
		goto vam1p_copy;

	case CopyMux(v1_pop):							/* pop list/struct adress from stack */
		TraceInstr("v1_t_pop")
		Pop((MWPTR), m1ptr);
		if (((MW) m1ptr) > 0)
			goto vam1p_unify;
		m1ptr = (MWPTR)(-((MW) m1ptr));
		goto vam1p_copy;

	case CopyMux(v1_fstvar_const):		/* varoffset (short), atom/int (long) */
		goto v_fstvar_const;
	case CopyMux(v1_nxtvar_const):		/* varoffset (short), atom/int (long) */
		goto v_nxtvar_const;
	case CopyMux(v1_fsttmp_const):		/* varoffset (short), atom/int (long) */
		goto v_fsttmp_const;
	case CopyMux(v1_nxttmp_const):		/* varoffset (short), atom/int (long) */
		goto v_nxttmp_const;
	case CopyMux(v1_fsttmp0_const):		/* no operand, atom/int (long) */
		goto v_fsttmp0_const;
	case CopyMux(v1_nxttmp0_const):		/* no operand, atom/int (long) */
		goto v_nxttmp0_const;
	case CopyMux(v1_fstvar_nil):		/* varoffset (short), no operand */
		goto v_fstvar_nil;
	case CopyMux(v1_nxtvar_nil):		/* varoffset (short), no operand */
		goto v_nxtvar_nil;
	case CopyMux(v1_fsttmp_nil):		/* varoffset (short), no operand */
		goto v_fsttmp_nil;
	case CopyMux(v1_nxttmp_nil):		/* varoffset (short), no operand */
		goto v_nxttmp_nil;
	case CopyMux(v1_fsttmp0_nil):		/* no operand, no operand */
		goto v_fsttmp0_nil;
	case CopyMux(v1_nxttmp0_nil):		/* no operand, no operand */
		goto v_nxttmp0_nil;
	case CopyMux(v1_fstvar_list):		/* varoffset (short), 2 operands */
		goto v_fstvar_list;
	case CopyMux(v1_nxtvar_list):		/* varoffset (short), 2 operands */
		goto v_nxtvar_list;
	case CopyMux(v1_fsttmp_list):		/* varoffset (short), 2 operands */
		goto v_fsttmp_list;
	case CopyMux(v1_nxttmp_list):		/* varoffset (short), 2 operands */
		goto v_nxttmp_list;
	case CopyMux(v1_fsttmp0_list):		/* no operand, 2 operands */
		goto v_fsttmp0_list;
	case CopyMux(v1_nxttmp0_list):		/* no operand, 2 operands */
		goto v_nxttmp0_list;
	case CopyMux(v1_fstvar_struct):		/* varoffset (short), functor and n operands */
		goto v_fstvar_struct;
	case CopyMux(v1_nxtvar_struct):		/* varoffset (short), functor and n operands */
		goto v_nxtvar_struct;
	case CopyMux(v1_fsttmp_struct):		/* varoffset (short), functor and n operands */
		goto v_fsttmp_struct;
	case CopyMux(v1_nxttmp_struct):		/* varoffset (short), functor and n operands */
		goto v_nxttmp_struct;
	case CopyMux(v1_fsttmp0_struct):	/* no operand, functor and n operands */
		goto v_fsttmp0_struct;
	case CopyMux(v1_nxttmp0_struct):	/* no operand, functor and n operands */
		goto v_nxttmp0_struct;
	case CopyMux(v1_fstvar_void):		/* varoffset (short), no operand */
		goto v_fstvar_void;
	case CopyMux(v1_fsttmp_void):		/* varoffset (short), no operand */
		goto v_fsttmp_void;
	case CopyMux(v1_fsttmp0_void):		/* no operand, no operand */
		goto v_fsttmp0_void;
	case CopyMux(v1_fstvar_fstvar):		/* varoffset (short), varoffset (short) */
		goto v_fstvar_fstvar;
	case CopyMux(v1_fstvar_nxtvar):		/* varoffset (short), varoffset (short) */
		goto v_fstvar_nxtvar;
	case CopyMux(v1_fstvar_fsttmp):		/* varoffset (short), varoffset (short) */
		goto v_fstvar_fsttmp;
	case CopyMux(v1_fstvar_nxttmp):		/* varoffset (short), varoffset (short) */
		goto v_fstvar_nxttmp;
	case CopyMux(v1_fstvar_fsttmp0):		/* varoffset (short), no operand */
		goto v_fstvar_fsttmp0;
	case CopyMux(v1_fstvar_nxttmp0):		/* varoffset (short), no operand */
		goto v_fstvar_nxttmp0;
	case CopyMux(v1_fsttmp_nxtvar):		/* varoffset (short), varoffset (short) */
		goto v_fsttmp_nxtvar;
	case CopyMux(v1_fsttmp0_nxtvar):		/* varoffset (short), varoffset (short) */
		goto v_fsttmp0_nxtvar;
	case CopyMux(v1_nxtvar_nxtvar):		/* varoffset (short), varoffset (short) */
		goto v_nxtvar_nxtvar;
	case CopyMux(v1_nxtvar_nxttmp):		/* varoffset (short), varoffset (short) */
		goto v_nxtvar_nxttmp;
	case CopyMux(v1_nxtvar_nxttmp0):	/* varoffset (short), no operand */
		goto v_nxtvar_nxttmp0;
	case CopyMux(v1_goal):
		goto v_goal;
	case CopyMux(v1_builtin):
		goto v_builtin;
	case CopyMux(v1_metacall):
		goto v_metacall;
	case CopyMux(v1_xgoal):
		goto v_xgoal;

	default:
		fprintf(stderr, "Vam1pCopyError\n");
		return(ErrorNumber = SystemError);
	}
}



